/* warp.c generated by valac 0.56.18, the Vala compiler
 * generated from warp.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 *
 * Rewrite of the original by Sean MacIsaac, Ian Peters, Guillaume Béland
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2020 Arnaud Bonatti <arnaud.bonatti@gmail.com>
 * Copyright (C) 2022-24 Ben Corby <bcorby@new-ms.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 * grep -ne ' $' *.vala
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <string.h>

#define WARP_MANAGER_MAX_WARPS ((guint8) 200)
#define NIBBLES_GAME_EMPTYCHAR 'a'
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;
typedef struct _WarpManagerPrivate WarpManagerPrivate;

#define WARP_MANAGER_TYPE_WARP (warp_manager_warp_get_type ())
#define WARP_MANAGER_WARP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), WARP_MANAGER_TYPE_WARP, WarpManagerWarp))
#define WARP_MANAGER_WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), WARP_MANAGER_TYPE_WARP, WarpManagerWarpClass))
#define WARP_MANAGER_IS_WARP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), WARP_MANAGER_TYPE_WARP))
#define WARP_MANAGER_IS_WARP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), WARP_MANAGER_TYPE_WARP))
#define WARP_MANAGER_WARP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), WARP_MANAGER_TYPE_WARP, WarpManagerWarpClass))

typedef struct _WarpManagerWarp WarpManagerWarp;
typedef struct _WarpManagerWarpClass WarpManagerWarpClass;
enum  {
	WARP_MANAGER_0_PROPERTY,
	WARP_MANAGER_NUM_PROPERTIES
};
static GParamSpec* warp_manager_properties[WARP_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;
typedef struct _WarpManagerWarpPrivate WarpManagerWarpPrivate;
enum  {
	WARP_MANAGER_WARP_0_PROPERTY,
	WARP_MANAGER_WARP_MANAGER_PROPERTY,
	WARP_MANAGER_WARP_ID_PROPERTY,
	WARP_MANAGER_WARP_SOURCE_X_PROPERTY,
	WARP_MANAGER_WARP_SOURCE_Y_PROPERTY,
	WARP_MANAGER_WARP_TARGET_X_PROPERTY,
	WARP_MANAGER_WARP_TARGET_Y_PROPERTY,
	WARP_MANAGER_WARP_RANDOM_PROPERTY,
	WARP_MANAGER_WARP_BIDI_PROPERTY,
	WARP_MANAGER_WARP_NUM_PROPERTIES
};
static GParamSpec* warp_manager_warp_properties[WARP_MANAGER_WARP_NUM_PROPERTIES];

#define TYPE_WORM_MAP (worm_map_get_type ())
#define WORM_MAP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_MAP, WormMap))
#define WORM_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_MAP, WormMapClass))
#define IS_WORM_MAP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_MAP))
#define IS_WORM_MAP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_MAP))
#define WORM_MAP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_MAP, WormMapClass))

typedef struct _WormMap WormMap;
typedef struct _WormMapClass WormMapClass;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _WarpManager {
	GObject parent_instance;
	WarpManagerPrivate * priv;
	guint16* all_empty_board_positions;
	gint all_empty_board_positions_length1;
	gint _all_empty_board_positions_size_;
	gint* board;
	gint board_length1;
	gint board_length2;
	guint8 board_max_x;
	guint8 board_max_y;
};

struct _WarpManagerClass {
	GObjectClass parent_class;
};

struct _WarpManagerPrivate {
	GeeLinkedList* warps;
};

struct _Position {
	guint8 x;
	guint8 y;
};

struct _WarpManagerWarp {
	GObject parent_instance;
	WarpManagerWarpPrivate * priv;
};

struct _WarpManagerWarpClass {
	GObjectClass parent_class;
};

struct _WarpManagerWarpPrivate {
	gboolean init_finished;
	WarpManager* _manager;
	gint _id;
	guint8 _source_x;
	guint8 _source_y;
	guint8 _target_x;
	guint8 _target_y;
	gboolean _random;
	gboolean _bidi;
};

static gint WarpManager_private_offset;
static gpointer warp_manager_parent_class = NULL;
static gint WarpManagerWarp_private_offset;
static gpointer warp_manager_warp_parent_class = NULL;

VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
static GType warp_manager_warp_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManagerWarp, g_object_unref)
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y,
                                   gboolean random);
static gint warp_manager_warp_get_id (WarpManagerWarp* self);
static void warp_manager_warp_set_source (WarpManagerWarp* self,
                                   guint8 x,
                                   guint8 y);
static gboolean warp_manager_warp_get_bidi (WarpManagerWarp* self);
static WarpManagerWarp* warp_manager_warp_new_from_source (WarpManager* manager,
                                                    gint id,
                                                    guint8 source_x,
                                                    guint8 source_y,
                                                    gboolean random);
static WarpManagerWarp* warp_manager_warp_construct_from_source (GType object_type,
                                                          WarpManager* manager,
                                                          gint id,
                                                          guint8 source_x,
                                                          guint8 source_y,
                                                          gboolean random);
static guint8 warp_manager_warp_get_source_x (WarpManagerWarp* self);
static guint8 warp_manager_warp_get_source_y (WarpManagerWarp* self);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
static void warp_manager_warp_set_target (WarpManagerWarp* self,
                                   guint8 x,
                                   guint8 y);
static WarpManagerWarp* warp_manager_warp_new_from_target (WarpManager* manager,
                                                    gint id,
                                                    guint8 target_x,
                                                    guint8 target_y);
static WarpManagerWarp* warp_manager_warp_construct_from_target (GType object_type,
                                                          WarpManager* manager,
                                                          gint id,
                                                          guint8 target_x,
                                                          guint8 target_y);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       WormDirection worm_direction,
                                       gint worm_length,
                                       gboolean ai_worm,
                                       GeeLinkedList* worms,
                                       guint8* target_x,
                                       guint8* target_y,
                                       gboolean* bonus);
static gboolean warp_manager_warp_get_target (WarpManagerWarp* self,
                                       guint8 x,
                                       guint8 y,
                                       WormDirection direction,
                                       gint length,
                                       gboolean ai_worm,
                                       GeeLinkedList* worms,
                                       guint8* target_x,
                                       guint8* target_y,
                                       gboolean* bonus);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN void warp_manager_initilise (WarpManager* self,
                             gint* board,
                             gint board_length1,
                             gint board_length2);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
static void _vala_array_add7 (guint16* * array,
                       gint* length,
                       gint* size,
                       guint16 value);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
static void warp_manager_warp_set_target_x (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_target_y (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_source_x (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_source_y (WarpManagerWarp* self,
                                     guint8 value);
static void warp_manager_warp_set_bidi (WarpManagerWarp* self,
                                 gboolean value);
static gboolean warp_manager_warp_get_random (WarpManagerWarp* self);
VALA_EXTERN GType worm_map_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormMap, g_object_unref)
static WarpManager* warp_manager_warp_get_manager (WarpManagerWarp* self);
VALA_EXTERN WormMap* worm_map_new (GeeList* worms,
                       guint8 map_width,
                       guint8 map_height);
VALA_EXTERN WormMap* worm_map_construct (GType object_type,
                             GeeList* worms,
                             guint8 map_width,
                             guint8 map_height);
static guint16* _vala_array_dup1 (guint16* self,
                           gssize length);
VALA_EXTERN void position_move (Position *self,
                    WormDirection direction,
                    guint8 width,
                    guint8 height);
VALA_EXTERN gboolean worm_map_contain_position (WormMap* self,
                                    Position* p);
VALA_EXTERN gint worm_ai_deadend_after (gint* board,
                            gint board_length1,
                            gint board_length2,
                            GeeLinkedList* worms,
                            WormMap* worm_map,
                            Position* old_position,
                            WormDirection direction,
                            gint length);
static guint8 warp_manager_warp_get_target_x (WarpManagerWarp* self);
static guint8 warp_manager_warp_get_target_y (WarpManagerWarp* self);
static WarpManagerWarp* warp_manager_warp_new (void);
static WarpManagerWarp* warp_manager_warp_construct (GType object_type);
static void warp_manager_warp_set_manager (WarpManagerWarp* self,
                                    WarpManager* value);
static void warp_manager_warp_set_id (WarpManagerWarp* self,
                               gint value);
static void warp_manager_warp_set_random (WarpManagerWarp* self,
                                   gboolean value);
static void warp_manager_warp_finalize (GObject * obj);
static GType warp_manager_warp_get_type_once (void);
static void _vala_warp_manager_warp_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_warp_manager_warp_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static void warp_manager_finalize (GObject * obj);
static GType warp_manager_get_type_once (void);
static void _vala_array_move (gpointer array,
                       gsize element_size,
                       gssize src,
                       gssize dest,
                       gssize length);

static inline gpointer
warp_manager_get_instance_private (WarpManager* self)
{
	return G_STRUCT_MEMBER_P (self, WarpManager_private_offset);
}

void
warp_manager_add_warp_source (WarpManager* self,
                              gint id,
                              guint8 x,
                              guint8 y,
                              gboolean random)
{
	GeeLinkedList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	GeeLinkedList* _tmp28_;
	WarpManagerWarp* _tmp29_;
	WarpManagerWarp* _tmp30_;
#line 232 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 365 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _warp_index = 0;
#line 234 "../src/warp.vala"
		_tmp0_ = self->priv->warps;
#line 234 "../src/warp.vala"
		_warp_list = _tmp0_;
#line 234 "../src/warp.vala"
		_tmp1_ = _warp_list;
#line 234 "../src/warp.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 234 "../src/warp.vala"
		_tmp3_ = _tmp2_;
#line 234 "../src/warp.vala"
		_warp_size = _tmp3_;
#line 234 "../src/warp.vala"
		_warp_index = -1;
#line 234 "../src/warp.vala"
		while (TRUE) {
#line 390 "warp.c"
			gint _tmp4_;
			gint _tmp5_;
			WarpManagerWarp* warp = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			WarpManagerWarp* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			WarpManagerWarp* _tmp11_;
			WarpManagerWarp* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 234 "../src/warp.vala"
			_warp_index = _warp_index + 1;
#line 234 "../src/warp.vala"
			_tmp4_ = _warp_index;
#line 234 "../src/warp.vala"
			_tmp5_ = _warp_size;
#line 234 "../src/warp.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 234 "../src/warp.vala"
				break;
#line 413 "warp.c"
			}
#line 234 "../src/warp.vala"
			_tmp6_ = _warp_list;
#line 234 "../src/warp.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _warp_index);
#line 234 "../src/warp.vala"
			warp = (WarpManagerWarp*) _tmp7_;
#line 236 "../src/warp.vala"
			_tmp8_ = warp;
#line 236 "../src/warp.vala"
			_tmp9_ = warp_manager_warp_get_id (_tmp8_);
#line 236 "../src/warp.vala"
			_tmp10_ = _tmp9_;
#line 236 "../src/warp.vala"
			if (_tmp10_ != id) {
#line 237 "../src/warp.vala"
				_g_object_unref0 (warp);
#line 237 "../src/warp.vala"
				continue;
#line 433 "warp.c"
			}
#line 239 "../src/warp.vala"
			_tmp11_ = warp;
#line 239 "../src/warp.vala"
			warp_manager_warp_set_source (_tmp11_, x, y);
#line 240 "../src/warp.vala"
			_tmp12_ = warp;
#line 240 "../src/warp.vala"
			_tmp13_ = warp_manager_warp_get_bidi (_tmp12_);
#line 240 "../src/warp.vala"
			_tmp14_ = _tmp13_;
#line 240 "../src/warp.vala"
			if (_tmp14_) {
#line 447 "warp.c"
				WarpManagerWarp* bidi_warp = NULL;
				WarpManagerWarp* _tmp15_;
				WarpManagerWarp* _tmp16_;
				WarpManagerWarp* _tmp17_;
				guint8 _tmp18_;
				guint8 _tmp19_;
				WarpManagerWarp* _tmp20_;
				guint8 _tmp21_;
				guint8 _tmp22_;
				GeeLinkedList* _tmp23_;
				WarpManagerWarp* _tmp24_;
#line 242 "../src/warp.vala"
				_tmp15_ = warp_manager_warp_new_from_source (self, id, x, y, FALSE);
#line 242 "../src/warp.vala"
				bidi_warp = _tmp15_;
#line 243 "../src/warp.vala"
				_tmp16_ = bidi_warp;
#line 243 "../src/warp.vala"
				_tmp17_ = warp;
#line 243 "../src/warp.vala"
				_tmp18_ = warp_manager_warp_get_source_x (_tmp17_);
#line 243 "../src/warp.vala"
				_tmp19_ = _tmp18_;
#line 243 "../src/warp.vala"
				_tmp20_ = warp;
#line 243 "../src/warp.vala"
				_tmp21_ = warp_manager_warp_get_source_y (_tmp20_);
#line 243 "../src/warp.vala"
				_tmp22_ = _tmp21_;
#line 243 "../src/warp.vala"
				warp_manager_warp_set_source (_tmp16_, _tmp19_, _tmp22_);
#line 244 "../src/warp.vala"
				_tmp23_ = self->priv->warps;
#line 244 "../src/warp.vala"
				_tmp24_ = bidi_warp;
#line 244 "../src/warp.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp23_, _tmp24_);
#line 240 "../src/warp.vala"
				_g_object_unref0 (bidi_warp);
#line 487 "warp.c"
			}
#line 246 "../src/warp.vala"
			_g_object_unref0 (warp);
#line 246 "../src/warp.vala"
			return;
#line 493 "warp.c"
		}
	}
#line 249 "../src/warp.vala"
	_tmp25_ = self->priv->warps;
#line 249 "../src/warp.vala"
	_tmp26_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp25_);
#line 249 "../src/warp.vala"
	_tmp27_ = _tmp26_;
#line 249 "../src/warp.vala"
	if (_tmp27_ >= ((gint) WARP_MANAGER_MAX_WARPS)) {
#line 250 "../src/warp.vala"
		return;
#line 506 "warp.c"
	}
#line 252 "../src/warp.vala"
	_tmp28_ = self->priv->warps;
#line 252 "../src/warp.vala"
	_tmp29_ = warp_manager_warp_new_from_source (self, id, x, y, random);
#line 252 "../src/warp.vala"
	_tmp30_ = _tmp29_;
#line 252 "../src/warp.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp28_, _tmp30_);
#line 252 "../src/warp.vala"
	_g_object_unref0 (_tmp30_);
#line 518 "warp.c"
}

void
warp_manager_add_warp_target (WarpManager* self,
                              gint id,
                              guint8 x,
                              guint8 y)
{
	GeeLinkedList* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	GeeLinkedList* _tmp15_;
	WarpManagerWarp* _tmp16_;
	WarpManagerWarp* _tmp17_;
#line 255 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 535 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _warp_index = 0;
#line 257 "../src/warp.vala"
		_tmp0_ = self->priv->warps;
#line 257 "../src/warp.vala"
		_warp_list = _tmp0_;
#line 257 "../src/warp.vala"
		_tmp1_ = _warp_list;
#line 257 "../src/warp.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 257 "../src/warp.vala"
		_tmp3_ = _tmp2_;
#line 257 "../src/warp.vala"
		_warp_size = _tmp3_;
#line 257 "../src/warp.vala"
		_warp_index = -1;
#line 257 "../src/warp.vala"
		while (TRUE) {
#line 560 "warp.c"
			gint _tmp4_;
			gint _tmp5_;
			WarpManagerWarp* warp = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			WarpManagerWarp* _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			WarpManagerWarp* _tmp11_;
#line 257 "../src/warp.vala"
			_warp_index = _warp_index + 1;
#line 257 "../src/warp.vala"
			_tmp4_ = _warp_index;
#line 257 "../src/warp.vala"
			_tmp5_ = _warp_size;
#line 257 "../src/warp.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 257 "../src/warp.vala"
				break;
#line 580 "warp.c"
			}
#line 257 "../src/warp.vala"
			_tmp6_ = _warp_list;
#line 257 "../src/warp.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _warp_index);
#line 257 "../src/warp.vala"
			warp = (WarpManagerWarp*) _tmp7_;
#line 259 "../src/warp.vala"
			_tmp8_ = warp;
#line 259 "../src/warp.vala"
			_tmp9_ = warp_manager_warp_get_id (_tmp8_);
#line 259 "../src/warp.vala"
			_tmp10_ = _tmp9_;
#line 259 "../src/warp.vala"
			if (_tmp10_ != id) {
#line 260 "../src/warp.vala"
				_g_object_unref0 (warp);
#line 260 "../src/warp.vala"
				continue;
#line 600 "warp.c"
			}
#line 262 "../src/warp.vala"
			_tmp11_ = warp;
#line 262 "../src/warp.vala"
			warp_manager_warp_set_target (_tmp11_, x, y);
#line 263 "../src/warp.vala"
			_g_object_unref0 (warp);
#line 263 "../src/warp.vala"
			return;
#line 610 "warp.c"
		}
	}
#line 266 "../src/warp.vala"
	_tmp12_ = self->priv->warps;
#line 266 "../src/warp.vala"
	_tmp13_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp12_);
#line 266 "../src/warp.vala"
	_tmp14_ = _tmp13_;
#line 266 "../src/warp.vala"
	if (_tmp14_ >= ((gint) WARP_MANAGER_MAX_WARPS)) {
#line 267 "../src/warp.vala"
		return;
#line 623 "warp.c"
	}
#line 269 "../src/warp.vala"
	_tmp15_ = self->priv->warps;
#line 269 "../src/warp.vala"
	_tmp16_ = warp_manager_warp_new_from_target (self, id, x, y);
#line 269 "../src/warp.vala"
	_tmp17_ = _tmp16_;
#line 269 "../src/warp.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp17_);
#line 269 "../src/warp.vala"
	_g_object_unref0 (_tmp17_);
#line 635 "warp.c"
}

gboolean
warp_manager_get_warp_target (WarpManager* self,
                              guint8 x,
                              guint8 y,
                              WormDirection worm_direction,
                              gint worm_length,
                              gboolean ai_worm,
                              GeeLinkedList* worms,
                              guint8* target_x,
                              guint8* target_y,
                              gboolean* bonus)
{
	guint8 _vala_target_x = 0U;
	guint8 _vala_target_y = 0U;
	gboolean _vala_bonus = FALSE;
	gboolean result;
#line 272 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 272 "../src/warp.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 274 "../src/warp.vala"
	_vala_target_x = (guint8) 0;
#line 275 "../src/warp.vala"
	_vala_target_y = (guint8) 0;
#line 277 "../src/warp.vala"
	_vala_bonus = FALSE;
#line 664 "warp.c"
	{
		GeeLinkedList* _warp_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _warp_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _warp_index = 0;
#line 278 "../src/warp.vala"
		_tmp0_ = self->priv->warps;
#line 278 "../src/warp.vala"
		_warp_list = _tmp0_;
#line 278 "../src/warp.vala"
		_tmp1_ = _warp_list;
#line 278 "../src/warp.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 278 "../src/warp.vala"
		_tmp3_ = _tmp2_;
#line 278 "../src/warp.vala"
		_warp_size = _tmp3_;
#line 278 "../src/warp.vala"
		_warp_index = -1;
#line 278 "../src/warp.vala"
		while (TRUE) {
#line 689 "warp.c"
			gint _tmp4_;
			gint _tmp5_;
			WarpManagerWarp* warp = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			WarpManagerWarp* _tmp8_;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_;
#line 278 "../src/warp.vala"
			_warp_index = _warp_index + 1;
#line 278 "../src/warp.vala"
			_tmp4_ = _warp_index;
#line 278 "../src/warp.vala"
			_tmp5_ = _warp_size;
#line 278 "../src/warp.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 278 "../src/warp.vala"
				break;
#line 708 "warp.c"
			}
#line 278 "../src/warp.vala"
			_tmp6_ = _warp_list;
#line 278 "../src/warp.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _warp_index);
#line 278 "../src/warp.vala"
			warp = (WarpManagerWarp*) _tmp7_;
#line 279 "../src/warp.vala"
			_tmp8_ = warp;
#line 279 "../src/warp.vala"
			_tmp10_ = warp_manager_warp_get_target (_tmp8_, x, y, worm_direction, worm_length, ai_worm, worms, &_vala_target_x, &_vala_target_y, &_tmp9_);
#line 279 "../src/warp.vala"
			_vala_bonus = _tmp9_;
#line 279 "../src/warp.vala"
			if (_tmp10_) {
#line 280 "../src/warp.vala"
				result = TRUE;
#line 280 "../src/warp.vala"
				_g_object_unref0 (warp);
#line 280 "../src/warp.vala"
				if (target_x) {
#line 280 "../src/warp.vala"
					*target_x = _vala_target_x;
#line 732 "warp.c"
				}
#line 280 "../src/warp.vala"
				if (target_y) {
#line 280 "../src/warp.vala"
					*target_y = _vala_target_y;
#line 738 "warp.c"
				}
#line 280 "../src/warp.vala"
				if (bonus) {
#line 280 "../src/warp.vala"
					*bonus = _vala_bonus;
#line 744 "warp.c"
				}
#line 280 "../src/warp.vala"
				return result;
#line 748 "warp.c"
			}
#line 278 "../src/warp.vala"
			_g_object_unref0 (warp);
#line 752 "warp.c"
		}
	}
#line 282 "../src/warp.vala"
	result = FALSE;
#line 282 "../src/warp.vala"
	if (target_x) {
#line 282 "../src/warp.vala"
		*target_x = _vala_target_x;
#line 761 "warp.c"
	}
#line 282 "../src/warp.vala"
	if (target_y) {
#line 282 "../src/warp.vala"
		*target_y = _vala_target_y;
#line 767 "warp.c"
	}
#line 282 "../src/warp.vala"
	if (bonus) {
#line 282 "../src/warp.vala"
		*bonus = _vala_bonus;
#line 773 "warp.c"
	}
#line 282 "../src/warp.vala"
	return result;
#line 777 "warp.c"
}

void
warp_manager_clear_warps (WarpManager* self)
{
	GeeLinkedList* _tmp0_;
	guint16* _tmp1_;
#line 285 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/warp.vala"
	_tmp0_ = self->priv->warps;
#line 287 "../src/warp.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 288 "../src/warp.vala"
	_tmp1_ = g_new0 (guint16, 0);
#line 288 "../src/warp.vala"
	self->all_empty_board_positions = (g_free (self->all_empty_board_positions), NULL);
#line 288 "../src/warp.vala"
	self->all_empty_board_positions = _tmp1_;
#line 288 "../src/warp.vala"
	self->all_empty_board_positions_length1 = 0;
#line 288 "../src/warp.vala"
	self->_all_empty_board_positions_size_ = self->all_empty_board_positions_length1;
#line 801 "warp.c"
}

static void
_vala_array_add7 (guint16* * array,
                  gint* length,
                  gint* size,
                  guint16 value)
{
#line 302 "../src/warp.vala"
	if ((*length) == (*size)) {
#line 302 "../src/warp.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 302 "../src/warp.vala"
		*array = g_renew (guint16, *array, *size);
#line 816 "warp.c"
	}
#line 302 "../src/warp.vala"
	(*array)[(*length)++] = value;
#line 820 "warp.c"
}

void
warp_manager_initilise (WarpManager* self,
                        gint* board,
                        gint board_length1,
                        gint board_length2)
{
	gint _tmp0_;
	gint _tmp1_;
	Position p = {0};
	Position _tmp2_ = {0};
#line 291 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 293 "../src/warp.vala"
	self->board = board;
#line 293 "../src/warp.vala"
	self->board_length1 = board_length1;
#line 293 "../src/warp.vala"
	self->board_length2 = board_length2;
#line 294 "../src/warp.vala"
	_tmp0_ = board_length1;
#line 294 "../src/warp.vala"
	self->board_max_x = (guint8) _tmp0_;
#line 295 "../src/warp.vala"
	_tmp1_ = board_length2;
#line 295 "../src/warp.vala"
	self->board_max_y = (guint8) _tmp1_;
#line 296 "../src/warp.vala"
	_tmp2_.x = (guint8) 0;
#line 296 "../src/warp.vala"
	_tmp2_.y = (guint8) 0;
#line 296 "../src/warp.vala"
	p = _tmp2_;
#line 855 "warp.c"
	{
		gboolean _tmp3_ = FALSE;
#line 297 "../src/warp.vala"
		_tmp3_ = TRUE;
#line 297 "../src/warp.vala"
		while (TRUE) {
#line 862 "warp.c"
			Position _tmp5_;
#line 297 "../src/warp.vala"
			if (!_tmp3_) {
#line 866 "warp.c"
				guint8 _tmp4_;
#line 297 "../src/warp.vala"
				_tmp4_ = p.y;
#line 297 "../src/warp.vala"
				p.y = _tmp4_ + 1;
#line 872 "warp.c"
			}
#line 297 "../src/warp.vala"
			_tmp3_ = FALSE;
#line 297 "../src/warp.vala"
			_tmp5_ = p;
#line 297 "../src/warp.vala"
			if (!(_tmp5_.y < self->board_max_y)) {
#line 297 "../src/warp.vala"
				break;
#line 882 "warp.c"
			}
			{
				gboolean _tmp6_ = FALSE;
#line 299 "../src/warp.vala"
				p.x = (guint8) 0;
#line 299 "../src/warp.vala"
				_tmp6_ = TRUE;
#line 299 "../src/warp.vala"
				while (TRUE) {
#line 892 "warp.c"
					Position _tmp8_;
					Position _tmp9_;
					Position _tmp10_;
					gint _tmp11_;
#line 299 "../src/warp.vala"
					if (!_tmp6_) {
#line 899 "warp.c"
						guint8 _tmp7_;
#line 299 "../src/warp.vala"
						_tmp7_ = p.x;
#line 299 "../src/warp.vala"
						p.x = _tmp7_ + 1;
#line 905 "warp.c"
					}
#line 299 "../src/warp.vala"
					_tmp6_ = FALSE;
#line 299 "../src/warp.vala"
					_tmp8_ = p;
#line 299 "../src/warp.vala"
					if (!(_tmp8_.x < self->board_max_x)) {
#line 299 "../src/warp.vala"
						break;
#line 915 "warp.c"
					}
#line 301 "../src/warp.vala"
					_tmp9_ = p;
#line 301 "../src/warp.vala"
					_tmp10_ = p;
#line 301 "../src/warp.vala"
					_tmp11_ = board[(_tmp9_.x * board_length2) + _tmp10_.y];
#line 301 "../src/warp.vala"
					if (_tmp11_ == ((gint) NIBBLES_GAME_EMPTYCHAR)) {
#line 925 "warp.c"
						Position _tmp12_;
						Position _tmp13_;
#line 302 "../src/warp.vala"
						_tmp12_ = p;
#line 302 "../src/warp.vala"
						_tmp13_ = p;
#line 302 "../src/warp.vala"
						_vala_array_add7 (&self->all_empty_board_positions, &self->all_empty_board_positions_length1, &self->_all_empty_board_positions_size_, (guint16) ((((guint16) _tmp12_.x) << 8) | _tmp13_.y));
#line 934 "warp.c"
					}
				}
			}
		}
	}
}

WarpManager*
warp_manager_construct (GType object_type)
{
	WarpManager * self = NULL;
#line 38 "../src/warp.vala"
	self = (WarpManager*) g_object_new (object_type, NULL);
#line 38 "../src/warp.vala"
	return self;
#line 950 "warp.c"
}

WarpManager*
warp_manager_new (void)
{
#line 38 "../src/warp.vala"
	return warp_manager_construct (TYPE_WARP_MANAGER);
#line 958 "warp.c"
}

static inline gpointer
warp_manager_warp_get_instance_private (WarpManagerWarp* self)
{
	return G_STRUCT_MEMBER_P (self, WarpManagerWarp_private_offset);
}

static WarpManagerWarp*
warp_manager_warp_construct_from_source (GType object_type,
                                         WarpManager* manager,
                                         gint id,
                                         guint8 source_x,
                                         guint8 source_y,
                                         gboolean random)
{
	WarpManagerWarp * self = NULL;
#line 67 "../src/warp.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 69 "../src/warp.vala"
	self = (WarpManagerWarp*) g_object_new (object_type, "manager", manager, "id", id, "source-x", source_x, "source-y", source_y, "random", random, "bidi", TRUE, NULL);
#line 67 "../src/warp.vala"
	return self;
#line 982 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_new_from_source (WarpManager* manager,
                                   gint id,
                                   guint8 source_x,
                                   guint8 source_y,
                                   gboolean random)
{
#line 67 "../src/warp.vala"
	return warp_manager_warp_construct_from_source (WARP_MANAGER_TYPE_WARP, manager, id, source_x, source_y, random);
#line 994 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_construct_from_target (GType object_type,
                                         WarpManager* manager,
                                         gint id,
                                         guint8 target_x,
                                         guint8 target_y)
{
	WarpManagerWarp * self = NULL;
#line 77 "../src/warp.vala"
	g_return_val_if_fail (manager != NULL, NULL);
#line 79 "../src/warp.vala"
	self = (WarpManagerWarp*) g_object_new (object_type, "manager", manager, "id", id, "target-x", target_x, "target-y", target_y, "bidi", FALSE, NULL);
#line 77 "../src/warp.vala"
	return self;
#line 1011 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_new_from_target (WarpManager* manager,
                                   gint id,
                                   guint8 target_x,
                                   guint8 target_y)
{
#line 77 "../src/warp.vala"
	return warp_manager_warp_construct_from_target (WARP_MANAGER_TYPE_WARP, manager, id, target_x, target_y);
#line 1022 "warp.c"
}

static void
warp_manager_warp_set_source (WarpManagerWarp* self,
                              guint8 x,
                              guint8 y)
{
	gboolean _tmp0_;
#line 86 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/warp.vala"
	_vala_return_if_fail (self->priv->init_finished == FALSE, "init_finished == false");
#line 89 "../src/warp.vala"
	_tmp0_ = self->priv->_bidi;
#line 89 "../src/warp.vala"
	if (_tmp0_) {
#line 91 "../src/warp.vala"
		warp_manager_warp_set_target_x (self, x);
#line 92 "../src/warp.vala"
		warp_manager_warp_set_target_y (self, y);
#line 1043 "warp.c"
	} else {
#line 96 "../src/warp.vala"
		warp_manager_warp_set_source_x (self, x);
#line 97 "../src/warp.vala"
		warp_manager_warp_set_source_y (self, y);
#line 1049 "warp.c"
	}
#line 99 "../src/warp.vala"
	self->priv->init_finished = TRUE;
#line 1053 "warp.c"
}

static void
warp_manager_warp_set_target (WarpManagerWarp* self,
                              guint8 x,
                              guint8 y)
{
	gboolean _tmp0_;
#line 102 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/warp.vala"
	_vala_return_if_fail (self->priv->init_finished == FALSE, "init_finished == false");
#line 102 "../src/warp.vala"
	_tmp0_ = self->priv->_bidi;
#line 102 "../src/warp.vala"
	_vala_return_if_fail (_tmp0_ == TRUE, "bidi == true");
#line 106 "../src/warp.vala"
	warp_manager_warp_set_target_x (self, x);
#line 107 "../src/warp.vala"
	warp_manager_warp_set_target_y (self, y);
#line 108 "../src/warp.vala"
	warp_manager_warp_set_bidi (self, FALSE);
#line 109 "../src/warp.vala"
	self->priv->init_finished = TRUE;
#line 1078 "warp.c"
}

static guint16*
_vala_array_dup1 (guint16* self,
                  gssize length)
{
#line 125 "../src/warp.vala"
	if (length > 0) {
#line 125 "../src/warp.vala"
		return g_memdup2 (self, length * sizeof (guint16));
#line 1089 "warp.c"
	}
#line 125 "../src/warp.vala"
	return NULL;
#line 1093 "warp.c"
}

static gboolean
warp_manager_warp_get_target (WarpManagerWarp* self,
                              guint8 x,
                              guint8 y,
                              WormDirection direction,
                              gint length,
                              gboolean ai_worm,
                              GeeLinkedList* worms,
                              guint8* target_x,
                              guint8* target_y,
                              gboolean* bonus)
{
	gboolean _vala_bonus = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint8 _tmp2_;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 112 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 112 "../src/warp.vala"
	g_return_val_if_fail (worms != NULL, FALSE);
#line 112 "../src/warp.vala"
	_vala_return_val_if_fail (self->priv->init_finished == TRUE, "init_finished == true", FALSE);
#line 116 "../src/warp.vala"
	_vala_bonus = FALSE;
#line 118 "../src/warp.vala"
	_tmp2_ = self->priv->_source_x;
#line 118 "../src/warp.vala"
	if (x != _tmp2_) {
#line 1127 "warp.c"
		guint8 _tmp3_;
#line 118 "../src/warp.vala"
		_tmp3_ = self->priv->_source_x;
#line 118 "../src/warp.vala"
		_tmp1_ = ((gint) x) != (_tmp3_ + 1);
#line 1133 "warp.c"
	} else {
#line 118 "../src/warp.vala"
		_tmp1_ = FALSE;
#line 1137 "warp.c"
	}
#line 118 "../src/warp.vala"
	if (_tmp1_) {
#line 118 "../src/warp.vala"
		_tmp0_ = TRUE;
#line 1143 "warp.c"
	} else {
		gboolean _tmp4_ = FALSE;
		guint8 _tmp5_;
#line 119 "../src/warp.vala"
		_tmp5_ = self->priv->_source_y;
#line 119 "../src/warp.vala"
		if (y != _tmp5_) {
#line 1151 "warp.c"
			guint8 _tmp6_;
#line 119 "../src/warp.vala"
			_tmp6_ = self->priv->_source_y;
#line 119 "../src/warp.vala"
			_tmp4_ = ((gint) y) != (_tmp6_ + 1);
#line 1157 "warp.c"
		} else {
#line 119 "../src/warp.vala"
			_tmp4_ = FALSE;
#line 1161 "warp.c"
		}
#line 119 "../src/warp.vala"
		_tmp0_ = _tmp4_;
#line 1165 "warp.c"
	}
#line 118 "../src/warp.vala"
	if (_tmp0_) {
#line 120 "../src/warp.vala"
		result = FALSE;
#line 120 "../src/warp.vala"
		if (bonus) {
#line 120 "../src/warp.vala"
			*bonus = _vala_bonus;
#line 1175 "warp.c"
		}
#line 120 "../src/warp.vala"
		return result;
#line 1179 "warp.c"
	}
#line 122 "../src/warp.vala"
	_tmp7_ = warp_manager_warp_get_random (self);
#line 122 "../src/warp.vala"
	_tmp8_ = _tmp7_;
#line 122 "../src/warp.vala"
	if (_tmp8_) {
#line 1187 "warp.c"
		WormMap* worm_map = NULL;
		WarpManager* _tmp9_;
		WarpManager* _tmp10_;
		WormMap* _tmp11_;
		guint16* P = NULL;
		WarpManager* _tmp12_;
		guint16* _tmp13_;
		gint _tmp13__length1;
		guint16* _tmp14_;
		gint _tmp14__length1;
		gint P_length1;
		gint _P_size_;
		Position p = {0};
		Position _tmp15_ = {0};
		gint lowest_deadend = 0;
		guint16 lowest_deadend_position = 0U;
		gint i = 0;
		gint count = 0;
		gint clear_count = 0;
		gint _tmp16_ = 0;
		gint array_length = 0;
		guint16* _tmp17_;
		gint _tmp17__length1;
#line 124 "../src/warp.vala"
		_tmp9_ = self->priv->_manager;
#line 124 "../src/warp.vala"
		_tmp10_ = self->priv->_manager;
#line 124 "../src/warp.vala"
		_tmp11_ = worm_map_new ((GeeList*) worms, _tmp9_->board_max_x, _tmp10_->board_max_y);
#line 124 "../src/warp.vala"
		worm_map = _tmp11_;
#line 125 "../src/warp.vala"
		_tmp12_ = self->priv->_manager;
#line 125 "../src/warp.vala"
		_tmp13_ = _tmp12_->all_empty_board_positions;
#line 125 "../src/warp.vala"
		_tmp13__length1 = _tmp12_->all_empty_board_positions_length1;
#line 125 "../src/warp.vala"
		_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup1 (_tmp13_, _tmp13__length1) : _tmp13_;
#line 125 "../src/warp.vala"
		_tmp14__length1 = _tmp13__length1;
#line 125 "../src/warp.vala"
		P = _tmp14_;
#line 125 "../src/warp.vala"
		P_length1 = _tmp14__length1;
#line 125 "../src/warp.vala"
		_P_size_ = P_length1;
#line 126 "../src/warp.vala"
		_tmp15_.x = (guint8) 0;
#line 126 "../src/warp.vala"
		_tmp15_.y = (guint8) 0;
#line 126 "../src/warp.vala"
		p = _tmp15_;
#line 127 "../src/warp.vala"
		lowest_deadend = G_MAXINT;
#line 128 "../src/warp.vala"
		lowest_deadend_position = (guint16) 0;
#line 135 "../src/warp.vala"
		if (ai_worm) {
#line 135 "../src/warp.vala"
			_tmp16_ = 2;
#line 1249 "warp.c"
		} else {
#line 135 "../src/warp.vala"
			_tmp16_ = 12;
#line 1253 "warp.c"
		}
#line 135 "../src/warp.vala"
		clear_count = _tmp16_;
#line 137 "../src/warp.vala"
		_tmp17_ = P;
#line 137 "../src/warp.vala"
		_tmp17__length1 = P_length1;
#line 137 "../src/warp.vala"
		array_length = _tmp17__length1;
#line 1263 "warp.c"
		{
			gboolean _tmp18_ = FALSE;
#line 138 "../src/warp.vala"
			_tmp18_ = TRUE;
#line 138 "../src/warp.vala"
			while (TRUE) {
#line 1270 "warp.c"
				gint _tmp54_;
#line 138 "../src/warp.vala"
				if (!_tmp18_) {
#line 1274 "warp.c"
				}
#line 138 "../src/warp.vala"
				_tmp18_ = FALSE;
#line 138 "../src/warp.vala"
				if (!(array_length > 0)) {
#line 138 "../src/warp.vala"
					break;
#line 1282 "warp.c"
				}
#line 140 "../src/warp.vala"
				i = (gint) g_random_int_range ((gint32) 0, (gint32) array_length);
#line 1286 "warp.c"
				{
					guint16* _tmp19_;
					gint _tmp19__length1;
					guint16 _tmp20_;
					guint16* _tmp21_;
					gint _tmp21__length1;
					guint16 _tmp22_;
					gboolean _tmp23_ = FALSE;
#line 141 "../src/warp.vala"
					count = 0;
#line 141 "../src/warp.vala"
					_tmp19_ = P;
#line 141 "../src/warp.vala"
					_tmp19__length1 = P_length1;
#line 141 "../src/warp.vala"
					_tmp20_ = _tmp19_[i];
#line 141 "../src/warp.vala"
					p.x = (guint8) (_tmp20_ >> 8);
#line 141 "../src/warp.vala"
					_tmp21_ = P;
#line 141 "../src/warp.vala"
					_tmp21__length1 = P_length1;
#line 141 "../src/warp.vala"
					_tmp22_ = _tmp21_[i];
#line 141 "../src/warp.vala"
					p.y = (guint8) _tmp22_;
#line 141 "../src/warp.vala"
					_tmp23_ = TRUE;
#line 141 "../src/warp.vala"
					while (TRUE) {
#line 1317 "warp.c"
						gboolean _tmp27_ = FALSE;
						gboolean _tmp28_ = FALSE;
#line 141 "../src/warp.vala"
						if (!_tmp23_) {
#line 1322 "warp.c"
							gint _tmp24_;
							WarpManager* _tmp25_;
							WarpManager* _tmp26_;
#line 143 "../src/warp.vala"
							_tmp24_ = count;
#line 143 "../src/warp.vala"
							count = _tmp24_ + 1;
#line 143 "../src/warp.vala"
							_tmp25_ = self->priv->_manager;
#line 143 "../src/warp.vala"
							_tmp26_ = self->priv->_manager;
#line 143 "../src/warp.vala"
							position_move (&p, direction, _tmp25_->board_max_x, _tmp26_->board_max_y);
#line 1336 "warp.c"
						}
#line 141 "../src/warp.vala"
						_tmp23_ = FALSE;
#line 142 "../src/warp.vala"
						if (count < clear_count) {
#line 1342 "warp.c"
							WarpManager* _tmp29_;
							gint* _tmp30_;
							gint _tmp30__length1;
							gint _tmp30__length2;
							Position _tmp31_;
							Position _tmp32_;
							gint _tmp33_;
#line 142 "../src/warp.vala"
							_tmp29_ = self->priv->_manager;
#line 142 "../src/warp.vala"
							_tmp30_ = _tmp29_->board;
#line 142 "../src/warp.vala"
							_tmp30__length1 = _tmp29_->board_length1;
#line 142 "../src/warp.vala"
							_tmp30__length2 = _tmp29_->board_length2;
#line 142 "../src/warp.vala"
							_tmp31_ = p;
#line 142 "../src/warp.vala"
							_tmp32_ = p;
#line 142 "../src/warp.vala"
							_tmp33_ = _tmp30_[(_tmp31_.x * _tmp30__length2) + _tmp32_.y];
#line 142 "../src/warp.vala"
							_tmp28_ = _tmp33_ == ((gint) NIBBLES_GAME_EMPTYCHAR);
#line 1366 "warp.c"
						} else {
#line 142 "../src/warp.vala"
							_tmp28_ = FALSE;
#line 1370 "warp.c"
						}
#line 142 "../src/warp.vala"
						if (_tmp28_) {
#line 1374 "warp.c"
							WormMap* _tmp34_;
							Position _tmp35_;
#line 142 "../src/warp.vala"
							_tmp34_ = worm_map;
#line 142 "../src/warp.vala"
							_tmp35_ = p;
#line 142 "../src/warp.vala"
							_tmp27_ = !worm_map_contain_position (_tmp34_, &_tmp35_);
#line 1383 "warp.c"
						} else {
#line 142 "../src/warp.vala"
							_tmp27_ = FALSE;
#line 1387 "warp.c"
						}
#line 142 "../src/warp.vala"
						if (!_tmp27_) {
#line 142 "../src/warp.vala"
							break;
#line 1393 "warp.c"
						}
					}
				}
#line 144 "../src/warp.vala"
				if (count >= clear_count) {
#line 146 "../src/warp.vala"
					if (ai_worm) {
#line 1401 "warp.c"
						guint16* _tmp36_;
						gint _tmp36__length1;
						guint16 _tmp37_;
						guint16* _tmp38_;
						gint _tmp38__length1;
						guint16 _tmp39_;
#line 148 "../src/warp.vala"
						_tmp36_ = P;
#line 148 "../src/warp.vala"
						_tmp36__length1 = P_length1;
#line 148 "../src/warp.vala"
						_tmp37_ = _tmp36_[i];
#line 148 "../src/warp.vala"
						*target_x = (guint8) (_tmp37_ >> 8);
#line 149 "../src/warp.vala"
						_tmp38_ = P;
#line 149 "../src/warp.vala"
						_tmp38__length1 = P_length1;
#line 149 "../src/warp.vala"
						_tmp39_ = _tmp38_[i];
#line 149 "../src/warp.vala"
						*target_y = (guint8) _tmp39_;
#line 150 "../src/warp.vala"
						break;
#line 1426 "warp.c"
					} else {
						gint deadend = 0;
						WarpManager* _tmp40_;
						gint* _tmp41_;
						gint _tmp41__length1;
						gint _tmp41__length2;
						WormMap* _tmp42_;
						guint16* _tmp43_;
						gint _tmp43__length1;
						guint16 _tmp44_;
						guint16* _tmp45_;
						gint _tmp45__length1;
						guint16 _tmp46_;
						Position _tmp47_ = {0};
#line 154 "../src/warp.vala"
						_tmp40_ = self->priv->_manager;
#line 154 "../src/warp.vala"
						_tmp41_ = _tmp40_->board;
#line 154 "../src/warp.vala"
						_tmp41__length1 = _tmp40_->board_length1;
#line 154 "../src/warp.vala"
						_tmp41__length2 = _tmp40_->board_length2;
#line 154 "../src/warp.vala"
						_tmp42_ = worm_map;
#line 154 "../src/warp.vala"
						_tmp43_ = P;
#line 154 "../src/warp.vala"
						_tmp43__length1 = P_length1;
#line 154 "../src/warp.vala"
						_tmp44_ = _tmp43_[i];
#line 154 "../src/warp.vala"
						_tmp45_ = P;
#line 154 "../src/warp.vala"
						_tmp45__length1 = P_length1;
#line 154 "../src/warp.vala"
						_tmp46_ = _tmp45_[i];
#line 154 "../src/warp.vala"
						_tmp47_.x = (guint8) (_tmp44_ >> 8);
#line 154 "../src/warp.vala"
						_tmp47_.y = (guint8) _tmp46_;
#line 154 "../src/warp.vala"
						deadend = worm_ai_deadend_after (_tmp41_, (gint) _tmp41__length1, (gint) _tmp41__length2, worms, _tmp42_, &_tmp47_, direction, length);
#line 155 "../src/warp.vala"
						if (deadend <= 0) {
#line 1471 "warp.c"
							guint16* _tmp48_;
							gint _tmp48__length1;
							guint16 _tmp49_;
							guint16* _tmp50_;
							gint _tmp50__length1;
							guint16 _tmp51_;
#line 157 "../src/warp.vala"
							_tmp48_ = P;
#line 157 "../src/warp.vala"
							_tmp48__length1 = P_length1;
#line 157 "../src/warp.vala"
							_tmp49_ = _tmp48_[i];
#line 157 "../src/warp.vala"
							*target_x = (guint8) (_tmp49_ >> 8);
#line 158 "../src/warp.vala"
							_tmp50_ = P;
#line 158 "../src/warp.vala"
							_tmp50__length1 = P_length1;
#line 158 "../src/warp.vala"
							_tmp51_ = _tmp50_[i];
#line 158 "../src/warp.vala"
							*target_y = (guint8) _tmp51_;
#line 159 "../src/warp.vala"
							break;
#line 1496 "warp.c"
						}
#line 161 "../src/warp.vala"
						if (deadend < lowest_deadend) {
#line 1500 "warp.c"
							guint16* _tmp52_;
							gint _tmp52__length1;
							guint16 _tmp53_;
#line 163 "../src/warp.vala"
							lowest_deadend = deadend;
#line 164 "../src/warp.vala"
							_tmp52_ = P;
#line 164 "../src/warp.vala"
							_tmp52__length1 = P_length1;
#line 164 "../src/warp.vala"
							_tmp53_ = _tmp52_[i];
#line 164 "../src/warp.vala"
							lowest_deadend_position = _tmp53_;
#line 1514 "warp.c"
						}
					}
				}
#line 169 "../src/warp.vala"
				if (i < (array_length - 1)) {
#line 170 "../src/warp.vala"
					_vala_array_move (P, sizeof (guint16), i + 1, i, array_length - (i + 1));
#line 1522 "warp.c"
				}
#line 171 "../src/warp.vala"
				_tmp54_ = array_length;
#line 171 "../src/warp.vala"
				array_length = _tmp54_ - 1;
#line 1528 "warp.c"
			}
		}
#line 173 "../src/warp.vala"
		if (array_length <= 0) {
#line 178 "../src/warp.vala"
			if (lowest_deadend < G_MAXINT) {
#line 180 "../src/warp.vala"
				*target_x = (guint8) (lowest_deadend_position >> 8);
#line 181 "../src/warp.vala"
				*target_y = (guint8) lowest_deadend_position;
#line 1539 "warp.c"
			} else {
#line 185 "../src/warp.vala"
				result = FALSE;
#line 185 "../src/warp.vala"
				P = (g_free (P), NULL);
#line 185 "../src/warp.vala"
				_g_object_unref0 (worm_map);
#line 185 "../src/warp.vala"
				if (bonus) {
#line 185 "../src/warp.vala"
					*bonus = _vala_bonus;
#line 1551 "warp.c"
				}
#line 185 "../src/warp.vala"
				return result;
#line 1555 "warp.c"
			}
		}
#line 188 "../src/warp.vala"
		_vala_bonus = TRUE;
#line 122 "../src/warp.vala"
		P = (g_free (P), NULL);
#line 122 "../src/warp.vala"
		_g_object_unref0 (worm_map);
#line 1564 "warp.c"
	} else {
		gboolean _tmp55_;
#line 190 "../src/warp.vala"
		_tmp55_ = self->priv->_bidi;
#line 190 "../src/warp.vala"
		if (!_tmp55_) {
#line 1571 "warp.c"
			guint8 _tmp56_;
			guint8 _tmp57_;
#line 192 "../src/warp.vala"
			_tmp56_ = self->priv->_target_x;
#line 192 "../src/warp.vala"
			*target_x = _tmp56_;
#line 193 "../src/warp.vala"
			_tmp57_ = self->priv->_target_y;
#line 193 "../src/warp.vala"
			*target_y = _tmp57_;
#line 1582 "warp.c"
		} else {
			gboolean _tmp58_ = FALSE;
#line 195 "../src/warp.vala"
			if (direction == WORM_DIRECTION_LEFT) {
#line 195 "../src/warp.vala"
				_tmp58_ = TRUE;
#line 1589 "warp.c"
			} else {
#line 195 "../src/warp.vala"
				_tmp58_ = direction == WORM_DIRECTION_RIGHT;
#line 1593 "warp.c"
			}
#line 195 "../src/warp.vala"
			if (_tmp58_) {
#line 1597 "warp.c"
				guint8 _tmp59_;
				guint8 _tmp63_;
#line 197 "../src/warp.vala"
				_tmp59_ = self->priv->_source_x;
#line 197 "../src/warp.vala"
				if (x == _tmp59_) {
#line 1604 "warp.c"
					guint8 _tmp60_;
#line 198 "../src/warp.vala"
					_tmp60_ = self->priv->_target_x;
#line 198 "../src/warp.vala"
					*target_x = (guint8) (_tmp60_ + 2);
#line 1610 "warp.c"
				} else {
					guint8 _tmp61_;
#line 199 "../src/warp.vala"
					_tmp61_ = self->priv->_target_x;
#line 199 "../src/warp.vala"
					if (((gint) _tmp61_) == 0) {
#line 200 "../src/warp.vala"
						g_assert_not_reached ();
#line 1619 "warp.c"
					} else {
						guint8 _tmp62_;
#line 202 "../src/warp.vala"
						_tmp62_ = self->priv->_target_x;
#line 202 "../src/warp.vala"
						*target_x = (guint8) (_tmp62_ - 1);
#line 1626 "warp.c"
					}
				}
#line 203 "../src/warp.vala"
				_tmp63_ = self->priv->_source_y;
#line 203 "../src/warp.vala"
				if (y == _tmp63_) {
#line 1633 "warp.c"
					guint8 _tmp64_;
#line 204 "../src/warp.vala"
					_tmp64_ = self->priv->_target_y;
#line 204 "../src/warp.vala"
					*target_y = _tmp64_;
#line 1639 "warp.c"
				} else {
					guint8 _tmp65_;
#line 206 "../src/warp.vala"
					_tmp65_ = self->priv->_target_y;
#line 206 "../src/warp.vala"
					*target_y = (guint8) (_tmp65_ + 1);
#line 1646 "warp.c"
				}
			} else {
				guint8 _tmp66_;
				guint8 _tmp69_;
#line 210 "../src/warp.vala"
				_tmp66_ = self->priv->_source_x;
#line 210 "../src/warp.vala"
				if (x == _tmp66_) {
#line 1655 "warp.c"
					guint8 _tmp67_;
#line 211 "../src/warp.vala"
					_tmp67_ = self->priv->_target_x;
#line 211 "../src/warp.vala"
					*target_x = _tmp67_;
#line 1661 "warp.c"
				} else {
					guint8 _tmp68_;
#line 213 "../src/warp.vala"
					_tmp68_ = self->priv->_target_x;
#line 213 "../src/warp.vala"
					*target_x = (guint8) (_tmp68_ + 1);
#line 1668 "warp.c"
				}
#line 214 "../src/warp.vala"
				_tmp69_ = self->priv->_source_y;
#line 214 "../src/warp.vala"
				if (y == _tmp69_) {
#line 1674 "warp.c"
					guint8 _tmp70_;
#line 215 "../src/warp.vala"
					_tmp70_ = self->priv->_target_y;
#line 215 "../src/warp.vala"
					*target_y = (guint8) (_tmp70_ + 2);
#line 1680 "warp.c"
				} else {
					guint8 _tmp71_;
#line 216 "../src/warp.vala"
					_tmp71_ = self->priv->_target_y;
#line 216 "../src/warp.vala"
					if (((gint) _tmp71_) == 0) {
#line 217 "../src/warp.vala"
						g_assert_not_reached ();
#line 1689 "warp.c"
					} else {
						guint8 _tmp72_;
#line 219 "../src/warp.vala"
						_tmp72_ = self->priv->_target_y;
#line 219 "../src/warp.vala"
						*target_y = (guint8) (_tmp72_ - 1);
#line 1696 "warp.c"
					}
				}
			}
		}
	}
#line 221 "../src/warp.vala"
	result = TRUE;
#line 221 "../src/warp.vala"
	if (bonus) {
#line 221 "../src/warp.vala"
		*bonus = _vala_bonus;
#line 1708 "warp.c"
	}
#line 221 "../src/warp.vala"
	return result;
#line 1712 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_construct (GType object_type)
{
	WarpManagerWarp * self = NULL;
#line 40 "../src/warp.vala"
	self = (WarpManagerWarp*) g_object_new (object_type, NULL);
#line 40 "../src/warp.vala"
	return self;
#line 1723 "warp.c"
}

static WarpManagerWarp*
warp_manager_warp_new (void)
{
#line 40 "../src/warp.vala"
	return warp_manager_warp_construct (WARP_MANAGER_TYPE_WARP);
#line 1731 "warp.c"
}

static WarpManager*
warp_manager_warp_get_manager (WarpManagerWarp* self)
{
	WarpManager* result;
	WarpManager* _tmp0_;
#line 44 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../src/warp.vala"
	_tmp0_ = self->priv->_manager;
#line 44 "../src/warp.vala"
	result = _tmp0_;
#line 44 "../src/warp.vala"
	return result;
#line 1747 "warp.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../src/warp.vala"
	return self ? g_object_ref (self) : NULL;
#line 1755 "warp.c"
}

static void
warp_manager_warp_set_manager (WarpManagerWarp* self,
                               WarpManager* value)
{
	WarpManager* old_value;
#line 44 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 44 "../src/warp.vala"
	old_value = warp_manager_warp_get_manager (self);
#line 44 "../src/warp.vala"
	if (old_value != value) {
#line 1769 "warp.c"
		WarpManager* _tmp0_;
#line 44 "../src/warp.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 44 "../src/warp.vala"
		_g_object_unref0 (self->priv->_manager);
#line 44 "../src/warp.vala"
		self->priv->_manager = _tmp0_;
#line 44 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_MANAGER_PROPERTY]);
#line 1779 "warp.c"
	}
}

static gint
warp_manager_warp_get_id (WarpManagerWarp* self)
{
	gint result;
#line 46 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../src/warp.vala"
	result = self->priv->_id;
#line 46 "../src/warp.vala"
	return result;
#line 1793 "warp.c"
}

static void
warp_manager_warp_set_id (WarpManagerWarp* self,
                          gint value)
{
	gint old_value;
#line 46 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/warp.vala"
	old_value = warp_manager_warp_get_id (self);
#line 46 "../src/warp.vala"
	if (old_value != value) {
#line 46 "../src/warp.vala"
		self->priv->_id = value;
#line 46 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_ID_PROPERTY]);
#line 1811 "warp.c"
	}
}

static guint8
warp_manager_warp_get_source_x (WarpManagerWarp* self)
{
	guint8 result;
#line 48 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 48 "../src/warp.vala"
	result = self->priv->_source_x;
#line 48 "../src/warp.vala"
	return result;
#line 1825 "warp.c"
}

static void
warp_manager_warp_set_source_x (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 48 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 48 "../src/warp.vala"
	old_value = warp_manager_warp_get_source_x (self);
#line 48 "../src/warp.vala"
	if (old_value != value) {
#line 48 "../src/warp.vala"
		self->priv->_source_x = value;
#line 48 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_X_PROPERTY]);
#line 1843 "warp.c"
	}
}

static guint8
warp_manager_warp_get_source_y (WarpManagerWarp* self)
{
	guint8 result;
#line 49 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 49 "../src/warp.vala"
	result = self->priv->_source_y;
#line 49 "../src/warp.vala"
	return result;
#line 1857 "warp.c"
}

static void
warp_manager_warp_set_source_y (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 49 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/warp.vala"
	old_value = warp_manager_warp_get_source_y (self);
#line 49 "../src/warp.vala"
	if (old_value != value) {
#line 49 "../src/warp.vala"
		self->priv->_source_y = value;
#line 49 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_Y_PROPERTY]);
#line 1875 "warp.c"
	}
}

static guint8
warp_manager_warp_get_target_x (WarpManagerWarp* self)
{
	guint8 result;
#line 51 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 51 "../src/warp.vala"
	result = self->priv->_target_x;
#line 51 "../src/warp.vala"
	return result;
#line 1889 "warp.c"
}

static void
warp_manager_warp_set_target_x (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 51 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 51 "../src/warp.vala"
	old_value = warp_manager_warp_get_target_x (self);
#line 51 "../src/warp.vala"
	if (old_value != value) {
#line 51 "../src/warp.vala"
		self->priv->_target_x = value;
#line 51 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_X_PROPERTY]);
#line 1907 "warp.c"
	}
}

static guint8
warp_manager_warp_get_target_y (WarpManagerWarp* self)
{
	guint8 result;
#line 52 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 52 "../src/warp.vala"
	result = self->priv->_target_y;
#line 52 "../src/warp.vala"
	return result;
#line 1921 "warp.c"
}

static void
warp_manager_warp_set_target_y (WarpManagerWarp* self,
                                guint8 value)
{
	guint8 old_value;
#line 52 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/warp.vala"
	old_value = warp_manager_warp_get_target_y (self);
#line 52 "../src/warp.vala"
	if (old_value != value) {
#line 52 "../src/warp.vala"
		self->priv->_target_y = value;
#line 52 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_Y_PROPERTY]);
#line 1939 "warp.c"
	}
}

static gboolean
warp_manager_warp_get_random (WarpManagerWarp* self)
{
	gboolean result;
#line 56 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../src/warp.vala"
	result = self->priv->_random;
#line 56 "../src/warp.vala"
	return result;
#line 1953 "warp.c"
}

static void
warp_manager_warp_set_random (WarpManagerWarp* self,
                              gboolean value)
{
#line 57 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/warp.vala"
	self->priv->_random = value;
#line 60 "../src/warp.vala"
	if (value) {
#line 61 "../src/warp.vala"
		self->priv->init_finished = TRUE;
#line 1968 "warp.c"
	}
#line 57 "../src/warp.vala"
	g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_RANDOM_PROPERTY]);
#line 1972 "warp.c"
}

static gboolean
warp_manager_warp_get_bidi (WarpManagerWarp* self)
{
	gboolean result;
#line 65 "../src/warp.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../src/warp.vala"
	result = self->priv->_bidi;
#line 65 "../src/warp.vala"
	return result;
#line 1985 "warp.c"
}

static void
warp_manager_warp_set_bidi (WarpManagerWarp* self,
                            gboolean value)
{
	gboolean old_value;
#line 65 "../src/warp.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/warp.vala"
	old_value = warp_manager_warp_get_bidi (self);
#line 65 "../src/warp.vala"
	if (old_value != value) {
#line 65 "../src/warp.vala"
		self->priv->_bidi = value;
#line 65 "../src/warp.vala"
		g_object_notify_by_pspec ((GObject *) self, warp_manager_warp_properties[WARP_MANAGER_WARP_BIDI_PROPERTY]);
#line 2003 "warp.c"
	}
}

static void
warp_manager_warp_class_init (WarpManagerWarpClass * klass,
                              gpointer klass_data)
{
#line 40 "../src/warp.vala"
	warp_manager_warp_parent_class = g_type_class_peek_parent (klass);
#line 40 "../src/warp.vala"
	g_type_class_adjust_private_offset (klass, &WarpManagerWarp_private_offset);
#line 40 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_warp_manager_warp_get_property;
#line 40 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_warp_manager_warp_set_property;
#line 40 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->finalize = warp_manager_warp_finalize;
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_MANAGER_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_MANAGER_PROPERTY] = g_param_spec_object ("manager", "manager", "manager", TYPE_WARP_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_ID_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_SOURCE_X_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_X_PROPERTY] = g_param_spec_uchar ("source-x", "source-x", "source-x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_SOURCE_Y_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_SOURCE_Y_PROPERTY] = g_param_spec_uchar ("source-y", "source-y", "source-y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_TARGET_X_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_X_PROPERTY] = g_param_spec_uchar ("target-x", "target-x", "target-x", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_TARGET_Y_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_TARGET_Y_PROPERTY] = g_param_spec_uchar ("target-y", "target-y", "target-y", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_RANDOM_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_RANDOM_PROPERTY] = g_param_spec_boolean ("random", "random", "random", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 40 "../src/warp.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), WARP_MANAGER_WARP_BIDI_PROPERTY, warp_manager_warp_properties[WARP_MANAGER_WARP_BIDI_PROPERTY] = g_param_spec_boolean ("bidi", "bidi", "bidi", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 2037 "warp.c"
}

static void
warp_manager_warp_instance_init (WarpManagerWarp * self,
                                 gpointer klass)
{
#line 40 "../src/warp.vala"
	self->priv = warp_manager_warp_get_instance_private (self);
#line 42 "../src/warp.vala"
	self->priv->init_finished = FALSE;
#line 2048 "warp.c"
}

static void
warp_manager_warp_finalize (GObject * obj)
{
	WarpManagerWarp * self;
#line 40 "../src/warp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, WARP_MANAGER_TYPE_WARP, WarpManagerWarp);
#line 44 "../src/warp.vala"
	_g_object_unref0 (self->priv->_manager);
#line 40 "../src/warp.vala"
	G_OBJECT_CLASS (warp_manager_warp_parent_class)->finalize (obj);
#line 2061 "warp.c"
}

 G_GNUC_NO_INLINE static GType
warp_manager_warp_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarpManagerWarpClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warp_manager_warp_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarpManagerWarp), 0, (GInstanceInitFunc) warp_manager_warp_instance_init, NULL };
	GType warp_manager_warp_type_id;
	warp_manager_warp_type_id = g_type_register_static (G_TYPE_OBJECT, "WarpManagerWarp", &g_define_type_info, 0);
	WarpManagerWarp_private_offset = g_type_add_instance_private (warp_manager_warp_type_id, sizeof (WarpManagerWarpPrivate));
	return warp_manager_warp_type_id;
}

static GType
warp_manager_warp_get_type (void)
{
	static gsize warp_manager_warp_type_id__once = 0;
	if (g_once_init_enter (&warp_manager_warp_type_id__once)) {
		GType warp_manager_warp_type_id;
		warp_manager_warp_type_id = warp_manager_warp_get_type_once ();
		g_once_init_leave (&warp_manager_warp_type_id__once, warp_manager_warp_type_id);
	}
	return warp_manager_warp_type_id__once;
}

static void
_vala_warp_manager_warp_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	WarpManagerWarp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARP_MANAGER_TYPE_WARP, WarpManagerWarp);
#line 40 "../src/warp.vala"
	switch (property_id) {
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_MANAGER_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_object (value, warp_manager_warp_get_manager (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_ID_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_int (value, warp_manager_warp_get_id (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_X_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_source_x (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_Y_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_source_y (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_X_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_target_x (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_Y_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_uchar (value, warp_manager_warp_get_target_y (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_RANDOM_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_boolean (value, warp_manager_warp_get_random (self));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_BIDI_PROPERTY:
#line 40 "../src/warp.vala"
		g_value_set_boolean (value, warp_manager_warp_get_bidi (self));
#line 40 "../src/warp.vala"
		break;
#line 2144 "warp.c"
		default:
#line 40 "../src/warp.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../src/warp.vala"
		break;
#line 2150 "warp.c"
	}
}

static void
_vala_warp_manager_warp_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	WarpManagerWarp * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, WARP_MANAGER_TYPE_WARP, WarpManagerWarp);
#line 40 "../src/warp.vala"
	switch (property_id) {
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_MANAGER_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_manager (self, g_value_get_object (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_ID_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_id (self, g_value_get_int (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_X_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_source_x (self, g_value_get_uchar (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_SOURCE_Y_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_source_y (self, g_value_get_uchar (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_X_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_target_x (self, g_value_get_uchar (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_TARGET_Y_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_target_y (self, g_value_get_uchar (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_RANDOM_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_random (self, g_value_get_boolean (value));
#line 40 "../src/warp.vala"
		break;
#line 40 "../src/warp.vala"
		case WARP_MANAGER_WARP_BIDI_PROPERTY:
#line 40 "../src/warp.vala"
		warp_manager_warp_set_bidi (self, g_value_get_boolean (value));
#line 40 "../src/warp.vala"
		break;
#line 2212 "warp.c"
		default:
#line 40 "../src/warp.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 40 "../src/warp.vala"
		break;
#line 2218 "warp.c"
	}
}

static void
warp_manager_class_init (WarpManagerClass * klass,
                         gpointer klass_data)
{
#line 38 "../src/warp.vala"
	warp_manager_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/warp.vala"
	g_type_class_adjust_private_offset (klass, &WarpManager_private_offset);
#line 38 "../src/warp.vala"
	G_OBJECT_CLASS (klass)->finalize = warp_manager_finalize;
#line 2232 "warp.c"
}

static void
warp_manager_instance_init (WarpManager * self,
                            gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 38 "../src/warp.vala"
	self->priv = warp_manager_get_instance_private (self);
#line 230 "../src/warp.vala"
	_tmp0_ = gee_linked_list_new (WARP_MANAGER_TYPE_WARP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 230 "../src/warp.vala"
	self->priv->warps = _tmp0_;
#line 2246 "warp.c"
}

static void
warp_manager_finalize (GObject * obj)
{
	WarpManager * self;
#line 38 "../src/warp.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_WARP_MANAGER, WarpManager);
#line 225 "../src/warp.vala"
	self->all_empty_board_positions = (g_free (self->all_empty_board_positions), NULL);
#line 230 "../src/warp.vala"
	_g_object_unref0 (self->priv->warps);
#line 38 "../src/warp.vala"
	G_OBJECT_CLASS (warp_manager_parent_class)->finalize (obj);
#line 2261 "warp.c"
}

 G_GNUC_NO_INLINE static GType
warp_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (WarpManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) warp_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (WarpManager), 0, (GInstanceInitFunc) warp_manager_instance_init, NULL };
	GType warp_manager_type_id;
	warp_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "WarpManager", &g_define_type_info, 0);
	WarpManager_private_offset = g_type_add_instance_private (warp_manager_type_id, sizeof (WarpManagerPrivate));
	return warp_manager_type_id;
}

GType
warp_manager_get_type (void)
{
	static gsize warp_manager_type_id__once = 0;
	if (g_once_init_enter (&warp_manager_type_id__once)) {
		GType warp_manager_type_id;
		warp_manager_type_id = warp_manager_get_type_once ();
		g_once_init_leave (&warp_manager_type_id__once, warp_manager_type_id);
	}
	return warp_manager_type_id__once;
}

static void
_vala_array_move (gpointer array,
                  gsize element_size,
                  gssize src,
                  gssize dest,
                  gssize length)
{
	memmove (((char*) array) + (dest * element_size), ((char*) array) + (src * element_size), length * element_size);
	if ((src < dest) && ((src + length) > dest)) {
		memset (((char*) array) + (src * element_size), 0, (dest - src) * element_size);
	} else if ((src > dest) && (src < (dest + length))) {
		memset (((char*) array) + ((dest + length) * element_size), 0, (src - dest) * element_size);
	} else if (src != dest) {
		memset (((char*) array) + (src * element_size), 0, length * element_size);
	}
}

