/* nibbles-game.c generated by valac 0.56.18, the Vala compiler
 * generated from nibbles-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 * Gnome Nibbles: Gnome Worm Game
 * Copyright (C) 2015 Iulian-Gabriel Radu <iulian.radu67@gmail.com>
 * Copyright (C) 2022-25 Ben Corby <bcorby@new-ms.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
 * Coding style.
 *
 * To help you comply with the coding style in this project use the
 * following greps. Any lines returned should be adjusted so they
 * don't match. The convoluted regular expressions are so they don't
 * match them self.
 *
 * grep -ne '[^][)(_!$ "](' *.vala
 * grep -ne '[(] ' *.vala
 * grep -ne '[ ])' *.vala
 * grep -ne ' $' *.vala
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <glib/gstdio.h>
#include <gio/gio.h>

#define NIBBLES_GAME_MAX_WORMS 6
#define NIBBLES_GAME_MAX_SPEED 4
#define NIBBLES_GAME_EMPTYCHAR 'a'
#define NIBBLES_GAME_WARPCHAR 'W'
#define NIBBLES_GAME_MAX_LEVEL 26
#define WORM_GROW_FACTOR 4
#define NIBBLES_GAME_BONUSES_MAX_BONUSES ((guint8) 100)
#define NIBBLES_GAME_BONUSES_MAX_MISSED ((guint8) 2)
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef gboolean (*KeypressHandlerFunction) (guint a, guint b, gboolean* remove_handler, gpointer user_data);
typedef gboolean (*_LocalFunc0_) (GValue* value, GVariant* variant, void* data, gpointer user_data);
typedef GVariant* (*_LocalFunc1_) (GValue* value, const GVariantType* type, void* data, gpointer user_data);

#define TYPE_NIBBLES_GAME (nibbles_game_get_type ())
#define NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NIBBLES_GAME, NibblesGame))
#define NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NIBBLES_GAME, NibblesGameClass))
#define IS_NIBBLES_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NIBBLES_GAME))
#define IS_NIBBLES_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NIBBLES_GAME))
#define NIBBLES_GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NIBBLES_GAME, NibblesGameClass))

typedef struct _NibblesGame NibblesGame;
typedef struct _NibblesGameClass NibblesGameClass;
typedef struct _NibblesGamePrivate NibblesGamePrivate;

#define TYPE_WORM (worm_get_type ())
#define WORM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM, Worm))
#define WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM, WormClass))
#define IS_WORM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM))
#define IS_WORM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM))
#define WORM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM, WormClass))

typedef struct _Worm Worm;
typedef struct _WormClass WormClass;

#define TYPE_WORM_PROPERTIES (worm_properties_get_type ())
#define WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_PROPERTIES, WormProperties))
#define WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_PROPERTIES, WormPropertiesClass))
#define IS_WORM_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_PROPERTIES))
#define IS_WORM_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_PROPERTIES))
#define WORM_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_PROPERTIES, WormPropertiesClass))

typedef struct _WormProperties WormProperties;
typedef struct _WormPropertiesClass WormPropertiesClass;

#define NIBBLES_GAME_TYPE_BONUSES (nibbles_game_bonuses_get_type ())
#define NIBBLES_GAME_BONUSES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NIBBLES_GAME_TYPE_BONUSES, NibblesGameBonuses))
#define NIBBLES_GAME_BONUSES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NIBBLES_GAME_TYPE_BONUSES, NibblesGameBonusesClass))
#define NIBBLES_GAME_IS_BONUSES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NIBBLES_GAME_TYPE_BONUSES))
#define NIBBLES_GAME_IS_BONUSES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NIBBLES_GAME_TYPE_BONUSES))
#define NIBBLES_GAME_BONUSES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NIBBLES_GAME_TYPE_BONUSES, NibblesGameBonusesClass))

typedef struct _NibblesGameBonuses NibblesGameBonuses;
typedef struct _NibblesGameBonusesClass NibblesGameBonusesClass;

#define TYPE_WARP_MANAGER (warp_manager_get_type ())
#define WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WARP_MANAGER, WarpManager))
#define WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WARP_MANAGER, WarpManagerClass))
#define IS_WARP_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WARP_MANAGER))
#define IS_WARP_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WARP_MANAGER))
#define WARP_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WARP_MANAGER, WarpManagerClass))

typedef struct _WarpManager WarpManager;
typedef struct _WarpManagerClass WarpManagerClass;

#define TYPE_BONUS (bonus_get_type ())
#define BONUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BONUS, Bonus))
#define BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BONUS, BonusClass))
#define IS_BONUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BONUS))
#define IS_BONUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BONUS))
#define BONUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BONUS, BonusClass))

typedef struct _Bonus Bonus;
typedef struct _BonusClass BonusClass;

#define NIBBLES_GAME_TYPE_SCORE_DELTA (nibbles_game_score_delta_get_type ())
#define NIBBLES_GAME_SCORE_DELTA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NIBBLES_GAME_TYPE_SCORE_DELTA, NibblesGameScoreDelta))
#define NIBBLES_GAME_SCORE_DELTA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NIBBLES_GAME_TYPE_SCORE_DELTA, NibblesGameScoreDeltaClass))
#define NIBBLES_GAME_IS_SCORE_DELTA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NIBBLES_GAME_TYPE_SCORE_DELTA))
#define NIBBLES_GAME_IS_SCORE_DELTA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NIBBLES_GAME_TYPE_SCORE_DELTA))
#define NIBBLES_GAME_SCORE_DELTA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NIBBLES_GAME_TYPE_SCORE_DELTA, NibblesGameScoreDeltaClass))

typedef struct _NibblesGameScoreDelta NibblesGameScoreDelta;
typedef struct _NibblesGameScoreDeltaClass NibblesGameScoreDeltaClass;
enum  {
	NIBBLES_GAME_0_PROPERTY,
	NIBBLES_GAME_SKIP_SCORE_PROPERTY,
	NIBBLES_GAME_CURRENT_LEVEL_PROPERTY,
	NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY,
	NIBBLES_GAME_SPEED_PROPERTY,
	NIBBLES_GAME_GAMEDELAY_PROPERTY,
	NIBBLES_GAME_PROGRESS_PROPERTY,
	NIBBLES_GAME_START_LEVEL_PROPERTY,
	NIBBLES_GAME_WIDTH_PROPERTY,
	NIBBLES_GAME_HEIGHT_PROPERTY,
	NIBBLES_GAME_NUMHUMANS_PROPERTY,
	NIBBLES_GAME_NUMAI_PROPERTY,
	NIBBLES_GAME_NUMWORMS_PROPERTY,
	NIBBLES_GAME_WORMS_PROPERTY,
	NIBBLES_GAME_WORM_PROPS_PROPERTY,
	NIBBLES_GAME_IS_RUNNING_PROPERTY,
	NIBBLES_GAME_PAUSED_PROPERTY,
	NIBBLES_GAME_FAKES_PROPERTY,
	NIBBLES_GAME_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_properties[NIBBLES_GAME_NUM_PROPERTIES];
typedef enum  {
	NIBBLES_GAME_ESTATUS_GAMEOVER,
	NIBBLES_GAME_ESTATUS_VICTORY,
	NIBBLES_GAME_ESTATUS_NEWROUND
} NibblesGameeStatus;

#define NIBBLES_GAME_TYPE_ESTATUS (nibbles_game_estatus_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _fclose0(var) ((var == NULL) ? NULL : (var = (fclose (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
typedef enum  {
	WORM_DIRECTION_NONE,
	WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_EAST = WORM_DIRECTION_RIGHT,
	WORM_DIRECTION_DOWN,
	WORM_DIRECTION_SOUTH = WORM_DIRECTION_DOWN,
	WORM_DIRECTION_LEFT,
	WORM_DIRECTION_WEST = WORM_DIRECTION_LEFT,
	WORM_DIRECTION_UP,
	WORM_DIRECTION_NORTH = WORM_DIRECTION_UP
} WormDirection;

#define TYPE_WORM_DIRECTION (worm_direction_get_type ())
typedef GeeList* (*WormGetOtherWormsType) (Worm* _self_, gpointer user_data);
typedef GeeList* (*WormGetBonusesType) (gpointer user_data);
typedef struct _WormPrivate WormPrivate;

#define TYPE_POSITION (position_get_type ())
typedef struct _Position Position;

#define TYPE_WORM_POSITIONS (worm_positions_get_type ())
#define WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_WORM_POSITIONS, WormPositions))
#define WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_WORM_POSITIONS, WormPositionsClass))
#define IS_WORM_POSITIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_WORM_POSITIONS))
#define IS_WORM_POSITIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_WORM_POSITIONS))
#define WORM_POSITIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_WORM_POSITIONS, WormPositionsClass))

typedef struct _WormPositions WormPositions;
typedef struct _WormPositionsClass WormPositionsClass;
typedef enum  {
	BONUS_ETYPE_REGULAR,
	BONUS_ETYPE_HALF,
	BONUS_ETYPE_DOUBLE,
	BONUS_ETYPE_LIFE,
	BONUS_ETYPE_REVERSE,
	BONUS_ETYPE_WARP
} BonuseType;

#define BONUS_TYPE_ETYPE (bonus_etype_get_type ())
typedef struct _NibblesGameBonusesPrivate NibblesGameBonusesPrivate;
enum  {
	NIBBLES_GAME_BONUSES_0_PROPERTY,
	NIBBLES_GAME_BONUSES_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_bonuses_properties[NIBBLES_GAME_BONUSES_NUM_PROPERTIES];
enum  {
	NIBBLES_GAME_BONUSES_BONUS_REMOVED_SIGNAL,
	NIBBLES_GAME_BONUSES_NUM_SIGNALS
};
static guint nibbles_game_bonuses_signals[NIBBLES_GAME_BONUSES_NUM_SIGNALS] = {0};
typedef struct _NibblesGameScoreDeltaPrivate NibblesGameScoreDeltaPrivate;
enum  {
	NIBBLES_GAME_SCORE_DELTA_0_PROPERTY,
	NIBBLES_GAME_SCORE_DELTA_WORM_PROPERTY,
	NIBBLES_GAME_SCORE_DELTA_SCORE_DELTA_PROPERTY,
	NIBBLES_GAME_SCORE_DELTA_NUM_PROPERTIES
};
static GParamSpec* nibbles_game_score_delta_properties[NIBBLES_GAME_SCORE_DELTA_NUM_PROPERTIES];
enum  {
	NIBBLES_GAME_BONUS_APPLIED_SIGNAL,
	NIBBLES_GAME_LOG_SCORE_SIGNAL,
	NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL,
	NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL,
	NIBBLES_GAME_WARP_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_ADDED_SIGNAL,
	NIBBLES_GAME_BONUS_REMOVED_SIGNAL,
	NIBBLES_GAME_GET_PKGDATADIR_SIGNAL,
	NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL,
	NIBBLES_GAME_REDRAW_SIGNAL,
	NIBBLES_GAME_PLAY_SOUND_SIGNAL,
	NIBBLES_GAME_NUM_SIGNALS
};
static guint nibbles_game_signals[NIBBLES_GAME_NUM_SIGNALS] = {0};

struct _NibblesGame {
	GObject parent_instance;
	NibblesGamePrivate * priv;
	gint _progress;
	gint* levels_uncompleated;
	gint levels_uncompleated_length1;
	gint _levels_uncompleated_size_;
	gint* board;
	gint board_length1;
	gint board_length2;
	gboolean added_keypress_handler;
};

struct _NibblesGameClass {
	GObjectClass parent_class;
};

struct _NibblesGamePrivate {
	gboolean _skip_score;
	gint _current_level;
	gboolean _three_dimensional_view;
	gint _speed;
	gint _gamedelay;
	gint _start_level;
	guint8 _width;
	guint8 _height;
	gint _numhumans;
	gint _numai;
	gint _numworms;
	GeeLinkedList* _worms;
	GeeHashMap* _worm_props;
	NibblesGameBonuses* bonuses;
	WarpManager* warp_manager;
	GeeHashMap* _score_deltas;
	GeeSet* bouns_eaten;
	gboolean _is_running;
	gboolean _is_paused;
	guint main_id;
	gboolean _fakes;
	guint8 bonus_cycle;
};

struct _Position {
	guint8 x;
	guint8 y;
};

struct _Worm {
	GObject parent_instance;
	WormPrivate * priv;
	gboolean is_human;
	gint rounds_to_stay_still;
	gboolean is_stopped;
	Position warp_position;
	gboolean warp_bonus;
	WormPositions* list;
};

struct _WormClass {
	GObjectClass parent_class;
};

struct _NibblesGameBonuses {
	GObject parent_instance;
	NibblesGameBonusesPrivate * priv;
	gint progress;
};

struct _NibblesGameBonusesClass {
	GObjectClass parent_class;
};

struct _NibblesGameBonusesPrivate {
	GeeLinkedList* bonuses;
	guint8 regular_bonus_left;
	guint8 regular_bonus_maxi;
	guint8 total_bonus_number;
	guint8 missed;
};

struct _NibblesGameScoreDelta {
	GObject parent_instance;
	NibblesGameScoreDeltaPrivate * priv;
};

struct _NibblesGameScoreDeltaClass {
	GObjectClass parent_class;
};

struct _NibblesGameScoreDeltaPrivate {
	Worm* _worm;
	gint _score_delta;
};

static gint NibblesGame_private_offset;
static gpointer nibbles_game_parent_class = NULL;
static gint NibblesGameBonuses_private_offset;
static gpointer nibbles_game_bonuses_parent_class = NULL;
static gint NibblesGameScoreDelta_private_offset;
static gpointer nibbles_game_score_delta_parent_class = NULL;

VALA_EXTERN GType nibbles_game_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGame, g_object_unref)
VALA_EXTERN GType worm_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Worm, g_object_unref)
VALA_EXTERN GType worm_properties_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormProperties, g_object_unref)
static GType nibbles_game_bonuses_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGameBonuses, g_object_unref)
VALA_EXTERN GType warp_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WarpManager, g_object_unref)
VALA_EXTERN GType bonus_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Bonus, g_object_unref)
static GType nibbles_game_score_delta_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NibblesGameScoreDelta, g_object_unref)
VALA_EXTERN GType nibbles_game_estatus_get_type (void) G_GNUC_CONST ;
static NibblesGameBonuses* nibbles_game_bonuses_new (void);
static NibblesGameBonuses* nibbles_game_bonuses_construct (GType object_type);
VALA_EXTERN WarpManager* warp_manager_new (void);
VALA_EXTERN WarpManager* warp_manager_construct (GType object_type);
VALA_EXTERN NibblesGame* nibbles_game_new (gint start_level,
                               gint speed,
                               gint gamedelay,
                               gboolean fakes,
                               gboolean three_dimensional_view,
                               guint8 width,
                               guint8 height,
                               gboolean no_random);
VALA_EXTERN NibblesGame* nibbles_game_construct (GType object_type,
                                     gint start_level,
                                     gint speed,
                                     gint gamedelay,
                                     gboolean fakes,
                                     gboolean three_dimensional_view,
                                     guint8 width,
                                     guint8 height,
                                     gboolean no_random);
VALA_EXTERN void nibbles_game_new_level (NibblesGame* self,
                             gint level_id);
VALA_EXTERN gboolean nibbles_game_keypress (NibblesGame* self,
                                guint keyval,
                                guint keycode,
                                gboolean* remove_handler);
static gboolean _nibbles_game_keypress_keypress_handler_function (guint a,
                                                           guint b,
                                                           gboolean* remove_handler,
                                                           gpointer self);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
VALA_EXTERN gboolean nibbles_game_load_board (NibblesGame* self,
                                  gchar** future_board,
                                  gint future_board_length1,
                                  guint8 regular_bonus);
VALA_EXTERN gint nibbles_game_get_numworms (NibblesGame* self);
VALA_EXTERN guint8 nibbles_game_get_height (NibblesGame* self);
static void nibbles_game_bonuses_reset (NibblesGameBonuses* self,
                                 guint8 regular_bonus);
VALA_EXTERN void warp_manager_clear_warps (WarpManager* self);
VALA_EXTERN guint8 nibbles_game_get_width (NibblesGame* self);
VALA_EXTERN GeeLinkedList* nibbles_game_get_worms (NibblesGame* self);
VALA_EXTERN GType worm_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void worm_set_start (Worm* self,
                     guint8 x,
                     guint8 y,
                     WormDirection direction);
VALA_EXTERN void warp_manager_add_warp_source (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y,
                                   gboolean random);
VALA_EXTERN void warp_manager_add_warp_target (WarpManager* self,
                                   gint id,
                                   guint8 x,
                                   guint8 y);
VALA_EXTERN void warp_manager_initilise (WarpManager* self,
                             gint* board,
                             gint board_length1,
                             gint board_length2);
VALA_EXTERN void nibbles_game_start (NibblesGame* self,
                         gboolean add_initial_bonus);
static void nibbles_game_add_bonus (NibblesGame* self,
                             gboolean regular);
static void nibbles_game_set_is_running (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_speed (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_gamedelay (NibblesGame* self);
static gboolean __lambda6_ (NibblesGame* self);
static gboolean nibbles_game_main_loop_cb (NibblesGame* self);
static gboolean ___lambda6__gsource_func (gpointer self);
VALA_EXTERN void nibbles_game_stop (NibblesGame* self);
VALA_EXTERN void nibbles_game_reset (NibblesGame* self,
                         gint start_level);
VALA_EXTERN void nibbles_game_set_skip_score (NibblesGame* self,
                                  gboolean value);
VALA_EXTERN gint nibbles_game_get_progress (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_current_level (NibblesGame* self,
                                     gint value);
static void _vala_array_add2 (gint* * array,
                       gint* length,
                       gint* size,
                       gint value);
static gint nibbles_game_remove_one_uncompleated_level (NibblesGame* self);
static void nibbles_game_set_is_paused (NibblesGame* self,
                                 gboolean value);
static void nibbles_game_end (NibblesGame* self);
VALA_EXTERN NibblesGameeStatus* nibbles_game_get_game_status (NibblesGame* self);
static gboolean _nibbles_game_estatus_equal (const NibblesGameeStatus * s1,
                                      const NibblesGameeStatus * s2);
VALA_EXTERN gint worm_get_score (Worm* self);
VALA_EXTERN gint nibbles_game_get_current_level (NibblesGame* self);
VALA_EXTERN Worm* nibbles_game_get_winner (NibblesGame* self);
static void nibbles_game_move_worms (NibblesGame* self);
VALA_EXTERN void nibbles_game_create_worms (NibblesGame* self,
                                GeeArrayList* worm_settings);
VALA_EXTERN gint nibbles_game_get_numai (NibblesGame* self);
VALA_EXTERN gint nibbles_game_get_numhumans (NibblesGame* self);
static void nibbles_game_set_numworms (NibblesGame* self,
                                gint value);
static GeeList* nibbles_game_get_other_worms (NibblesGame* self,
                                       Worm* _self_);
static GeeList* _nibbles_game_get_other_worms_worm_get_other_worms_type (Worm* _self_,
                                                                  gpointer self);
VALA_EXTERN GeeList* nibbles_game_get_bonuses (NibblesGame* self);
static GeeList* _nibbles_game_get_bonuses_worm_get_bonuses_type (gpointer self);
VALA_EXTERN Worm* worm_new (gint id,
                guint8 width,
                guint8 height,
                WormGetOtherWormsType cb0,
                gpointer cb0_target,
                WormGetBonusesType cb1,
                gpointer cb1_target);
VALA_EXTERN Worm* worm_construct (GType object_type,
                      gint id,
                      guint8 width,
                      guint8 height,
                      WormGetOtherWormsType cb0,
                      gpointer cb0_target,
                      WormGetBonusesType cb1,
                      gpointer cb1_target);
static void nibbles_game_bonus_found_cb (NibblesGame* self,
                                  Worm* worm);
static void _nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                                    gpointer self);
VALA_EXTERN GType position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN Position* position_dup (const Position* self);
VALA_EXTERN void position_free (Position* self);
VALA_EXTERN GType worm_positions_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (WormPositions, g_object_unref)
VALA_EXTERN void nibbles_game_load_worm_properties (NibblesGame* self,
                                        GeeArrayList* worm_settings);
VALA_EXTERN void nibbles_game_add_worms (NibblesGame* self);
VALA_EXTERN void worm_spawn (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static inline gboolean nibbles_game_bonuses_too_many_missed (NibblesGameBonuses* self);
VALA_EXTERN void worm_set_score (Worm* self,
                     gint value);
static void nibbles_game_bonuses_on_worms_move (NibblesGameBonuses* self,
                                         guint8* missed_bonuses_to_replace);
VALA_EXTERN void worm_human_move (Worm* self,
                      gint* board,
                      gint board_length1,
                      gint board_length2,
                      GeeLinkedList* worms);
VALA_EXTERN void worm_ai_move (Worm* self,
                   gint* board,
                   gint board_length1,
                   gint board_length2,
                   GeeLinkedList* worms);
VALA_EXTERN void worm_position_move (Worm* self,
                         Position* result);
VALA_EXTERN gboolean warp_manager_get_warp_target (WarpManager* self,
                                       guint8 x,
                                       guint8 y,
                                       WormDirection worm_direction,
                                       gint worm_length,
                                       gboolean ai_worm,
                                       GeeLinkedList* worms,
                                       guint8* target_x,
                                       guint8* target_y,
                                       gboolean* bonus);
VALA_EXTERN WormDirection worm_get_direction (Worm* self);
VALA_EXTERN gint worm_get_length (Worm* self);
VALA_EXTERN gboolean worm_can_move_to (Worm* self,
                           gint* board,
                           gint board_length1,
                           gint board_length2,
                           GeeList* worms,
                           Position* position);
VALA_EXTERN void worm_move_part_1 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2);
VALA_EXTERN void worm_get_head (Worm* self,
                    Position * result);
VALA_EXTERN void worm_move_part_2 (Worm* self,
                       gint* board,
                       gint board_length1,
                       gint board_length2,
                       Position* head_position);
static void nibbles_game_bonuses_decrement_regular_bonus (NibblesGameBonuses* self,
                                                   gint d);
static GeeHashMap* nibbles_game_get_score_deltas (NibblesGame* self);
static gint nibbles_game_score_delta_get_score_delta (NibblesGameScoreDelta* self);
static Worm* nibbles_game_score_delta_get_worm (NibblesGameScoreDelta* self);
VALA_EXTERN GType bonus_etype_get_type (void) G_GNUC_CONST ;
VALA_EXTERN BonuseType bonus_get_etype (Bonus* self);
VALA_EXTERN gboolean bonus_get_fake (Bonus* self);
static void nibbles_game_bonuses_remove_bonus (NibblesGameBonuses* self,
                                        Bonus* bonus);
static inline gboolean nibbles_game_bonuses_last_regular_bonus (NibblesGameBonuses* self);
VALA_EXTERN guint8 worm_get_lives (Worm* self);
VALA_EXTERN void worm_reset (Worm* self,
                 gint* board,
                 gint board_length1,
                 gint board_length2);
static void nibbles_game_reverse_worms (NibblesGame* self,
                                 Worm* worm);
VALA_EXTERN void worm_reverse (Worm* self);
static gboolean nibbles_game_is_space_empty (NibblesGame* self,
                                      guint8 x,
                                      guint8 y,
                                      gboolean* worms_at,
                                      gint worms_at_length1,
                                      gint worms_at_length2);
static Bonus* nibbles_game_bonuses_get_bonus (NibblesGameBonuses* self,
                                       guint8 x,
                                       guint8 y);
VALA_EXTERN gboolean nibbles_game_get_fakes (NibblesGame* self);
static inline void _nibbles_game_add_bonus (NibblesGame* self,
                              guint8 x,
                              guint8 y,
                              BonuseType bonus_type,
                              gboolean fake,
                              guint16 countdown);
VALA_EXTERN Bonus* bonus_new (guint8 x,
                  guint8 y,
                  GType type,
                  gboolean fake,
                  guint16 countdown);
VALA_EXTERN Bonus* bonus_construct (GType object_type,
                        guint8 x,
                        guint8 y,
                        GType type,
                        gboolean fake,
                        guint16 countdown);
static gboolean nibbles_game_bonuses_add_bonus (NibblesGameBonuses* self,
                                         Bonus* bonus);
static gint nibbles_game_calculate_bonus (NibblesGame* self,
                                   Bonus* bonus,
                                   Worm* worm);
static guint8 nibbles_game_bonuses_new_regular_bonus_eaten (NibblesGameBonuses* self);
VALA_EXTERN gint worm_get_change (Worm* self);
VALA_EXTERN void worm_set_change (Worm* self,
                      gint value);
VALA_EXTERN void worm_reduce_tail (Worm* self,
                       gint erase_size);
VALA_EXTERN void worm_add_life (Worm* self);
VALA_EXTERN void worm_add_bonus_eaten_position (Worm* self,
                                    guint8 x,
                                    guint8 y);
static NibblesGameScoreDelta* nibbles_game_score_delta_new (Worm* worm,
                                                     gint score_delta);
static NibblesGameScoreDelta* nibbles_game_score_delta_construct (GType object_type,
                                                           Worm* worm,
                                                           gint score_delta);
static NibblesGameeStatus* _nibbles_game_estatus_dup (NibblesGameeStatus* self);
VALA_EXTERN guint nibbles_game_humans_left (NibblesGame* self);
static gboolean __lambda7_ (NibblesGame* self,
                     GValue* value,
                     GVariant* variant,
                     void* data);
static inline gint nibbles_game_get_color_num (const gchar* color);
static gboolean ___lambda7___localfunc0_ (GValue* value,
                                   GVariant* variant,
                                   void* data,
                                   gpointer self);
static GVariant* __lambda8_ (NibblesGame* self,
                      GValue* value,
                      const GVariantType* type,
                      void* data);
static inline gchar* nibbles_game_get_color_string (gint color);
static GVariant* ___lambda8___localfunc1_ (GValue* value,
                                    const GVariantType* type,
                                    void* data,
                                    gpointer self);
VALA_EXTERN GeeHashMap* nibbles_game_get_worm_props (NibblesGame* self);
VALA_EXTERN WormProperties* worm_properties_new (void);
VALA_EXTERN WormProperties* worm_properties_construct (GType object_type);
VALA_EXTERN gint worm_get_id (Worm* self);
VALA_EXTERN gboolean nibbles_game_handle_keypress (NibblesGame* self,
                                       guint keyval,
                                       guint keycode);
VALA_EXTERN gboolean nibbles_game_get_is_running (NibblesGame* self);
VALA_EXTERN gboolean worm_handle_keypress (Worm* self,
                               guint keycode,
                               GeeHashMap* worm_props);
static GeeList* nibbles_game_bonuses_get_bonuses (NibblesGameBonuses* self);
VALA_EXTERN gboolean nibbles_game_get_skip_score (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_three_dimensional_view (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                              gboolean value);
VALA_EXTERN void nibbles_game_set_speed (NibblesGame* self,
                             gint value);
static void nibbles_game_set_gamedelay (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_progress (NibblesGame* self,
                                gint value);
VALA_EXTERN gint nibbles_game_get_start_level (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_start_level (NibblesGame* self,
                                   gint value);
static void nibbles_game_set_width (NibblesGame* self,
                             guint8 value);
static void nibbles_game_set_height (NibblesGame* self,
                              guint8 value);
VALA_EXTERN void nibbles_game_set_numhumans (NibblesGame* self,
                                 gint value);
VALA_EXTERN void nibbles_game_set_numai (NibblesGame* self,
                             gint value);
static gboolean nibbles_game_get_is_paused (NibblesGame* self);
VALA_EXTERN gboolean nibbles_game_get_paused (NibblesGame* self);
VALA_EXTERN void nibbles_game_set_paused (NibblesGame* self,
                              gboolean value);
VALA_EXTERN void nibbles_game_set_fakes (NibblesGame* self,
                             gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_INT (GClosure * closure,
                                                      GValue * return_value,
                                                      guint n_param_values,
                                                      const GValue * param_values,
                                                      gpointer invocation_hint,
                                                      gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void g_cclosure_user_marshal_STRING__VOID (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static inline void nibbles_game_bonuses_reset_missed (NibblesGameBonuses* self);
VALA_EXTERN guint8 bonus_get_x (Bonus* self);
VALA_EXTERN guint8 bonus_get_y (Bonus* self);
VALA_EXTERN guint16 bonus_get_countdown (Bonus* self);
VALA_EXTERN void bonus_set_countdown (Bonus* self,
                          guint16 value);
static inline void nibbles_game_bonuses_increase_missed (NibblesGameBonuses* self);
static void nibbles_game_bonuses_finalize (GObject * obj);
static GType nibbles_game_bonuses_get_type_once (void);
static void nibbles_game_score_delta_set_worm (NibblesGameScoreDelta* self,
                                        Worm* value);
static void nibbles_game_score_delta_set_score_delta (NibblesGameScoreDelta* self,
                                               gint value);
static void nibbles_game_score_delta_finalize (GObject * obj);
static GType nibbles_game_score_delta_get_type_once (void);
static void _vala_nibbles_game_score_delta_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_nibbles_game_score_delta_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);
static GObject * nibbles_game_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void _nibbles_game___lambda9_ (NibblesGame* self,
                               Bonus* bonus);
static void __nibbles_game___lambda9__nibbles_game_bonuses_bonus_removed (NibblesGameBonuses* _sender,
                                                                   Bonus* bonus,
                                                                   gpointer self);
static void nibbles_game_finalize (GObject * obj);
static GType nibbles_game_get_type_once (void);
static void _vala_nibbles_game_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_nibbles_game_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static void _vala_array_move (gpointer array,
                       gsize element_size,
                       gssize src,
                       gssize dest,
                       gssize length);

static inline gpointer
nibbles_game_get_instance_private (NibblesGame* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGame_private_offset);
}

 G_GNUC_NO_INLINE static GType
nibbles_game_estatus_get_type_once (void)
{
	static const GEnumValue values[] = {{NIBBLES_GAME_ESTATUS_GAMEOVER, "NIBBLES_GAME_ESTATUS_GAMEOVER", "gameover"}, {NIBBLES_GAME_ESTATUS_VICTORY, "NIBBLES_GAME_ESTATUS_VICTORY", "victory"}, {NIBBLES_GAME_ESTATUS_NEWROUND, "NIBBLES_GAME_ESTATUS_NEWROUND", "newround"}, {0, NULL, NULL}};
	GType nibbles_game_estatus_type_id;
	nibbles_game_estatus_type_id = g_enum_register_static ("NibblesGameeStatus", values);
	return nibbles_game_estatus_type_id;
}

GType
nibbles_game_estatus_get_type (void)
{
	static gsize nibbles_game_estatus_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_estatus_type_id__once)) {
		GType nibbles_game_estatus_type_id;
		nibbles_game_estatus_type_id = nibbles_game_estatus_get_type_once ();
		g_once_init_leave (&nibbles_game_estatus_type_id__once, nibbles_game_estatus_type_id);
	}
	return nibbles_game_estatus_type_id__once;
}

NibblesGame*
nibbles_game_construct (GType object_type,
                        gint start_level,
                        gint speed,
                        gint gamedelay,
                        gboolean fakes,
                        gboolean three_dimensional_view,
                        guint8 width,
                        guint8 height,
                        gboolean no_random)
{
	NibblesGame * self = NULL;
	guint32 _tmp0_ = 0U;
#line 255 "../src/nibbles-game.vala"
	self = (NibblesGame*) g_object_new (object_type, "skip-score", start_level != 1, "current-level", start_level, "speed", speed, "gamedelay", gamedelay, "fakes", fakes, "three-dimensional-view", three_dimensional_view, "width", width, "height", height, NULL);
#line 256 "../src/nibbles-game.vala"
	if (no_random) {
#line 256 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) 42;
#line 812 "nibbles-game.c"
	} else {
		time_t _tmp1_;
#line 256 "../src/nibbles-game.vala"
		_tmp1_ = time (NULL);
#line 256 "../src/nibbles-game.vala"
		_tmp0_ = (guint32) _tmp1_;
#line 819 "nibbles-game.c"
	}
#line 256 "../src/nibbles-game.vala"
	g_random_set_seed (_tmp0_);
#line 253 "../src/nibbles-game.vala"
	return self;
#line 825 "nibbles-game.c"
}

NibblesGame*
nibbles_game_new (gint start_level,
                  gint speed,
                  gint gamedelay,
                  gboolean fakes,
                  gboolean three_dimensional_view,
                  guint8 width,
                  guint8 height,
                  gboolean no_random)
{
#line 253 "../src/nibbles-game.vala"
	return nibbles_game_construct (TYPE_NIBBLES_GAME, start_level, speed, gamedelay, fakes, three_dimensional_view, width, height, no_random);
#line 840 "nibbles-game.c"
}

static gboolean
_nibbles_game_keypress_keypress_handler_function (guint a,
                                                  guint b,
                                                  gboolean* remove_handler,
                                                  gpointer self)
{
	gboolean result;
	result = nibbles_game_keypress ((NibblesGame*) self, a, b, remove_handler);
#line 268 "../src/nibbles-game.vala"
	return result;
#line 853 "nibbles-game.c"
}

static gchar*
g_file_stream_read_line (FILE* self)
{
	gint c = 0;
	GString* ret = NULL;
	GString* _tmp3_;
	gchar* result;
#line 4109 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 4111 "glib-2.0.vapi"
	ret = NULL;
#line 4112 "glib-2.0.vapi"
	while (TRUE) {
#line 869 "nibbles-game.c"
		GString* _tmp0_;
		GString* _tmp2_;
#line 4112 "glib-2.0.vapi"
		c = fgetc (self);
#line 4112 "glib-2.0.vapi"
		if (!(c != EOF)) {
#line 4112 "glib-2.0.vapi"
			break;
#line 878 "nibbles-game.c"
		}
#line 4113 "glib-2.0.vapi"
		_tmp0_ = ret;
#line 4113 "glib-2.0.vapi"
		if (_tmp0_ == NULL) {
#line 884 "nibbles-game.c"
			GString* _tmp1_;
#line 4114 "glib-2.0.vapi"
			_tmp1_ = g_string_new ("");
#line 4114 "glib-2.0.vapi"
			_g_string_free0 (ret);
#line 4114 "glib-2.0.vapi"
			ret = _tmp1_;
#line 892 "nibbles-game.c"
		}
#line 4116 "glib-2.0.vapi"
		if (c == ((gint) '\n')) {
#line 4117 "glib-2.0.vapi"
			break;
#line 898 "nibbles-game.c"
		}
#line 4119 "glib-2.0.vapi"
		_tmp2_ = ret;
#line 4119 "glib-2.0.vapi"
		g_string_append_c ((GString*) _tmp2_, (gchar) c);
#line 904 "nibbles-game.c"
	}
#line 4121 "glib-2.0.vapi"
	_tmp3_ = ret;
#line 4121 "glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 4122 "glib-2.0.vapi"
		result = NULL;
#line 4122 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4122 "glib-2.0.vapi"
		return result;
#line 916 "nibbles-game.c"
	} else {
		GString* _tmp4_;
		gchar* _tmp5_;
#line 4124 "glib-2.0.vapi"
		_tmp4_ = ret;
#line 4124 "glib-2.0.vapi"
		_tmp5_ = ((GString*) _tmp4_)->str;
#line 4124 "glib-2.0.vapi"
		((GString*) _tmp4_)->str = NULL;
#line 4124 "glib-2.0.vapi"
		result = _tmp5_;
#line 4124 "glib-2.0.vapi"
		_g_string_free0 (ret);
#line 4124 "glib-2.0.vapi"
		return result;
#line 932 "nibbles-game.c"
	}
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 280 "../src/nibbles-game.vala"
	if ((*length) == (*size)) {
#line 280 "../src/nibbles-game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 280 "../src/nibbles-game.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 948 "nibbles-game.c"
	}
#line 280 "../src/nibbles-game.vala"
	(*array)[(*length)++] = value;
#line 280 "../src/nibbles-game.vala"
	(*array)[*length] = NULL;
#line 954 "nibbles-game.c"
}

void
nibbles_game_new_level (NibblesGame* self,
                        gint level_id)
{
	gchar* level_name = NULL;
	gchar* _tmp1_;
	gchar* filename = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	FILE* file = NULL;
	FILE* _tmp6_;
	gchar* line = NULL;
	gchar** board = NULL;
	gchar** _tmp7_;
	gint board_length1;
	gint _board_size_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint _tmp13_;
#line 264 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 267 "../src/nibbles-game.vala"
	if (!self->added_keypress_handler) {
#line 982 "nibbles-game.c"
		gboolean _tmp0_ = FALSE;
#line 268 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL], 0, _nibbles_game_keypress_keypress_handler_function, self, &_tmp0_);
#line 268 "../src/nibbles-game.vala"
		self->added_keypress_handler = _tmp0_;
#line 988 "nibbles-game.c"
	}
#line 270 "../src/nibbles-game.vala"
	_tmp1_ = g_strdup_printf ("level%03d.gnl", level_id);
#line 270 "../src/nibbles-game.vala"
	level_name = _tmp1_;
#line 271 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_GET_PKGDATADIR_SIGNAL], 0, &_tmp2_);
#line 271 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 271 "../src/nibbles-game.vala"
	_tmp4_ = g_build_filename (_tmp3_, "levels", level_name, NULL, NULL);
#line 271 "../src/nibbles-game.vala"
	_tmp5_ = _tmp4_;
#line 271 "../src/nibbles-game.vala"
	_g_free0 (_tmp3_);
#line 271 "../src/nibbles-game.vala"
	filename = _tmp5_;
#line 274 "../src/nibbles-game.vala"
	_tmp6_ = g_fopen (filename, "r");
#line 274 "../src/nibbles-game.vala"
	_fclose0 (file);
#line 274 "../src/nibbles-game.vala"
	file = _tmp6_;
#line 274 "../src/nibbles-game.vala"
	if (file == NULL) {
#line 275 "../src/nibbles-game.vala"
		g_error ("nibbles-game.vala:275: Nibbles couldn't find pixmap file: %s", filename);
#line 1016 "nibbles-game.c"
	}
#line 278 "../src/nibbles-game.vala"
	_tmp7_ = g_new0 (gchar*, 0 + 1);
#line 278 "../src/nibbles-game.vala"
	board = _tmp7_;
#line 278 "../src/nibbles-game.vala"
	board_length1 = 0;
#line 278 "../src/nibbles-game.vala"
	_board_size_ = board_length1;
#line 279 "../src/nibbles-game.vala"
	while (TRUE) {
#line 1028 "nibbles-game.c"
		gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 279 "../src/nibbles-game.vala"
		_tmp8_ = g_file_stream_read_line (file);
#line 279 "../src/nibbles-game.vala"
		_g_free0 (line);
#line 279 "../src/nibbles-game.vala"
		line = _tmp8_;
#line 279 "../src/nibbles-game.vala"
		_tmp9_ = line;
#line 279 "../src/nibbles-game.vala"
		if (!(_tmp9_ != NULL)) {
#line 279 "../src/nibbles-game.vala"
			break;
#line 1045 "nibbles-game.c"
		}
#line 280 "../src/nibbles-game.vala"
		_tmp10_ = line;
#line 280 "../src/nibbles-game.vala"
		_tmp11_ = g_strdup ((const gchar*) _tmp10_);
#line 280 "../src/nibbles-game.vala"
		_vala_array_add1 (&board, &board_length1, &_board_size_, _tmp11_);
#line 1053 "nibbles-game.c"
	}
#line 281 "../src/nibbles-game.vala"
	_tmp12_ = board;
#line 281 "../src/nibbles-game.vala"
	_tmp12__length1 = board_length1;
#line 281 "../src/nibbles-game.vala"
	_tmp13_ = self->priv->_numworms;
#line 281 "../src/nibbles-game.vala"
	if (!nibbles_game_load_board (self, _tmp12_, (gint) _tmp12__length1, (guint8) (8 + _tmp13_))) {
#line 282 "../src/nibbles-game.vala"
		g_error ("nibbles-game.vala:282: Level file appears to be damaged: %s", filename);
#line 1065 "nibbles-game.c"
	}
#line 264 "../src/nibbles-game.vala"
	board = (_vala_array_free (board, board_length1, (GDestroyNotify) g_free), NULL);
#line 264 "../src/nibbles-game.vala"
	_g_free0 (line);
#line 264 "../src/nibbles-game.vala"
	_fclose0 (file);
#line 264 "../src/nibbles-game.vala"
	_g_free0 (filename);
#line 264 "../src/nibbles-game.vala"
	_g_free0 (level_name);
#line 1077 "nibbles-game.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result;
#line 1313 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1314 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1314 "glib-2.0.vapi"
	return result;
#line 1091 "nibbles-game.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gchar* _tmp0_;
	gint result;
#line 1333 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1334 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1334 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1334 "glib-2.0.vapi"
	return result;
#line 1108 "nibbles-game.c"
}

gboolean
nibbles_game_load_board (NibblesGame* self,
                         gchar** future_board,
                         gint future_board_length1,
                         guint8 regular_bonus)
{
	guint8 _tmp0_;
	NibblesGameBonuses* _tmp1_;
	WarpManager* _tmp2_;
	gchar* tmpboard = NULL;
	gint count = 0;
	WarpManager* _tmp63_;
	gint* _tmp64_;
	gint _tmp64__length1;
	gint _tmp64__length2;
	gboolean result;
#line 285 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 287 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_height;
#line 287 "../src/nibbles-game.vala"
	if (future_board_length1 != ((gint) _tmp0_)) {
#line 288 "../src/nibbles-game.vala"
		result = FALSE;
#line 288 "../src/nibbles-game.vala"
		return result;
#line 1137 "nibbles-game.c"
	}
#line 290 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->bonuses;
#line 290 "../src/nibbles-game.vala"
	nibbles_game_bonuses_reset (_tmp1_, regular_bonus);
#line 291 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->warp_manager;
#line 291 "../src/nibbles-game.vala"
	warp_manager_clear_warps (_tmp2_);
#line 294 "../src/nibbles-game.vala"
	count = 0;
#line 1149 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 295 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 1154 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 295 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 295 "../src/nibbles-game.vala"
			while (TRUE) {
#line 1161 "nibbles-game.c"
				guint8 _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				const gchar* _tmp8_;
				guint8 _tmp9_;
#line 295 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 1169 "nibbles-game.c"
					guint8 _tmp4_;
#line 295 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 295 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 1175 "nibbles-game.c"
				}
#line 295 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 295 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_height;
#line 295 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 295 "../src/nibbles-game.vala"
					break;
#line 1185 "nibbles-game.c"
				}
#line 297 "../src/nibbles-game.vala"
				_tmp6_ = future_board[i];
#line 297 "../src/nibbles-game.vala"
				_tmp7_ = g_strdup (_tmp6_);
#line 297 "../src/nibbles-game.vala"
				_g_free0 (tmpboard);
#line 297 "../src/nibbles-game.vala"
				tmpboard = _tmp7_;
#line 298 "../src/nibbles-game.vala"
				_tmp8_ = tmpboard;
#line 298 "../src/nibbles-game.vala"
				_tmp9_ = self->priv->_width;
#line 298 "../src/nibbles-game.vala"
				if (g_utf8_strlen (_tmp8_, (gssize) -1) != ((gint) _tmp9_)) {
#line 299 "../src/nibbles-game.vala"
					result = FALSE;
#line 299 "../src/nibbles-game.vala"
					_g_free0 (tmpboard);
#line 299 "../src/nibbles-game.vala"
					return result;
#line 1207 "nibbles-game.c"
				}
				{
					guint8 j = 0U;
#line 300 "../src/nibbles-game.vala"
					j = (guint8) 0;
#line 1213 "nibbles-game.c"
					{
						gboolean _tmp10_ = FALSE;
#line 300 "../src/nibbles-game.vala"
						_tmp10_ = TRUE;
#line 300 "../src/nibbles-game.vala"
						while (TRUE) {
#line 1220 "nibbles-game.c"
							guint8 _tmp12_;
							gunichar char_value = 0U;
							const gchar* _tmp13_;
							const gchar* _tmp14_;
#line 300 "../src/nibbles-game.vala"
							if (!_tmp10_) {
#line 1227 "nibbles-game.c"
								guint8 _tmp11_;
#line 300 "../src/nibbles-game.vala"
								_tmp11_ = j;
#line 300 "../src/nibbles-game.vala"
								j = _tmp11_ + 1;
#line 1233 "nibbles-game.c"
							}
#line 300 "../src/nibbles-game.vala"
							_tmp10_ = FALSE;
#line 300 "../src/nibbles-game.vala"
							_tmp12_ = self->priv->_width;
#line 300 "../src/nibbles-game.vala"
							if (!(j < _tmp12_)) {
#line 300 "../src/nibbles-game.vala"
								break;
#line 1243 "nibbles-game.c"
							}
#line 302 "../src/nibbles-game.vala"
							_tmp13_ = tmpboard;
#line 302 "../src/nibbles-game.vala"
							_tmp14_ = tmpboard;
#line 302 "../src/nibbles-game.vala"
							char_value = string_get_char (_tmp13_, (glong) string_index_of_nth_char (_tmp14_, (glong) j));
#line 303 "../src/nibbles-game.vala"
							switch (char_value) {
#line 303 "../src/nibbles-game.vala"
								case '.':
#line 303 "../src/nibbles-game.vala"
								case '+':
#line 1257 "nibbles-game.c"
								{
									gint* _tmp15_;
									gint _tmp15__length1;
									gint _tmp15__length2;
#line 308 "../src/nibbles-game.vala"
									_tmp15_ = self->board;
#line 308 "../src/nibbles-game.vala"
									_tmp15__length1 = self->board_length1;
#line 308 "../src/nibbles-game.vala"
									_tmp15__length2 = self->board_length2;
#line 308 "../src/nibbles-game.vala"
									_tmp15_[(j * _tmp15__length2) + i] = (gint) 'a';
#line 309 "../src/nibbles-game.vala"
									break;
#line 1272 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9475U:
#line 1276 "nibbles-game.c"
								{
									gint* _tmp16_;
									gint _tmp16__length1;
									gint _tmp16__length2;
#line 313 "../src/nibbles-game.vala"
									_tmp16_ = self->board;
#line 313 "../src/nibbles-game.vala"
									_tmp16__length1 = self->board_length1;
#line 313 "../src/nibbles-game.vala"
									_tmp16__length2 = self->board_length2;
#line 313 "../src/nibbles-game.vala"
									_tmp16_[(j * _tmp16__length2) + i] = (gint) 'b';
#line 314 "../src/nibbles-game.vala"
									break;
#line 1291 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9473U:
#line 1295 "nibbles-game.c"
								{
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
#line 316 "../src/nibbles-game.vala"
									_tmp17_ = self->board;
#line 316 "../src/nibbles-game.vala"
									_tmp17__length1 = self->board_length1;
#line 316 "../src/nibbles-game.vala"
									_tmp17__length2 = self->board_length2;
#line 316 "../src/nibbles-game.vala"
									_tmp17_[(j * _tmp17__length2) + i] = (gint) 'c';
#line 317 "../src/nibbles-game.vala"
									break;
#line 1310 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9495U:
#line 1314 "nibbles-game.c"
								{
									gint* _tmp18_;
									gint _tmp18__length1;
									gint _tmp18__length2;
#line 319 "../src/nibbles-game.vala"
									_tmp18_ = self->board;
#line 319 "../src/nibbles-game.vala"
									_tmp18__length1 = self->board_length1;
#line 319 "../src/nibbles-game.vala"
									_tmp18__length2 = self->board_length2;
#line 319 "../src/nibbles-game.vala"
									_tmp18_[(j * _tmp18__length2) + i] = (gint) 'd';
#line 320 "../src/nibbles-game.vala"
									break;
#line 1329 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9499U:
#line 1333 "nibbles-game.c"
								{
									gint* _tmp19_;
									gint _tmp19__length1;
									gint _tmp19__length2;
#line 322 "../src/nibbles-game.vala"
									_tmp19_ = self->board;
#line 322 "../src/nibbles-game.vala"
									_tmp19__length1 = self->board_length1;
#line 322 "../src/nibbles-game.vala"
									_tmp19__length2 = self->board_length2;
#line 322 "../src/nibbles-game.vala"
									_tmp19_[(j * _tmp19__length2) + i] = (gint) 'e';
#line 323 "../src/nibbles-game.vala"
									break;
#line 1348 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9487U:
#line 1352 "nibbles-game.c"
								{
									gint* _tmp20_;
									gint _tmp20__length1;
									gint _tmp20__length2;
#line 325 "../src/nibbles-game.vala"
									_tmp20_ = self->board;
#line 325 "../src/nibbles-game.vala"
									_tmp20__length1 = self->board_length1;
#line 325 "../src/nibbles-game.vala"
									_tmp20__length2 = self->board_length2;
#line 325 "../src/nibbles-game.vala"
									_tmp20_[(j * _tmp20__length2) + i] = (gint) 'f';
#line 326 "../src/nibbles-game.vala"
									break;
#line 1367 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9491U:
#line 1371 "nibbles-game.c"
								{
									gint* _tmp21_;
									gint _tmp21__length1;
									gint _tmp21__length2;
#line 328 "../src/nibbles-game.vala"
									_tmp21_ = self->board;
#line 328 "../src/nibbles-game.vala"
									_tmp21__length1 = self->board_length1;
#line 328 "../src/nibbles-game.vala"
									_tmp21__length2 = self->board_length2;
#line 328 "../src/nibbles-game.vala"
									_tmp21_[(j * _tmp21__length2) + i] = (gint) 'g';
#line 329 "../src/nibbles-game.vala"
									break;
#line 1386 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9531U:
#line 1390 "nibbles-game.c"
								{
									gint* _tmp22_;
									gint _tmp22__length1;
									gint _tmp22__length2;
#line 331 "../src/nibbles-game.vala"
									_tmp22_ = self->board;
#line 331 "../src/nibbles-game.vala"
									_tmp22__length1 = self->board_length1;
#line 331 "../src/nibbles-game.vala"
									_tmp22__length2 = self->board_length2;
#line 331 "../src/nibbles-game.vala"
									_tmp22_[(j * _tmp22__length2) + i] = (gint) 'h';
#line 332 "../src/nibbles-game.vala"
									break;
#line 1405 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9507U:
#line 1409 "nibbles-game.c"
								{
									gint* _tmp23_;
									gint _tmp23__length1;
									gint _tmp23__length2;
#line 334 "../src/nibbles-game.vala"
									_tmp23_ = self->board;
#line 334 "../src/nibbles-game.vala"
									_tmp23__length1 = self->board_length1;
#line 334 "../src/nibbles-game.vala"
									_tmp23__length2 = self->board_length2;
#line 334 "../src/nibbles-game.vala"
									_tmp23_[(j * _tmp23__length2) + i] = (gint) 'i';
#line 335 "../src/nibbles-game.vala"
									break;
#line 1424 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9515U:
#line 1428 "nibbles-game.c"
								{
									gint* _tmp24_;
									gint _tmp24__length1;
									gint _tmp24__length2;
#line 337 "../src/nibbles-game.vala"
									_tmp24_ = self->board;
#line 337 "../src/nibbles-game.vala"
									_tmp24__length1 = self->board_length1;
#line 337 "../src/nibbles-game.vala"
									_tmp24__length2 = self->board_length2;
#line 337 "../src/nibbles-game.vala"
									_tmp24_[(j * _tmp24__length2) + i] = (gint) 'j';
#line 338 "../src/nibbles-game.vala"
									break;
#line 1443 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9523U:
#line 1447 "nibbles-game.c"
								{
									gint* _tmp25_;
									gint _tmp25__length1;
									gint _tmp25__length2;
#line 340 "../src/nibbles-game.vala"
									_tmp25_ = self->board;
#line 340 "../src/nibbles-game.vala"
									_tmp25__length1 = self->board_length1;
#line 340 "../src/nibbles-game.vala"
									_tmp25__length2 = self->board_length2;
#line 340 "../src/nibbles-game.vala"
									_tmp25_[(j * _tmp25__length2) + i] = (gint) 'k';
#line 341 "../src/nibbles-game.vala"
									break;
#line 1462 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9547U:
#line 1466 "nibbles-game.c"
								{
									gint* _tmp26_;
									gint _tmp26__length1;
									gint _tmp26__length2;
#line 343 "../src/nibbles-game.vala"
									_tmp26_ = self->board;
#line 343 "../src/nibbles-game.vala"
									_tmp26__length1 = self->board_length1;
#line 343 "../src/nibbles-game.vala"
									_tmp26__length2 = self->board_length2;
#line 343 "../src/nibbles-game.vala"
									_tmp26_[(j * _tmp26__length2) + i] = (gint) 'l';
#line 344 "../src/nibbles-game.vala"
									break;
#line 1481 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9650U:
#line 303 "../src/nibbles-game.vala"
								case 'm':
#line 1487 "nibbles-game.c"
								{
									gint* _tmp27_;
									gint _tmp27__length1;
									gint _tmp27__length2;
									gint _tmp28_;
#line 349 "../src/nibbles-game.vala"
									_tmp27_ = self->board;
#line 349 "../src/nibbles-game.vala"
									_tmp27__length1 = self->board_length1;
#line 349 "../src/nibbles-game.vala"
									_tmp27__length2 = self->board_length2;
#line 349 "../src/nibbles-game.vala"
									_tmp27_[(j * _tmp27__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 350 "../src/nibbles-game.vala"
									_tmp28_ = self->priv->_numworms;
#line 350 "../src/nibbles-game.vala"
									if (count < _tmp28_) {
#line 1505 "nibbles-game.c"
										GeeLinkedList* _tmp29_;
										gpointer _tmp30_;
										Worm* _tmp31_;
										gint _tmp32_;
#line 352 "../src/nibbles-game.vala"
										_tmp29_ = self->priv->_worms;
#line 352 "../src/nibbles-game.vala"
										_tmp30_ = gee_abstract_list_get ((GeeAbstractList*) _tmp29_, count);
#line 352 "../src/nibbles-game.vala"
										_tmp31_ = (Worm*) _tmp30_;
#line 352 "../src/nibbles-game.vala"
										worm_set_start (_tmp31_, j, i, WORM_DIRECTION_UP);
#line 352 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp31_);
#line 353 "../src/nibbles-game.vala"
										_tmp32_ = count;
#line 353 "../src/nibbles-game.vala"
										count = _tmp32_ + 1;
#line 1524 "nibbles-game.c"
									}
#line 355 "../src/nibbles-game.vala"
									break;
#line 1528 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9664U:
#line 303 "../src/nibbles-game.vala"
								case 'n':
#line 1534 "nibbles-game.c"
								{
									gint* _tmp33_;
									gint _tmp33__length1;
									gint _tmp33__length2;
									gint _tmp34_;
#line 358 "../src/nibbles-game.vala"
									_tmp33_ = self->board;
#line 358 "../src/nibbles-game.vala"
									_tmp33__length1 = self->board_length1;
#line 358 "../src/nibbles-game.vala"
									_tmp33__length2 = self->board_length2;
#line 358 "../src/nibbles-game.vala"
									_tmp33_[(j * _tmp33__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 359 "../src/nibbles-game.vala"
									_tmp34_ = self->priv->_numworms;
#line 359 "../src/nibbles-game.vala"
									if (count < _tmp34_) {
#line 1552 "nibbles-game.c"
										GeeLinkedList* _tmp35_;
										gpointer _tmp36_;
										Worm* _tmp37_;
										gint _tmp38_;
#line 361 "../src/nibbles-game.vala"
										_tmp35_ = self->priv->_worms;
#line 361 "../src/nibbles-game.vala"
										_tmp36_ = gee_abstract_list_get ((GeeAbstractList*) _tmp35_, count);
#line 361 "../src/nibbles-game.vala"
										_tmp37_ = (Worm*) _tmp36_;
#line 361 "../src/nibbles-game.vala"
										worm_set_start (_tmp37_, j, i, WORM_DIRECTION_LEFT);
#line 361 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp37_);
#line 362 "../src/nibbles-game.vala"
										_tmp38_ = count;
#line 362 "../src/nibbles-game.vala"
										count = _tmp38_ + 1;
#line 1571 "nibbles-game.c"
									}
#line 364 "../src/nibbles-game.vala"
									break;
#line 1575 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9660U:
#line 303 "../src/nibbles-game.vala"
								case 'o':
#line 1581 "nibbles-game.c"
								{
									gint* _tmp39_;
									gint _tmp39__length1;
									gint _tmp39__length2;
									gint _tmp40_;
#line 367 "../src/nibbles-game.vala"
									_tmp39_ = self->board;
#line 367 "../src/nibbles-game.vala"
									_tmp39__length1 = self->board_length1;
#line 367 "../src/nibbles-game.vala"
									_tmp39__length2 = self->board_length2;
#line 367 "../src/nibbles-game.vala"
									_tmp39_[(j * _tmp39__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 368 "../src/nibbles-game.vala"
									_tmp40_ = self->priv->_numworms;
#line 368 "../src/nibbles-game.vala"
									if (count < _tmp40_) {
#line 1599 "nibbles-game.c"
										GeeLinkedList* _tmp41_;
										gpointer _tmp42_;
										Worm* _tmp43_;
										gint _tmp44_;
#line 370 "../src/nibbles-game.vala"
										_tmp41_ = self->priv->_worms;
#line 370 "../src/nibbles-game.vala"
										_tmp42_ = gee_abstract_list_get ((GeeAbstractList*) _tmp41_, count);
#line 370 "../src/nibbles-game.vala"
										_tmp43_ = (Worm*) _tmp42_;
#line 370 "../src/nibbles-game.vala"
										worm_set_start (_tmp43_, j, i, WORM_DIRECTION_DOWN);
#line 370 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp43_);
#line 371 "../src/nibbles-game.vala"
										_tmp44_ = count;
#line 371 "../src/nibbles-game.vala"
										count = _tmp44_ + 1;
#line 1618 "nibbles-game.c"
									}
#line 373 "../src/nibbles-game.vala"
									break;
#line 1622 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 9654U:
#line 303 "../src/nibbles-game.vala"
								case 'p':
#line 1628 "nibbles-game.c"
								{
									gint* _tmp45_;
									gint _tmp45__length1;
									gint _tmp45__length2;
									gint _tmp46_;
#line 376 "../src/nibbles-game.vala"
									_tmp45_ = self->board;
#line 376 "../src/nibbles-game.vala"
									_tmp45__length1 = self->board_length1;
#line 376 "../src/nibbles-game.vala"
									_tmp45__length2 = self->board_length2;
#line 376 "../src/nibbles-game.vala"
									_tmp45_[(j * _tmp45__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 377 "../src/nibbles-game.vala"
									_tmp46_ = self->priv->_numworms;
#line 377 "../src/nibbles-game.vala"
									if (count < _tmp46_) {
#line 1646 "nibbles-game.c"
										GeeLinkedList* _tmp47_;
										gpointer _tmp48_;
										Worm* _tmp49_;
										gint _tmp50_;
#line 379 "../src/nibbles-game.vala"
										_tmp47_ = self->priv->_worms;
#line 379 "../src/nibbles-game.vala"
										_tmp48_ = gee_abstract_list_get ((GeeAbstractList*) _tmp47_, count);
#line 379 "../src/nibbles-game.vala"
										_tmp49_ = (Worm*) _tmp48_;
#line 379 "../src/nibbles-game.vala"
										worm_set_start (_tmp49_, j, i, WORM_DIRECTION_RIGHT);
#line 379 "../src/nibbles-game.vala"
										_g_object_unref0 (_tmp49_);
#line 380 "../src/nibbles-game.vala"
										_tmp50_ = count;
#line 380 "../src/nibbles-game.vala"
										count = _tmp50_ + 1;
#line 1665 "nibbles-game.c"
									}
#line 382 "../src/nibbles-game.vala"
									break;
#line 1669 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 'Q':
#line 303 "../src/nibbles-game.vala"
								case 'R':
#line 303 "../src/nibbles-game.vala"
								case 'S':
#line 303 "../src/nibbles-game.vala"
								case 'T':
#line 303 "../src/nibbles-game.vala"
								case 'U':
#line 303 "../src/nibbles-game.vala"
								case 'V':
#line 303 "../src/nibbles-game.vala"
								case 'W':
#line 303 "../src/nibbles-game.vala"
								case 'X':
#line 303 "../src/nibbles-game.vala"
								case 'Y':
#line 303 "../src/nibbles-game.vala"
								case 'Z':
#line 1691 "nibbles-game.c"
								{
									gboolean _tmp51_ = FALSE;
									gint* _tmp52_;
									gint _tmp52__length1;
									gint _tmp52__length2;
									WarpManager* _tmp53_;
									gint* _tmp54_;
									gint _tmp54__length1;
									gint _tmp54__length2;
									gint _tmp55_;
									gint* _tmp56_;
									gint _tmp56__length1;
									gint _tmp56__length2;
									gint* _tmp57_;
									gint _tmp57__length1;
									gint _tmp57__length2;
									gint* _tmp58_;
									gint _tmp58__length1;
									gint _tmp58__length2;
									gint* _tmp59_;
									gint _tmp59__length1;
									gint _tmp59__length2;
#line 395 "../src/nibbles-game.vala"
									if (((gint) j) == 0) {
#line 395 "../src/nibbles-game.vala"
										_tmp51_ = TRUE;
#line 1718 "nibbles-game.c"
									} else {
#line 395 "../src/nibbles-game.vala"
										_tmp51_ = ((gint) i) == 0;
#line 1722 "nibbles-game.c"
									}
#line 395 "../src/nibbles-game.vala"
									if (_tmp51_) {
#line 396 "../src/nibbles-game.vala"
										result = FALSE;
#line 396 "../src/nibbles-game.vala"
										_g_free0 (tmpboard);
#line 396 "../src/nibbles-game.vala"
										return result;
#line 1732 "nibbles-game.c"
									}
#line 398 "../src/nibbles-game.vala"
									_tmp52_ = self->board;
#line 398 "../src/nibbles-game.vala"
									_tmp52__length1 = self->board_length1;
#line 398 "../src/nibbles-game.vala"
									_tmp52__length2 = self->board_length2;
#line 398 "../src/nibbles-game.vala"
									_tmp52_[(j * _tmp52__length2) + i] = (gint) char_value;
#line 399 "../src/nibbles-game.vala"
									_tmp53_ = self->priv->warp_manager;
#line 399 "../src/nibbles-game.vala"
									_tmp54_ = self->board;
#line 399 "../src/nibbles-game.vala"
									_tmp54__length1 = self->board_length1;
#line 399 "../src/nibbles-game.vala"
									_tmp54__length2 = self->board_length2;
#line 399 "../src/nibbles-game.vala"
									_tmp55_ = _tmp54_[(j * _tmp54__length2) + i];
#line 399 "../src/nibbles-game.vala"
									warp_manager_add_warp_source (_tmp53_, _tmp55_, (guint8) (j - 1), (guint8) (i - 1), char_value == ((gunichar) 'Q'));
#line 401 "../src/nibbles-game.vala"
									_tmp56_ = self->board;
#line 401 "../src/nibbles-game.vala"
									_tmp56__length1 = self->board_length1;
#line 401 "../src/nibbles-game.vala"
									_tmp56__length2 = self->board_length2;
#line 401 "../src/nibbles-game.vala"
									_tmp56_[((j - 1) * _tmp56__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 402 "../src/nibbles-game.vala"
									_tmp57_ = self->board;
#line 402 "../src/nibbles-game.vala"
									_tmp57__length1 = self->board_length1;
#line 402 "../src/nibbles-game.vala"
									_tmp57__length2 = self->board_length2;
#line 402 "../src/nibbles-game.vala"
									_tmp57_[(j * _tmp57__length2) + (i - 1)] = (gint) NIBBLES_GAME_WARPCHAR;
#line 403 "../src/nibbles-game.vala"
									_tmp58_ = self->board;
#line 403 "../src/nibbles-game.vala"
									_tmp58__length1 = self->board_length1;
#line 403 "../src/nibbles-game.vala"
									_tmp58__length2 = self->board_length2;
#line 403 "../src/nibbles-game.vala"
									_tmp58_[((j - 1) * _tmp58__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 404 "../src/nibbles-game.vala"
									_tmp59_ = self->board;
#line 404 "../src/nibbles-game.vala"
									_tmp59__length1 = self->board_length1;
#line 404 "../src/nibbles-game.vala"
									_tmp59__length2 = self->board_length2;
#line 404 "../src/nibbles-game.vala"
									_tmp59_[(j * _tmp59__length2) + i] = (gint) NIBBLES_GAME_WARPCHAR;
#line 406 "../src/nibbles-game.vala"
									g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL], 0, (guint8) (j - 1), (guint8) (i - 1));
#line 407 "../src/nibbles-game.vala"
									break;
#line 1790 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 'r':
#line 303 "../src/nibbles-game.vala"
								case 's':
#line 303 "../src/nibbles-game.vala"
								case 't':
#line 303 "../src/nibbles-game.vala"
								case 'u':
#line 303 "../src/nibbles-game.vala"
								case 'v':
#line 303 "../src/nibbles-game.vala"
								case 'w':
#line 303 "../src/nibbles-game.vala"
								case 'x':
#line 303 "../src/nibbles-game.vala"
								case 'y':
#line 303 "../src/nibbles-game.vala"
								case 'z':
#line 1810 "nibbles-game.c"
								{
									WarpManager* _tmp60_;
									gint* _tmp61_;
									gint _tmp61__length1;
									gint _tmp61__length2;
#line 419 "../src/nibbles-game.vala"
									_tmp60_ = self->priv->warp_manager;
#line 419 "../src/nibbles-game.vala"
									warp_manager_add_warp_target (_tmp60_, (((gint) char_value) - ((gint) 'a')) + ((gint) 'A'), j, i);
#line 420 "../src/nibbles-game.vala"
									_tmp61_ = self->board;
#line 420 "../src/nibbles-game.vala"
									_tmp61__length1 = self->board_length1;
#line 420 "../src/nibbles-game.vala"
									_tmp61__length2 = self->board_length2;
#line 420 "../src/nibbles-game.vala"
									_tmp61_[(j * _tmp61__length2) + i] = (gint) NIBBLES_GAME_EMPTYCHAR;
#line 421 "../src/nibbles-game.vala"
									break;
#line 1830 "nibbles-game.c"
								}
#line 303 "../src/nibbles-game.vala"
								case 'a':
#line 303 "../src/nibbles-game.vala"
								case 'b':
#line 303 "../src/nibbles-game.vala"
								case 'c':
#line 303 "../src/nibbles-game.vala"
								case 'd':
#line 303 "../src/nibbles-game.vala"
								case 'e':
#line 303 "../src/nibbles-game.vala"
								case 'f':
#line 303 "../src/nibbles-game.vala"
								case 'g':
#line 303 "../src/nibbles-game.vala"
								case 'h':
#line 303 "../src/nibbles-game.vala"
								case 'i':
#line 303 "../src/nibbles-game.vala"
								case 'j':
#line 303 "../src/nibbles-game.vala"
								case 'k':
#line 303 "../src/nibbles-game.vala"
								case 'l':
#line 1856 "nibbles-game.c"
								{
									gint* _tmp62_;
									gint _tmp62__length1;
									gint _tmp62__length2;
#line 436 "../src/nibbles-game.vala"
									_tmp62_ = self->board;
#line 436 "../src/nibbles-game.vala"
									_tmp62__length1 = self->board_length1;
#line 436 "../src/nibbles-game.vala"
									_tmp62__length2 = self->board_length2;
#line 436 "../src/nibbles-game.vala"
									_tmp62_[(j * _tmp62__length2) + i] = (gint) char_value;
#line 437 "../src/nibbles-game.vala"
									break;
#line 1871 "nibbles-game.c"
								}
								default:
								{
#line 440 "../src/nibbles-game.vala"
									result = FALSE;
#line 440 "../src/nibbles-game.vala"
									_g_free0 (tmpboard);
#line 440 "../src/nibbles-game.vala"
									return result;
#line 1881 "nibbles-game.c"
								}
							}
						}
					}
				}
			}
		}
	}
#line 444 "../src/nibbles-game.vala"
	_tmp63_ = self->priv->warp_manager;
#line 444 "../src/nibbles-game.vala"
	_tmp64_ = self->board;
#line 444 "../src/nibbles-game.vala"
	_tmp64__length1 = self->board_length1;
#line 444 "../src/nibbles-game.vala"
	_tmp64__length2 = self->board_length2;
#line 444 "../src/nibbles-game.vala"
	warp_manager_initilise (_tmp63_, _tmp64_, (gint) _tmp64__length1, (gint) _tmp64__length2);
#line 446 "../src/nibbles-game.vala"
	result = TRUE;
#line 446 "../src/nibbles-game.vala"
	_g_free0 (tmpboard);
#line 446 "../src/nibbles-game.vala"
	return result;
#line 1906 "nibbles-game.c"
}

static gboolean
__lambda6_ (NibblesGame* self)
{
	gboolean result;
#line 462 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) ((self->priv->bonus_cycle + 1) % 3);
#line 463 "../src/nibbles-game.vala"
	if (((gint) self->priv->bonus_cycle) == 0) {
#line 464 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, FALSE);
#line 1919 "nibbles-game.c"
	}
#line 465 "../src/nibbles-game.vala"
	result = nibbles_game_main_loop_cb (self);
#line 465 "../src/nibbles-game.vala"
	return result;
#line 1925 "nibbles-game.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ ((NibblesGame*) self);
#line 461 "../src/nibbles-game.vala"
	return result;
#line 1935 "nibbles-game.c"
}

void
nibbles_game_start (NibblesGame* self,
                    gboolean add_initial_bonus)
{
	gint _tmp0_ = 0;
	gint _tmp1_;
#line 454 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 456 "../src/nibbles-game.vala"
	if (add_initial_bonus) {
#line 457 "../src/nibbles-game.vala"
		nibbles_game_add_bonus (self, TRUE);
#line 1950 "nibbles-game.c"
	}
#line 459 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, TRUE);
#line 461 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_speed;
#line 461 "../src/nibbles-game.vala"
	if (_tmp1_ == 1) {
#line 1958 "nibbles-game.c"
		gint _tmp2_;
#line 461 "../src/nibbles-game.vala"
		_tmp2_ = self->priv->_gamedelay;
#line 461 "../src/nibbles-game.vala"
		_tmp0_ = (_tmp2_ * 3) / 2;
#line 1964 "nibbles-game.c"
	} else {
		gint _tmp3_;
		gint _tmp4_;
#line 461 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_gamedelay;
#line 461 "../src/nibbles-game.vala"
		_tmp4_ = self->priv->_speed;
#line 461 "../src/nibbles-game.vala"
		_tmp0_ = _tmp3_ * _tmp4_;
#line 1974 "nibbles-game.c"
	}
#line 461 "../src/nibbles-game.vala"
	self->priv->main_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) _tmp0_, ___lambda6__gsource_func, g_object_ref (self), g_object_unref);
#line 467 "../src/nibbles-game.vala"
	g_source_set_name_by_id (self->priv->main_id, "[Nibbles] main_loop_cb");
#line 1980 "nibbles-game.c"
}

void
nibbles_game_stop (NibblesGame* self)
{
#line 470 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/nibbles-game.vala"
	nibbles_game_set_is_running (self, FALSE);
#line 474 "../src/nibbles-game.vala"
	if (self->priv->main_id == ((guint) 0)) {
#line 475 "../src/nibbles-game.vala"
		return;
#line 1994 "nibbles-game.c"
	}
#line 476 "../src/nibbles-game.vala"
	g_source_remove (self->priv->main_id);
#line 477 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 2000 "nibbles-game.c"
}

static void
_vala_array_add2 (gint* * array,
                  gint* length,
                  gint* size,
                  gint value)
{
#line 488 "../src/nibbles-game.vala"
	if ((*length) == (*size)) {
#line 488 "../src/nibbles-game.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 488 "../src/nibbles-game.vala"
		*array = g_renew (gint, *array, *size);
#line 2015 "nibbles-game.c"
	}
#line 488 "../src/nibbles-game.vala"
	(*array)[(*length)++] = value;
#line 2019 "nibbles-game.c"
}

inline void
nibbles_game_reset (NibblesGame* self,
                    gint start_level)
{
	gint _tmp0_;
	gint _tmp1_;
#line 480 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 482 "../src/nibbles-game.vala"
	nibbles_game_set_skip_score (self, start_level != 1);
#line 483 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_progress (self);
#line 483 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 483 "../src/nibbles-game.vala"
	if (_tmp1_ != 1) {
#line 484 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, start_level);
#line 2040 "nibbles-game.c"
	} else {
		{
			gint i = 0;
#line 488 "../src/nibbles-game.vala"
			i = NIBBLES_GAME_MAX_LEVEL;
#line 2046 "nibbles-game.c"
			{
				gboolean _tmp2_ = FALSE;
#line 488 "../src/nibbles-game.vala"
				_tmp2_ = TRUE;
#line 488 "../src/nibbles-game.vala"
				while (TRUE) {
#line 488 "../src/nibbles-game.vala"
					if (!_tmp2_) {
#line 2055 "nibbles-game.c"
						gint _tmp3_;
#line 488 "../src/nibbles-game.vala"
						_tmp3_ = i;
#line 488 "../src/nibbles-game.vala"
						i = _tmp3_ - 1;
#line 488 "../src/nibbles-game.vala"
						_vala_array_add2 (&self->levels_uncompleated, &self->levels_uncompleated_length1, &self->_levels_uncompleated_size_, _tmp3_);
#line 2063 "nibbles-game.c"
					}
#line 488 "../src/nibbles-game.vala"
					_tmp2_ = FALSE;
#line 488 "../src/nibbles-game.vala"
					if (!(i > 0)) {
#line 488 "../src/nibbles-game.vala"
						break;
#line 2071 "nibbles-game.c"
					}
				}
			}
		}
#line 489 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, nibbles_game_remove_one_uncompleated_level (self));
#line 2078 "nibbles-game.c"
	}
#line 491 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, FALSE);
#line 2082 "nibbles-game.c"
}

static gint
nibbles_game_remove_one_uncompleated_level (NibblesGame* self)
{
	gint32 index = 0;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint level = 0;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp2_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint _tmp6_;
	gint result;
#line 494 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 496 "../src/nibbles-game.vala"
	_tmp0_ = self->levels_uncompleated;
#line 496 "../src/nibbles-game.vala"
	_tmp0__length1 = self->levels_uncompleated_length1;
#line 496 "../src/nibbles-game.vala"
	index = g_random_int_range ((gint32) 0, (gint32) _tmp0__length1);
#line 497 "../src/nibbles-game.vala"
	_tmp1_ = self->levels_uncompleated;
#line 497 "../src/nibbles-game.vala"
	_tmp1__length1 = self->levels_uncompleated_length1;
#line 497 "../src/nibbles-game.vala"
	_tmp2_ = _tmp1_[index];
#line 497 "../src/nibbles-game.vala"
	level = _tmp2_;
#line 499 "../src/nibbles-game.vala"
	_tmp3_ = self->levels_uncompleated;
#line 499 "../src/nibbles-game.vala"
	_tmp3__length1 = self->levels_uncompleated_length1;
#line 499 "../src/nibbles-game.vala"
	if (index < ((gint32) (_tmp3__length1 - 1))) {
#line 2123 "nibbles-game.c"
		gint* _tmp4_;
		gint _tmp4__length1;
#line 500 "../src/nibbles-game.vala"
		_tmp4_ = self->levels_uncompleated;
#line 500 "../src/nibbles-game.vala"
		_tmp4__length1 = self->levels_uncompleated_length1;
#line 500 "../src/nibbles-game.vala"
		_vala_array_move (self->levels_uncompleated, sizeof (gint), (gint) (index + 1), (gint) index, _tmp4__length1 - (index + 1));
#line 2132 "nibbles-game.c"
	}
#line 501 "../src/nibbles-game.vala"
	_tmp5_ = self->levels_uncompleated;
#line 501 "../src/nibbles-game.vala"
	_tmp5__length1 = self->levels_uncompleated_length1;
#line 501 "../src/nibbles-game.vala"
	_tmp6_ = _tmp5__length1 - 1;
#line 501 "../src/nibbles-game.vala"
	self->levels_uncompleated = g_renew (gint, self->levels_uncompleated, _tmp5__length1 - 1);
#line 501 "../src/nibbles-game.vala"
	(_tmp6_ > self->levels_uncompleated_length1) ? memset (self->levels_uncompleated + self->levels_uncompleated_length1, 0, sizeof (gint) * (_tmp6_ - self->levels_uncompleated_length1)) : NULL;
#line 501 "../src/nibbles-game.vala"
	self->levels_uncompleated_length1 = _tmp6_;
#line 501 "../src/nibbles-game.vala"
	self->_levels_uncompleated_size_ = _tmp6_;
#line 502 "../src/nibbles-game.vala"
	result = level;
#line 502 "../src/nibbles-game.vala"
	return result;
#line 2152 "nibbles-game.c"
}

static void
nibbles_game_end (NibblesGame* self)
{
#line 505 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 507 "../src/nibbles-game.vala"
	nibbles_game_stop (self);
#line 508 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 2164 "nibbles-game.c"
}

static gboolean
_nibbles_game_estatus_equal (const NibblesGameeStatus * s1,
                             const NibblesGameeStatus * s2)
{
#line 514 "../src/nibbles-game.vala"
	if (s1 == s2) {
#line 514 "../src/nibbles-game.vala"
		return TRUE;
#line 2175 "nibbles-game.c"
	}
#line 514 "../src/nibbles-game.vala"
	if (s1 == NULL) {
#line 514 "../src/nibbles-game.vala"
		return FALSE;
#line 2181 "nibbles-game.c"
	}
#line 514 "../src/nibbles-game.vala"
	if (s2 == NULL) {
#line 514 "../src/nibbles-game.vala"
		return FALSE;
#line 2187 "nibbles-game.c"
	}
#line 514 "../src/nibbles-game.vala"
	return (*s1) == (*s2);
#line 2191 "nibbles-game.c"
}

static gboolean
nibbles_game_main_loop_cb (NibblesGame* self)
{
	NibblesGameeStatus* status = NULL;
	NibblesGameeStatus* _tmp0_;
	NibblesGameeStatus* _tmp1_;
	NibblesGameeStatus _tmp2_;
	gboolean result;
#line 511 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 513 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_game_status (self);
#line 513 "../src/nibbles-game.vala"
	status = _tmp0_;
#line 514 "../src/nibbles-game.vala"
	_tmp1_ = status;
#line 514 "../src/nibbles-game.vala"
	_tmp2_ = NIBBLES_GAME_ESTATUS_GAMEOVER;
#line 514 "../src/nibbles-game.vala"
	if (_nibbles_game_estatus_equal (_tmp1_, &_tmp2_) == TRUE) {
#line 2214 "nibbles-game.c"
		GeeLinkedList* _tmp3_;
		gpointer _tmp4_;
		Worm* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 516 "../src/nibbles-game.vala"
		nibbles_game_end (self);
#line 518 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 518 "../src/nibbles-game.vala"
		_tmp4_ = gee_linked_list_first (_tmp3_);
#line 518 "../src/nibbles-game.vala"
		_tmp5_ = (Worm*) _tmp4_;
#line 518 "../src/nibbles-game.vala"
		_tmp6_ = worm_get_score (_tmp5_);
#line 518 "../src/nibbles-game.vala"
		_tmp7_ = _tmp6_;
#line 518 "../src/nibbles-game.vala"
		_tmp8_ = self->priv->_current_level;
#line 518 "../src/nibbles-game.vala"
		g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp7_, _tmp8_);
#line 518 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp5_);
#line 520 "../src/nibbles-game.vala"
		result = G_SOURCE_REMOVE;
#line 520 "../src/nibbles-game.vala"
		_g_free0 (status);
#line 520 "../src/nibbles-game.vala"
		return result;
#line 2245 "nibbles-game.c"
	} else {
		NibblesGameeStatus* _tmp9_;
		NibblesGameeStatus _tmp10_;
#line 522 "../src/nibbles-game.vala"
		_tmp9_ = status;
#line 522 "../src/nibbles-game.vala"
		_tmp10_ = NIBBLES_GAME_ESTATUS_VICTORY;
#line 522 "../src/nibbles-game.vala"
		if (_nibbles_game_estatus_equal (_tmp9_, &_tmp10_) == TRUE) {
#line 2255 "nibbles-game.c"
			Worm* winner = NULL;
			Worm* _tmp11_;
			Worm* _tmp12_;
#line 524 "../src/nibbles-game.vala"
			nibbles_game_end (self);
#line 526 "../src/nibbles-game.vala"
			_tmp11_ = nibbles_game_get_winner (self);
#line 526 "../src/nibbles-game.vala"
			winner = _tmp11_;
#line 527 "../src/nibbles-game.vala"
			_tmp12_ = winner;
#line 527 "../src/nibbles-game.vala"
			if (_tmp12_ != NULL) {
#line 2269 "nibbles-game.c"
				Worm* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
#line 528 "../src/nibbles-game.vala"
				_tmp13_ = winner;
#line 528 "../src/nibbles-game.vala"
				_tmp14_ = worm_get_score (_tmp13_);
#line 528 "../src/nibbles-game.vala"
				_tmp15_ = _tmp14_;
#line 528 "../src/nibbles-game.vala"
				_tmp16_ = self->priv->_current_level;
#line 528 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp15_, _tmp16_);
#line 2284 "nibbles-game.c"
			}
#line 530 "../src/nibbles-game.vala"
			result = G_SOURCE_REMOVE;
#line 530 "../src/nibbles-game.vala"
			_g_object_unref0 (winner);
#line 530 "../src/nibbles-game.vala"
			_g_free0 (status);
#line 530 "../src/nibbles-game.vala"
			return result;
#line 2294 "nibbles-game.c"
		} else {
			NibblesGameeStatus* _tmp17_;
			NibblesGameeStatus _tmp18_;
#line 532 "../src/nibbles-game.vala"
			_tmp17_ = status;
#line 532 "../src/nibbles-game.vala"
			_tmp18_ = NIBBLES_GAME_ESTATUS_NEWROUND;
#line 532 "../src/nibbles-game.vala"
			if (_nibbles_game_estatus_equal (_tmp17_, &_tmp18_) == TRUE) {
#line 2304 "nibbles-game.c"
				gint _tmp19_;
				gint _tmp20_;
#line 534 "../src/nibbles-game.vala"
				nibbles_game_stop (self);
#line 536 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL], 0);
#line 537 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL], 0);
#line 539 "../src/nibbles-game.vala"
				_tmp19_ = nibbles_game_get_progress (self);
#line 539 "../src/nibbles-game.vala"
				_tmp20_ = _tmp19_;
#line 539 "../src/nibbles-game.vala"
				if (_tmp20_ == 0) {
#line 2319 "nibbles-game.c"
					gint _tmp21_;
					gint _tmp22_;
#line 541 "../src/nibbles-game.vala"
					_tmp21_ = self->priv->_current_level;
#line 541 "../src/nibbles-game.vala"
					nibbles_game_set_current_level (self, _tmp21_ + 1);
#line 542 "../src/nibbles-game.vala"
					_tmp22_ = self->priv->_current_level;
#line 542 "../src/nibbles-game.vala"
					if (_tmp22_ == (NIBBLES_GAME_MAX_LEVEL + 1)) {
#line 2330 "nibbles-game.c"
						GeeLinkedList* _tmp23_;
						gpointer _tmp24_;
						Worm* _tmp25_;
						gint _tmp26_;
						gint _tmp27_;
						gint _tmp28_;
#line 543 "../src/nibbles-game.vala"
						_tmp23_ = self->priv->_worms;
#line 543 "../src/nibbles-game.vala"
						_tmp24_ = gee_linked_list_first (_tmp23_);
#line 543 "../src/nibbles-game.vala"
						_tmp25_ = (Worm*) _tmp24_;
#line 543 "../src/nibbles-game.vala"
						_tmp26_ = worm_get_score (_tmp25_);
#line 543 "../src/nibbles-game.vala"
						_tmp27_ = _tmp26_;
#line 543 "../src/nibbles-game.vala"
						_tmp28_ = self->priv->_current_level;
#line 543 "../src/nibbles-game.vala"
						g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp27_, _tmp28_);
#line 543 "../src/nibbles-game.vala"
						_g_object_unref0 (_tmp25_);
#line 2353 "nibbles-game.c"
					}
				} else {
					gint _tmp29_;
					gint _tmp30_;
#line 545 "../src/nibbles-game.vala"
					_tmp29_ = nibbles_game_get_progress (self);
#line 545 "../src/nibbles-game.vala"
					_tmp30_ = _tmp29_;
#line 545 "../src/nibbles-game.vala"
					if (_tmp30_ == 1) {
#line 2364 "nibbles-game.c"
						gint* _tmp31_;
						gint _tmp31__length1;
#line 547 "../src/nibbles-game.vala"
						_tmp31_ = self->levels_uncompleated;
#line 547 "../src/nibbles-game.vala"
						_tmp31__length1 = self->levels_uncompleated_length1;
#line 547 "../src/nibbles-game.vala"
						if (_tmp31__length1 > 0) {
#line 548 "../src/nibbles-game.vala"
							nibbles_game_set_current_level (self, nibbles_game_remove_one_uncompleated_level (self));
#line 2375 "nibbles-game.c"
						} else {
							GeeLinkedList* _tmp32_;
							gpointer _tmp33_;
							Worm* _tmp34_;
							gint _tmp35_;
							gint _tmp36_;
							gint _tmp37_;
#line 550 "../src/nibbles-game.vala"
							_tmp32_ = self->priv->_worms;
#line 550 "../src/nibbles-game.vala"
							_tmp33_ = gee_linked_list_first (_tmp32_);
#line 550 "../src/nibbles-game.vala"
							_tmp34_ = (Worm*) _tmp33_;
#line 550 "../src/nibbles-game.vala"
							_tmp35_ = worm_get_score (_tmp34_);
#line 550 "../src/nibbles-game.vala"
							_tmp36_ = _tmp35_;
#line 550 "../src/nibbles-game.vala"
							_tmp37_ = self->priv->_current_level;
#line 550 "../src/nibbles-game.vala"
							g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL], 0, _tmp36_, _tmp37_);
#line 550 "../src/nibbles-game.vala"
							_g_object_unref0 (_tmp34_);
#line 2399 "nibbles-game.c"
						}
					}
				}
#line 554 "../src/nibbles-game.vala"
				result = G_SOURCE_REMOVE;
#line 554 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 554 "../src/nibbles-game.vala"
				return result;
#line 2409 "nibbles-game.c"
			} else {
#line 558 "../src/nibbles-game.vala"
				nibbles_game_move_worms (self);
#line 559 "../src/nibbles-game.vala"
				result = G_SOURCE_CONTINUE;
#line 559 "../src/nibbles-game.vala"
				_g_free0 (status);
#line 559 "../src/nibbles-game.vala"
				return result;
#line 2419 "nibbles-game.c"
			}
		}
	}
}

static GeeList*
_nibbles_game_get_other_worms_worm_get_other_worms_type (Worm* _self_,
                                                         gpointer self)
{
	GeeList* result;
	result = nibbles_game_get_other_worms ((NibblesGame*) self, _self_);
#line 574 "../src/nibbles-game.vala"
	return result;
#line 2433 "nibbles-game.c"
}

static GeeList*
_nibbles_game_get_bonuses_worm_get_bonuses_type (gpointer self)
{
	GeeList* result;
	result = nibbles_game_get_bonuses ((NibblesGame*) self);
#line 574 "../src/nibbles-game.vala"
	return result;
#line 2443 "nibbles-game.c"
}

static void
_nibbles_game_bonus_found_cb_worm_bonus_found (Worm* _sender,
                                               gpointer self)
{
#line 575 "../src/nibbles-game.vala"
	nibbles_game_bonus_found_cb ((NibblesGame*) self, _sender);
#line 2452 "nibbles-game.c"
}

void
nibbles_game_create_worms (NibblesGame* self,
                           GeeArrayList* worm_settings)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 567 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 569 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 569 "../src/nibbles-game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 571 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_numai;
#line 571 "../src/nibbles-game.vala"
	_tmp2_ = self->priv->_numhumans;
#line 571 "../src/nibbles-game.vala"
	nibbles_game_set_numworms (self, _tmp1_ + _tmp2_);
#line 2474 "nibbles-game.c"
	{
		gint i = 0;
#line 572 "../src/nibbles-game.vala"
		i = 0;
#line 2479 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 572 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 572 "../src/nibbles-game.vala"
			while (TRUE) {
#line 2486 "nibbles-game.c"
				gint _tmp5_;
				Worm* worm = NULL;
				guint8 _tmp6_;
				guint8 _tmp7_;
				Worm* _tmp8_;
				Worm* _tmp9_;
				Worm* _tmp10_;
				gint _tmp11_;
				GeeLinkedList* _tmp12_;
				Worm* _tmp13_;
#line 572 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 2499 "nibbles-game.c"
					gint _tmp4_;
#line 572 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 572 "../src/nibbles-game.vala"
					i = _tmp4_ + 1;
#line 2505 "nibbles-game.c"
				}
#line 572 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 572 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->_numworms;
#line 572 "../src/nibbles-game.vala"
				if (!(i < _tmp5_)) {
#line 572 "../src/nibbles-game.vala"
					break;
#line 2515 "nibbles-game.c"
				}
#line 574 "../src/nibbles-game.vala"
				_tmp6_ = self->priv->_width;
#line 574 "../src/nibbles-game.vala"
				_tmp7_ = self->priv->_height;
#line 574 "../src/nibbles-game.vala"
				_tmp8_ = worm_new (i, _tmp6_, _tmp7_, _nibbles_game_get_other_worms_worm_get_other_worms_type, self, _nibbles_game_get_bonuses_worm_get_bonuses_type, self);
#line 574 "../src/nibbles-game.vala"
				worm = _tmp8_;
#line 575 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 575 "../src/nibbles-game.vala"
				g_signal_connect_object (_tmp9_, "bonus-found", (GCallback) _nibbles_game_bonus_found_cb_worm_bonus_found, self, 0);
#line 576 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 576 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_numhumans;
#line 576 "../src/nibbles-game.vala"
				_tmp10_->is_human = i < _tmp11_;
#line 577 "../src/nibbles-game.vala"
				_tmp12_ = self->priv->_worms;
#line 577 "../src/nibbles-game.vala"
				_tmp13_ = worm;
#line 577 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, _tmp13_);
#line 572 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2543 "nibbles-game.c"
			}
		}
	}
#line 579 "../src/nibbles-game.vala"
	if (worm_settings != NULL) {
#line 580 "../src/nibbles-game.vala"
		nibbles_game_load_worm_properties (self, worm_settings);
#line 2551 "nibbles-game.c"
	}
}

void
nibbles_game_add_worms (NibblesGame* self)
{
#line 583 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 2560 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 585 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 585 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 585 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 585 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 585 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 585 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 585 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 585 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2585 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			gint* _tmp9_;
			gint _tmp9__length1;
			gint _tmp9__length2;
#line 585 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 585 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 585 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 585 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 585 "../src/nibbles-game.vala"
				break;
#line 2605 "nibbles-game.c"
			}
#line 585 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 585 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 585 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 586 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 586 "../src/nibbles-game.vala"
			_tmp9_ = self->board;
#line 586 "../src/nibbles-game.vala"
			_tmp9__length1 = self->board_length1;
#line 586 "../src/nibbles-game.vala"
			_tmp9__length2 = self->board_length2;
#line 586 "../src/nibbles-game.vala"
			worm_spawn (_tmp8_, _tmp9_, (gint) _tmp9__length1, (gint) _tmp9__length2);
#line 585 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2625 "nibbles-game.c"
		}
	}
}

static void
nibbles_game_move_worms (NibblesGame* self)
{
	NibblesGameBonuses* _tmp13_;
	guint8 missed_bonuses_to_replace = 0U;
	NibblesGameBonuses* _tmp28_;
	guint8 _tmp29_ = 0U;
	GeeLinkedList* dead_worms = NULL;
	GeeLinkedList* _tmp53_;
	NibblesGameBonuses* _tmp176_;
	GeeSet* _tmp177_;
	gint _tmp178_;
	gint _tmp179_;
	GeeSet* _tmp180_;
	GeeHashMap* _tmp235_;
#line 589 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 2647 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 591 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 591 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 591 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 591 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 591 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 591 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 591 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 591 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2672 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			Worm* _tmp10_;
#line 591 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 591 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 591 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 591 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 591 "../src/nibbles-game.vala"
				break;
#line 2690 "nibbles-game.c"
			}
#line 591 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 591 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 591 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 593 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 593 "../src/nibbles-game.vala"
			if (_tmp8_->rounds_to_stay_still == 1) {
#line 2702 "nibbles-game.c"
				Worm* _tmp9_;
#line 594 "../src/nibbles-game.vala"
				_tmp9_ = worm;
#line 594 "../src/nibbles-game.vala"
				_tmp9_->is_stopped = FALSE;
#line 2708 "nibbles-game.c"
			}
#line 595 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 595 "../src/nibbles-game.vala"
			if (_tmp10_->rounds_to_stay_still > 0) {
#line 2714 "nibbles-game.c"
				Worm* _tmp11_;
				gint _tmp12_;
#line 596 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 596 "../src/nibbles-game.vala"
				_tmp11_->rounds_to_stay_still = _tmp11_->rounds_to_stay_still - 1;
#line 596 "../src/nibbles-game.vala"
				_tmp12_ = _tmp11_->rounds_to_stay_still;
#line 2723 "nibbles-game.c"
			}
#line 591 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2727 "nibbles-game.c"
		}
	}
#line 599 "../src/nibbles-game.vala"
	_tmp13_ = self->priv->bonuses;
#line 599 "../src/nibbles-game.vala"
	if (nibbles_game_bonuses_too_many_missed (_tmp13_)) {
#line 2734 "nibbles-game.c"
		{
			GeeLinkedList* _worm_list = NULL;
			GeeLinkedList* _tmp14_;
			gint _worm_size = 0;
			GeeLinkedList* _tmp15_;
			gint _tmp16_;
			gint _tmp17_;
			gint _worm_index = 0;
#line 601 "../src/nibbles-game.vala"
			_tmp14_ = self->priv->_worms;
#line 601 "../src/nibbles-game.vala"
			_worm_list = _tmp14_;
#line 601 "../src/nibbles-game.vala"
			_tmp15_ = _worm_list;
#line 601 "../src/nibbles-game.vala"
			_tmp16_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp15_);
#line 601 "../src/nibbles-game.vala"
			_tmp17_ = _tmp16_;
#line 601 "../src/nibbles-game.vala"
			_worm_size = _tmp17_;
#line 601 "../src/nibbles-game.vala"
			_worm_index = -1;
#line 601 "../src/nibbles-game.vala"
			while (TRUE) {
#line 2759 "nibbles-game.c"
				gint _tmp18_;
				gint _tmp19_;
				Worm* worm = NULL;
				GeeLinkedList* _tmp20_;
				gpointer _tmp21_;
				Worm* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 601 "../src/nibbles-game.vala"
				_worm_index = _worm_index + 1;
#line 601 "../src/nibbles-game.vala"
				_tmp18_ = _worm_index;
#line 601 "../src/nibbles-game.vala"
				_tmp19_ = _worm_size;
#line 601 "../src/nibbles-game.vala"
				if (!(_tmp18_ < _tmp19_)) {
#line 601 "../src/nibbles-game.vala"
					break;
#line 2778 "nibbles-game.c"
				}
#line 601 "../src/nibbles-game.vala"
				_tmp20_ = _worm_list;
#line 601 "../src/nibbles-game.vala"
				_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) _tmp20_, _worm_index);
#line 601 "../src/nibbles-game.vala"
				worm = (Worm*) _tmp21_;
#line 603 "../src/nibbles-game.vala"
				_tmp22_ = worm;
#line 603 "../src/nibbles-game.vala"
				_tmp23_ = worm_get_score (_tmp22_);
#line 603 "../src/nibbles-game.vala"
				_tmp24_ = _tmp23_;
#line 603 "../src/nibbles-game.vala"
				if (_tmp24_ > 0) {
#line 2794 "nibbles-game.c"
					Worm* _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
#line 604 "../src/nibbles-game.vala"
					_tmp25_ = worm;
#line 604 "../src/nibbles-game.vala"
					_tmp26_ = worm_get_score (_tmp25_);
#line 604 "../src/nibbles-game.vala"
					_tmp27_ = _tmp26_;
#line 604 "../src/nibbles-game.vala"
					worm_set_score (_tmp25_, _tmp27_ - 1);
#line 2806 "nibbles-game.c"
				}
#line 601 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 2810 "nibbles-game.c"
			}
		}
	}
#line 609 "../src/nibbles-game.vala"
	_tmp28_ = self->priv->bonuses;
#line 609 "../src/nibbles-game.vala"
	nibbles_game_bonuses_on_worms_move (_tmp28_, &_tmp29_);
#line 609 "../src/nibbles-game.vala"
	missed_bonuses_to_replace = _tmp29_;
#line 2820 "nibbles-game.c"
	{
		guint8 i = 0U;
#line 610 "../src/nibbles-game.vala"
		i = (guint8) 0;
#line 2825 "nibbles-game.c"
		{
			gboolean _tmp30_ = FALSE;
#line 610 "../src/nibbles-game.vala"
			_tmp30_ = TRUE;
#line 610 "../src/nibbles-game.vala"
			while (TRUE) {
#line 610 "../src/nibbles-game.vala"
				if (!_tmp30_) {
#line 2834 "nibbles-game.c"
					guint8 _tmp31_;
#line 610 "../src/nibbles-game.vala"
					_tmp31_ = i;
#line 610 "../src/nibbles-game.vala"
					i = _tmp31_ + 1;
#line 2840 "nibbles-game.c"
				}
#line 610 "../src/nibbles-game.vala"
				_tmp30_ = FALSE;
#line 610 "../src/nibbles-game.vala"
				if (!(i < missed_bonuses_to_replace)) {
#line 610 "../src/nibbles-game.vala"
					break;
#line 2848 "nibbles-game.c"
				}
#line 611 "../src/nibbles-game.vala"
				nibbles_game_add_bonus (self, TRUE);
#line 2852 "nibbles-game.c"
			}
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp32_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
		gint _worm_index = 0;
#line 614 "../src/nibbles-game.vala"
		_tmp32_ = self->priv->_worms;
#line 614 "../src/nibbles-game.vala"
		_worm_list = _tmp32_;
#line 614 "../src/nibbles-game.vala"
		_tmp33_ = _worm_list;
#line 614 "../src/nibbles-game.vala"
		_tmp34_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp33_);
#line 614 "../src/nibbles-game.vala"
		_tmp35_ = _tmp34_;
#line 614 "../src/nibbles-game.vala"
		_worm_size = _tmp35_;
#line 614 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 614 "../src/nibbles-game.vala"
		while (TRUE) {
#line 2880 "nibbles-game.c"
			gint _tmp36_;
			gint _tmp37_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp38_;
			gpointer _tmp39_;
			gboolean _tmp40_ = FALSE;
			Worm* _tmp41_;
#line 614 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 614 "../src/nibbles-game.vala"
			_tmp36_ = _worm_index;
#line 614 "../src/nibbles-game.vala"
			_tmp37_ = _worm_size;
#line 614 "../src/nibbles-game.vala"
			if (!(_tmp36_ < _tmp37_)) {
#line 614 "../src/nibbles-game.vala"
				break;
#line 2898 "nibbles-game.c"
			}
#line 614 "../src/nibbles-game.vala"
			_tmp38_ = _worm_list;
#line 614 "../src/nibbles-game.vala"
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) _tmp38_, _worm_index);
#line 614 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp39_;
#line 616 "../src/nibbles-game.vala"
			_tmp41_ = worm;
#line 616 "../src/nibbles-game.vala"
			if (!_tmp41_->is_stopped) {
#line 2910 "nibbles-game.c"
				Worm* _tmp42_;
				WormPositions* _tmp43_;
				gboolean _tmp44_;
				gboolean _tmp45_;
#line 616 "../src/nibbles-game.vala"
				_tmp42_ = worm;
#line 616 "../src/nibbles-game.vala"
				_tmp43_ = _tmp42_->list;
#line 616 "../src/nibbles-game.vala"
				_tmp44_ = gee_collection_get_is_empty ((GeeCollection*) _tmp43_);
#line 616 "../src/nibbles-game.vala"
				_tmp45_ = _tmp44_;
#line 616 "../src/nibbles-game.vala"
				_tmp40_ = !_tmp45_;
#line 2925 "nibbles-game.c"
			} else {
#line 616 "../src/nibbles-game.vala"
				_tmp40_ = FALSE;
#line 2929 "nibbles-game.c"
			}
#line 616 "../src/nibbles-game.vala"
			if (_tmp40_) {
#line 2933 "nibbles-game.c"
				Worm* _tmp46_;
#line 617 "../src/nibbles-game.vala"
				_tmp46_ = worm;
#line 617 "../src/nibbles-game.vala"
				if (_tmp46_->is_human) {
#line 2939 "nibbles-game.c"
					Worm* _tmp47_;
					gint* _tmp48_;
					gint _tmp48__length1;
					gint _tmp48__length2;
					GeeLinkedList* _tmp49_;
#line 618 "../src/nibbles-game.vala"
					_tmp47_ = worm;
#line 618 "../src/nibbles-game.vala"
					_tmp48_ = self->board;
#line 618 "../src/nibbles-game.vala"
					_tmp48__length1 = self->board_length1;
#line 618 "../src/nibbles-game.vala"
					_tmp48__length2 = self->board_length2;
#line 618 "../src/nibbles-game.vala"
					_tmp49_ = self->priv->_worms;
#line 618 "../src/nibbles-game.vala"
					worm_human_move (_tmp47_, _tmp48_, (gint) _tmp48__length1, (gint) _tmp48__length2, _tmp49_);
#line 2957 "nibbles-game.c"
				} else {
					Worm* _tmp50_;
					gint* _tmp51_;
					gint _tmp51__length1;
					gint _tmp51__length2;
					GeeLinkedList* _tmp52_;
#line 620 "../src/nibbles-game.vala"
					_tmp50_ = worm;
#line 620 "../src/nibbles-game.vala"
					_tmp51_ = self->board;
#line 620 "../src/nibbles-game.vala"
					_tmp51__length1 = self->board_length1;
#line 620 "../src/nibbles-game.vala"
					_tmp51__length2 = self->board_length2;
#line 620 "../src/nibbles-game.vala"
					_tmp52_ = self->priv->_worms;
#line 620 "../src/nibbles-game.vala"
					worm_ai_move (_tmp50_, _tmp51_, (gint) _tmp51__length1, (gint) _tmp51__length2, _tmp52_);
#line 2976 "nibbles-game.c"
				}
			}
#line 614 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 2981 "nibbles-game.c"
		}
	}
#line 624 "../src/nibbles-game.vala"
	_tmp53_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 624 "../src/nibbles-game.vala"
	dead_worms = _tmp53_;
#line 2988 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp54_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
		gint _worm_index = 0;
#line 625 "../src/nibbles-game.vala"
		_tmp54_ = self->priv->_worms;
#line 625 "../src/nibbles-game.vala"
		_worm_list = _tmp54_;
#line 625 "../src/nibbles-game.vala"
		_tmp55_ = _worm_list;
#line 625 "../src/nibbles-game.vala"
		_tmp56_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp55_);
#line 625 "../src/nibbles-game.vala"
		_tmp57_ = _tmp56_;
#line 625 "../src/nibbles-game.vala"
		_worm_size = _tmp57_;
#line 625 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 625 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3013 "nibbles-game.c"
			gint _tmp58_;
			gint _tmp59_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp60_;
			gpointer _tmp61_;
			gboolean _tmp62_ = FALSE;
			Worm* _tmp63_;
#line 625 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 625 "../src/nibbles-game.vala"
			_tmp58_ = _worm_index;
#line 625 "../src/nibbles-game.vala"
			_tmp59_ = _worm_size;
#line 625 "../src/nibbles-game.vala"
			if (!(_tmp58_ < _tmp59_)) {
#line 625 "../src/nibbles-game.vala"
				break;
#line 3031 "nibbles-game.c"
			}
#line 625 "../src/nibbles-game.vala"
			_tmp60_ = _worm_list;
#line 625 "../src/nibbles-game.vala"
			_tmp61_ = gee_abstract_list_get ((GeeAbstractList*) _tmp60_, _worm_index);
#line 625 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp61_;
#line 627 "../src/nibbles-game.vala"
			_tmp63_ = worm;
#line 627 "../src/nibbles-game.vala"
			if (!_tmp63_->is_stopped) {
#line 3043 "nibbles-game.c"
				Worm* _tmp64_;
				WormPositions* _tmp65_;
				gboolean _tmp66_;
				gboolean _tmp67_;
#line 627 "../src/nibbles-game.vala"
				_tmp64_ = worm;
#line 627 "../src/nibbles-game.vala"
				_tmp65_ = _tmp64_->list;
#line 627 "../src/nibbles-game.vala"
				_tmp66_ = gee_collection_get_is_empty ((GeeCollection*) _tmp65_);
#line 627 "../src/nibbles-game.vala"
				_tmp67_ = _tmp66_;
#line 627 "../src/nibbles-game.vala"
				_tmp62_ = !_tmp67_;
#line 3058 "nibbles-game.c"
			} else {
#line 627 "../src/nibbles-game.vala"
				_tmp62_ = FALSE;
#line 3062 "nibbles-game.c"
			}
#line 627 "../src/nibbles-game.vala"
			if (_tmp62_) {
#line 3066 "nibbles-game.c"
				Position position = {0};
				Worm* _tmp68_;
				Position _tmp69_ = {0};
				guint8 target_x = 0U;
				guint8 target_y = 0U;
				WarpManager* _tmp70_;
				Position _tmp71_;
				Position _tmp72_;
				Worm* _tmp73_;
				WormDirection _tmp74_;
				WormDirection _tmp75_;
				Worm* _tmp76_;
				gint _tmp77_;
				gint _tmp78_;
				Worm* _tmp79_;
				GeeLinkedList* _tmp80_;
				Worm* _tmp81_;
				guint8 _tmp82_ = 0U;
				guint8 _tmp83_ = 0U;
				gboolean _tmp84_ = FALSE;
				gboolean _tmp85_;
				Worm* _tmp87_;
				gint* _tmp88_;
				gint _tmp88__length1;
				gint _tmp88__length2;
				GeeLinkedList* _tmp89_;
				Position _tmp90_;
#line 629 "../src/nibbles-game.vala"
				_tmp68_ = worm;
#line 629 "../src/nibbles-game.vala"
				worm_position_move (_tmp68_, &_tmp69_);
#line 629 "../src/nibbles-game.vala"
				position = _tmp69_;
#line 632 "../src/nibbles-game.vala"
				_tmp70_ = self->priv->warp_manager;
#line 632 "../src/nibbles-game.vala"
				_tmp71_ = position;
#line 632 "../src/nibbles-game.vala"
				_tmp72_ = position;
#line 632 "../src/nibbles-game.vala"
				_tmp73_ = worm;
#line 632 "../src/nibbles-game.vala"
				_tmp74_ = worm_get_direction (_tmp73_);
#line 632 "../src/nibbles-game.vala"
				_tmp75_ = _tmp74_;
#line 632 "../src/nibbles-game.vala"
				_tmp76_ = worm;
#line 632 "../src/nibbles-game.vala"
				_tmp77_ = worm_get_length (_tmp76_);
#line 632 "../src/nibbles-game.vala"
				_tmp78_ = _tmp77_;
#line 632 "../src/nibbles-game.vala"
				_tmp79_ = worm;
#line 632 "../src/nibbles-game.vala"
				_tmp80_ = self->priv->_worms;
#line 632 "../src/nibbles-game.vala"
				_tmp81_ = worm;
#line 632 "../src/nibbles-game.vala"
				_tmp85_ = warp_manager_get_warp_target (_tmp70_, _tmp71_.x, _tmp72_.y, _tmp75_, _tmp78_, !_tmp79_->is_human, _tmp80_, &_tmp82_, &_tmp83_, &_tmp84_);
#line 632 "../src/nibbles-game.vala"
				target_x = _tmp82_;
#line 632 "../src/nibbles-game.vala"
				target_y = _tmp83_;
#line 632 "../src/nibbles-game.vala"
				_tmp81_->warp_bonus = _tmp84_;
#line 632 "../src/nibbles-game.vala"
				if (_tmp85_) {
#line 3134 "nibbles-game.c"
					Position _tmp86_ = {0};
#line 637 "../src/nibbles-game.vala"
					memset (&_tmp86_, 0, sizeof (Position));
#line 637 "../src/nibbles-game.vala"
					_tmp86_.x = target_x;
#line 637 "../src/nibbles-game.vala"
					_tmp86_.y = target_y;
#line 637 "../src/nibbles-game.vala"
					position = _tmp86_;
#line 3144 "nibbles-game.c"
				}
#line 638 "../src/nibbles-game.vala"
				_tmp87_ = worm;
#line 638 "../src/nibbles-game.vala"
				_tmp88_ = self->board;
#line 638 "../src/nibbles-game.vala"
				_tmp88__length1 = self->board_length1;
#line 638 "../src/nibbles-game.vala"
				_tmp88__length2 = self->board_length2;
#line 638 "../src/nibbles-game.vala"
				_tmp89_ = self->priv->_worms;
#line 638 "../src/nibbles-game.vala"
				_tmp90_ = position;
#line 638 "../src/nibbles-game.vala"
				if (!worm_can_move_to (_tmp87_, _tmp88_, (gint) _tmp88__length1, (gint) _tmp88__length2, (GeeList*) _tmp89_, &_tmp90_)) {
#line 3160 "nibbles-game.c"
					GeeLinkedList* _tmp91_;
					Worm* _tmp92_;
#line 640 "../src/nibbles-game.vala"
					_tmp91_ = dead_worms;
#line 640 "../src/nibbles-game.vala"
					_tmp92_ = worm;
#line 640 "../src/nibbles-game.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp91_, _tmp92_);
#line 641 "../src/nibbles-game.vala"
					g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "crash");
#line 3171 "nibbles-game.c"
				} else {
					Worm* _tmp93_;
					Position _tmp94_;
#line 644 "../src/nibbles-game.vala"
					_tmp93_ = worm;
#line 644 "../src/nibbles-game.vala"
					_tmp94_ = position;
#line 644 "../src/nibbles-game.vala"
					_tmp93_->warp_position = _tmp94_;
#line 3181 "nibbles-game.c"
				}
			}
#line 625 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3186 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp95_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp96_;
		gint _tmp97_;
		gint _tmp98_;
		gint _worm_index = 0;
#line 649 "../src/nibbles-game.vala"
		_tmp95_ = self->priv->_worms;
#line 649 "../src/nibbles-game.vala"
		_worm_list = _tmp95_;
#line 649 "../src/nibbles-game.vala"
		_tmp96_ = _worm_list;
#line 649 "../src/nibbles-game.vala"
		_tmp97_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp96_);
#line 649 "../src/nibbles-game.vala"
		_tmp98_ = _tmp97_;
#line 649 "../src/nibbles-game.vala"
		_worm_size = _tmp98_;
#line 649 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 649 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3213 "nibbles-game.c"
			gint _tmp99_;
			gint _tmp100_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp101_;
			gpointer _tmp102_;
			gboolean _tmp103_ = FALSE;
			gboolean _tmp104_ = FALSE;
			Worm* _tmp105_;
			Worm* _tmp112_;
			gint* _tmp113_;
			gint _tmp113__length1;
			gint _tmp113__length2;
			gint* _tmp114_;
			gint _tmp114__length1;
			gint _tmp114__length2;
			Worm* _tmp115_;
			Position _tmp116_ = {0};
			Position _tmp117_;
			Worm* _tmp118_;
			Position _tmp119_ = {0};
			Position _tmp120_;
			gint _tmp121_;
#line 649 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 649 "../src/nibbles-game.vala"
			_tmp99_ = _worm_index;
#line 649 "../src/nibbles-game.vala"
			_tmp100_ = _worm_size;
#line 649 "../src/nibbles-game.vala"
			if (!(_tmp99_ < _tmp100_)) {
#line 649 "../src/nibbles-game.vala"
				break;
#line 3246 "nibbles-game.c"
			}
#line 649 "../src/nibbles-game.vala"
			_tmp101_ = _worm_list;
#line 649 "../src/nibbles-game.vala"
			_tmp102_ = gee_abstract_list_get ((GeeAbstractList*) _tmp101_, _worm_index);
#line 649 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp102_;
#line 651 "../src/nibbles-game.vala"
			_tmp105_ = worm;
#line 651 "../src/nibbles-game.vala"
			if (_tmp105_->is_stopped) {
#line 651 "../src/nibbles-game.vala"
				_tmp104_ = TRUE;
#line 3260 "nibbles-game.c"
			} else {
				Worm* _tmp106_;
				WormPositions* _tmp107_;
				gboolean _tmp108_;
				gboolean _tmp109_;
#line 652 "../src/nibbles-game.vala"
				_tmp106_ = worm;
#line 652 "../src/nibbles-game.vala"
				_tmp107_ = _tmp106_->list;
#line 652 "../src/nibbles-game.vala"
				_tmp108_ = gee_collection_get_is_empty ((GeeCollection*) _tmp107_);
#line 652 "../src/nibbles-game.vala"
				_tmp109_ = _tmp108_;
#line 652 "../src/nibbles-game.vala"
				_tmp104_ = _tmp109_;
#line 3276 "nibbles-game.c"
			}
#line 651 "../src/nibbles-game.vala"
			if (_tmp104_) {
#line 651 "../src/nibbles-game.vala"
				_tmp103_ = TRUE;
#line 3282 "nibbles-game.c"
			} else {
				GeeLinkedList* _tmp110_;
				Worm* _tmp111_;
#line 653 "../src/nibbles-game.vala"
				_tmp110_ = dead_worms;
#line 653 "../src/nibbles-game.vala"
				_tmp111_ = worm;
#line 653 "../src/nibbles-game.vala"
				_tmp103_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp110_, _tmp111_);
#line 3292 "nibbles-game.c"
			}
#line 651 "../src/nibbles-game.vala"
			if (_tmp103_) {
#line 654 "../src/nibbles-game.vala"
				_g_object_unref0 (worm);
#line 654 "../src/nibbles-game.vala"
				continue;
#line 3300 "nibbles-game.c"
			}
#line 656 "../src/nibbles-game.vala"
			_tmp112_ = worm;
#line 656 "../src/nibbles-game.vala"
			_tmp113_ = self->board;
#line 656 "../src/nibbles-game.vala"
			_tmp113__length1 = self->board_length1;
#line 656 "../src/nibbles-game.vala"
			_tmp113__length2 = self->board_length2;
#line 656 "../src/nibbles-game.vala"
			worm_move_part_1 (_tmp112_, _tmp113_, (gint) _tmp113__length1, (gint) _tmp113__length2);
#line 657 "../src/nibbles-game.vala"
			_tmp114_ = self->board;
#line 657 "../src/nibbles-game.vala"
			_tmp114__length1 = self->board_length1;
#line 657 "../src/nibbles-game.vala"
			_tmp114__length2 = self->board_length2;
#line 657 "../src/nibbles-game.vala"
			_tmp115_ = worm;
#line 657 "../src/nibbles-game.vala"
			worm_get_head (_tmp115_, &_tmp116_);
#line 657 "../src/nibbles-game.vala"
			_tmp117_ = _tmp116_;
#line 657 "../src/nibbles-game.vala"
			_tmp118_ = worm;
#line 657 "../src/nibbles-game.vala"
			worm_get_head (_tmp118_, &_tmp119_);
#line 657 "../src/nibbles-game.vala"
			_tmp120_ = _tmp119_;
#line 657 "../src/nibbles-game.vala"
			_tmp121_ = _tmp114_[(_tmp117_.x * _tmp114__length2) + _tmp120_.y];
#line 657 "../src/nibbles-game.vala"
			if (_tmp121_ == ((gint) NIBBLES_GAME_WARPCHAR)) {
#line 3334 "nibbles-game.c"
				Worm* _tmp122_;
				gint* _tmp123_;
				gint _tmp123__length1;
				gint _tmp123__length2;
				Worm* _tmp124_;
				Position _tmp125_;
				Worm* _tmp126_;
#line 659 "../src/nibbles-game.vala"
				_tmp122_ = worm;
#line 659 "../src/nibbles-game.vala"
				_tmp123_ = self->board;
#line 659 "../src/nibbles-game.vala"
				_tmp123__length1 = self->board_length1;
#line 659 "../src/nibbles-game.vala"
				_tmp123__length2 = self->board_length2;
#line 659 "../src/nibbles-game.vala"
				_tmp124_ = worm;
#line 659 "../src/nibbles-game.vala"
				_tmp125_ = _tmp124_->warp_position;
#line 659 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp122_, _tmp123_, (gint) _tmp123__length1, (gint) _tmp123__length2, &_tmp125_);
#line 660 "../src/nibbles-game.vala"
				_tmp126_ = worm;
#line 660 "../src/nibbles-game.vala"
				if (_tmp126_->warp_bonus) {
#line 3360 "nibbles-game.c"
					Worm* _tmp127_;
					Worm* _tmp128_;
					gint _tmp129_;
					gint _tmp130_;
					Worm* _tmp131_;
					gint _tmp132_;
					gint _tmp133_;
					gint _tmp134_;
#line 662 "../src/nibbles-game.vala"
					_tmp127_ = worm;
#line 662 "../src/nibbles-game.vala"
					_tmp128_ = worm;
#line 662 "../src/nibbles-game.vala"
					_tmp129_ = worm_get_score (_tmp128_);
#line 662 "../src/nibbles-game.vala"
					_tmp130_ = _tmp129_;
#line 662 "../src/nibbles-game.vala"
					_tmp131_ = worm;
#line 662 "../src/nibbles-game.vala"
					_tmp132_ = worm_get_length (_tmp131_);
#line 662 "../src/nibbles-game.vala"
					_tmp133_ = _tmp132_;
#line 662 "../src/nibbles-game.vala"
					_tmp134_ = self->priv->_current_level;
#line 662 "../src/nibbles-game.vala"
					worm_set_score (_tmp128_, _tmp130_ + ((_tmp133_ * _tmp134_) / 2));
#line 663 "../src/nibbles-game.vala"
					g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 3389 "nibbles-game.c"
				}
			} else {
				Worm* _tmp135_;
				gint* _tmp136_;
				gint _tmp136__length1;
				gint _tmp136__length2;
#line 667 "../src/nibbles-game.vala"
				_tmp135_ = worm;
#line 667 "../src/nibbles-game.vala"
				_tmp136_ = self->board;
#line 667 "../src/nibbles-game.vala"
				_tmp136__length1 = self->board_length1;
#line 667 "../src/nibbles-game.vala"
				_tmp136__length2 = self->board_length2;
#line 667 "../src/nibbles-game.vala"
				worm_move_part_2 (_tmp135_, _tmp136_, (gint) _tmp136__length1, (gint) _tmp136__length2, NULL);
#line 3406 "nibbles-game.c"
			}
			{
				GeeLinkedList* _other_worm_list = NULL;
				GeeLinkedList* _tmp137_;
				gint _other_worm_size = 0;
				GeeLinkedList* _tmp138_;
				gint _tmp139_;
				gint _tmp140_;
				gint _other_worm_index = 0;
#line 670 "../src/nibbles-game.vala"
				_tmp137_ = self->priv->_worms;
#line 670 "../src/nibbles-game.vala"
				_other_worm_list = _tmp137_;
#line 670 "../src/nibbles-game.vala"
				_tmp138_ = _other_worm_list;
#line 670 "../src/nibbles-game.vala"
				_tmp139_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp138_);
#line 670 "../src/nibbles-game.vala"
				_tmp140_ = _tmp139_;
#line 670 "../src/nibbles-game.vala"
				_other_worm_size = _tmp140_;
#line 670 "../src/nibbles-game.vala"
				_other_worm_index = -1;
#line 670 "../src/nibbles-game.vala"
				while (TRUE) {
#line 3432 "nibbles-game.c"
					gint _tmp141_;
					gint _tmp142_;
					Worm* other_worm = NULL;
					GeeLinkedList* _tmp143_;
					gpointer _tmp144_;
					gboolean _tmp145_ = FALSE;
					gboolean _tmp146_ = FALSE;
					gboolean _tmp147_ = FALSE;
					gboolean _tmp148_ = FALSE;
					Worm* _tmp149_;
					Worm* _tmp150_;
#line 670 "../src/nibbles-game.vala"
					_other_worm_index = _other_worm_index + 1;
#line 670 "../src/nibbles-game.vala"
					_tmp141_ = _other_worm_index;
#line 670 "../src/nibbles-game.vala"
					_tmp142_ = _other_worm_size;
#line 670 "../src/nibbles-game.vala"
					if (!(_tmp141_ < _tmp142_)) {
#line 670 "../src/nibbles-game.vala"
						break;
#line 3454 "nibbles-game.c"
					}
#line 670 "../src/nibbles-game.vala"
					_tmp143_ = _other_worm_list;
#line 670 "../src/nibbles-game.vala"
					_tmp144_ = gee_abstract_list_get ((GeeAbstractList*) _tmp143_, _other_worm_index);
#line 670 "../src/nibbles-game.vala"
					other_worm = (Worm*) _tmp144_;
#line 672 "../src/nibbles-game.vala"
					_tmp149_ = worm;
#line 672 "../src/nibbles-game.vala"
					_tmp150_ = other_worm;
#line 672 "../src/nibbles-game.vala"
					if (_tmp149_ != _tmp150_) {
#line 3468 "nibbles-game.c"
						Worm* _tmp151_;
#line 673 "../src/nibbles-game.vala"
						_tmp151_ = other_worm;
#line 673 "../src/nibbles-game.vala"
						_tmp148_ = !_tmp151_->is_stopped;
#line 3474 "nibbles-game.c"
					} else {
#line 672 "../src/nibbles-game.vala"
						_tmp148_ = FALSE;
#line 3478 "nibbles-game.c"
					}
#line 672 "../src/nibbles-game.vala"
					if (_tmp148_) {
#line 3482 "nibbles-game.c"
						Worm* _tmp152_;
						WormPositions* _tmp153_;
						gboolean _tmp154_;
						gboolean _tmp155_;
#line 674 "../src/nibbles-game.vala"
						_tmp152_ = other_worm;
#line 674 "../src/nibbles-game.vala"
						_tmp153_ = _tmp152_->list;
#line 674 "../src/nibbles-game.vala"
						_tmp154_ = gee_collection_get_is_empty ((GeeCollection*) _tmp153_);
#line 674 "../src/nibbles-game.vala"
						_tmp155_ = _tmp154_;
#line 674 "../src/nibbles-game.vala"
						_tmp147_ = !_tmp155_;
#line 3497 "nibbles-game.c"
					} else {
#line 672 "../src/nibbles-game.vala"
						_tmp147_ = FALSE;
#line 3501 "nibbles-game.c"
					}
#line 672 "../src/nibbles-game.vala"
					if (_tmp147_) {
#line 3505 "nibbles-game.c"
						Worm* _tmp156_;
						Position _tmp157_ = {0};
						Position _tmp158_;
						Worm* _tmp159_;
						Position _tmp160_ = {0};
						Position _tmp161_;
#line 675 "../src/nibbles-game.vala"
						_tmp156_ = worm;
#line 675 "../src/nibbles-game.vala"
						worm_get_head (_tmp156_, &_tmp157_);
#line 675 "../src/nibbles-game.vala"
						_tmp158_ = _tmp157_;
#line 675 "../src/nibbles-game.vala"
						_tmp159_ = other_worm;
#line 675 "../src/nibbles-game.vala"
						worm_get_head (_tmp159_, &_tmp160_);
#line 675 "../src/nibbles-game.vala"
						_tmp161_ = _tmp160_;
#line 675 "../src/nibbles-game.vala"
						_tmp146_ = _tmp158_.x == _tmp161_.x;
#line 3526 "nibbles-game.c"
					} else {
#line 672 "../src/nibbles-game.vala"
						_tmp146_ = FALSE;
#line 3530 "nibbles-game.c"
					}
#line 672 "../src/nibbles-game.vala"
					if (_tmp146_) {
#line 3534 "nibbles-game.c"
						Worm* _tmp162_;
						Position _tmp163_ = {0};
						Position _tmp164_;
						Worm* _tmp165_;
						Position _tmp166_ = {0};
						Position _tmp167_;
#line 676 "../src/nibbles-game.vala"
						_tmp162_ = worm;
#line 676 "../src/nibbles-game.vala"
						worm_get_head (_tmp162_, &_tmp163_);
#line 676 "../src/nibbles-game.vala"
						_tmp164_ = _tmp163_;
#line 676 "../src/nibbles-game.vala"
						_tmp165_ = other_worm;
#line 676 "../src/nibbles-game.vala"
						worm_get_head (_tmp165_, &_tmp166_);
#line 676 "../src/nibbles-game.vala"
						_tmp167_ = _tmp166_;
#line 676 "../src/nibbles-game.vala"
						_tmp145_ = _tmp164_.y == _tmp167_.y;
#line 3555 "nibbles-game.c"
					} else {
#line 672 "../src/nibbles-game.vala"
						_tmp145_ = FALSE;
#line 3559 "nibbles-game.c"
					}
#line 672 "../src/nibbles-game.vala"
					if (_tmp145_) {
#line 3563 "nibbles-game.c"
						GeeLinkedList* _tmp168_;
						Worm* _tmp169_;
						GeeLinkedList* _tmp172_;
						Worm* _tmp173_;
#line 678 "../src/nibbles-game.vala"
						_tmp168_ = dead_worms;
#line 678 "../src/nibbles-game.vala"
						_tmp169_ = worm;
#line 678 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp168_, _tmp169_)) {
#line 3574 "nibbles-game.c"
							GeeLinkedList* _tmp170_;
							Worm* _tmp171_;
#line 679 "../src/nibbles-game.vala"
							_tmp170_ = dead_worms;
#line 679 "../src/nibbles-game.vala"
							_tmp171_ = worm;
#line 679 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp170_, _tmp171_);
#line 3583 "nibbles-game.c"
						}
#line 680 "../src/nibbles-game.vala"
						_tmp172_ = dead_worms;
#line 680 "../src/nibbles-game.vala"
						_tmp173_ = other_worm;
#line 680 "../src/nibbles-game.vala"
						if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp172_, _tmp173_)) {
#line 3591 "nibbles-game.c"
							GeeLinkedList* _tmp174_;
							Worm* _tmp175_;
#line 681 "../src/nibbles-game.vala"
							_tmp174_ = dead_worms;
#line 681 "../src/nibbles-game.vala"
							_tmp175_ = other_worm;
#line 681 "../src/nibbles-game.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp174_, _tmp175_);
#line 3600 "nibbles-game.c"
						}
					}
#line 670 "../src/nibbles-game.vala"
					_g_object_unref0 (other_worm);
#line 3605 "nibbles-game.c"
				}
			}
#line 649 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3610 "nibbles-game.c"
		}
	}
#line 687 "../src/nibbles-game.vala"
	_tmp176_ = self->priv->bonuses;
#line 687 "../src/nibbles-game.vala"
	_tmp177_ = self->priv->bouns_eaten;
#line 687 "../src/nibbles-game.vala"
	_tmp178_ = gee_collection_get_size ((GeeCollection*) _tmp177_);
#line 687 "../src/nibbles-game.vala"
	_tmp179_ = _tmp178_;
#line 687 "../src/nibbles-game.vala"
	nibbles_game_bonuses_decrement_regular_bonus (_tmp176_, _tmp179_);
#line 688 "../src/nibbles-game.vala"
	_tmp180_ = self->priv->bouns_eaten;
#line 688 "../src/nibbles-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp180_);
#line 3627 "nibbles-game.c"
	{
		GeeIterator* _bonus_it = NULL;
		GeeHashMap* _tmp181_;
		GeeIterator* _tmp182_;
#line 691 "../src/nibbles-game.vala"
		_tmp181_ = self->priv->_score_deltas;
#line 691 "../src/nibbles-game.vala"
		_tmp182_ = gee_iterable_iterator ((GeeIterable*) _tmp181_);
#line 691 "../src/nibbles-game.vala"
		_bonus_it = _tmp182_;
#line 691 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3640 "nibbles-game.c"
			GeeIterator* _tmp183_;
			GeeMapEntry* bonus = NULL;
			GeeIterator* _tmp184_;
			gpointer _tmp185_;
			gint how_many_worms_ate_the_bonus = 0;
			GeeMapEntry* _tmp186_;
			gconstpointer _tmp187_;
			gconstpointer _tmp188_;
			gint _tmp189_;
			gint _tmp190_;
			gboolean _tmp218_ = FALSE;
			GeeMapEntry* _tmp219_;
			gconstpointer _tmp220_;
			gconstpointer _tmp221_;
			BonuseType _tmp222_;
			BonuseType _tmp223_;
			gboolean real_bonus = FALSE;
			NibblesGameBonuses* _tmp229_;
			GeeMapEntry* _tmp230_;
			gconstpointer _tmp231_;
			gconstpointer _tmp232_;
			gboolean _tmp233_ = FALSE;
#line 691 "../src/nibbles-game.vala"
			_tmp183_ = _bonus_it;
#line 691 "../src/nibbles-game.vala"
			if (!gee_iterator_next (_tmp183_)) {
#line 691 "../src/nibbles-game.vala"
				break;
#line 3669 "nibbles-game.c"
			}
#line 691 "../src/nibbles-game.vala"
			_tmp184_ = _bonus_it;
#line 691 "../src/nibbles-game.vala"
			_tmp185_ = gee_iterator_get (_tmp184_);
#line 691 "../src/nibbles-game.vala"
			bonus = (GeeMapEntry*) _tmp185_;
#line 693 "../src/nibbles-game.vala"
			_tmp186_ = bonus;
#line 693 "../src/nibbles-game.vala"
			_tmp187_ = gee_map_entry_get_value (_tmp186_);
#line 693 "../src/nibbles-game.vala"
			_tmp188_ = _tmp187_;
#line 693 "../src/nibbles-game.vala"
			_tmp189_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) ((GeeLinkedList*) _tmp188_));
#line 693 "../src/nibbles-game.vala"
			_tmp190_ = _tmp189_;
#line 693 "../src/nibbles-game.vala"
			how_many_worms_ate_the_bonus = _tmp190_;
#line 3689 "nibbles-game.c"
			{
				GeeLinkedList* _score_delta_list = NULL;
				GeeMapEntry* _tmp191_;
				gconstpointer _tmp192_;
				gconstpointer _tmp193_;
				gint _score_delta_size = 0;
				GeeLinkedList* _tmp194_;
				gint _tmp195_;
				gint _tmp196_;
				gint _score_delta_index = 0;
#line 694 "../src/nibbles-game.vala"
				_tmp191_ = bonus;
#line 694 "../src/nibbles-game.vala"
				_tmp192_ = gee_map_entry_get_value (_tmp191_);
#line 694 "../src/nibbles-game.vala"
				_tmp193_ = _tmp192_;
#line 694 "../src/nibbles-game.vala"
				_score_delta_list = (GeeLinkedList*) _tmp193_;
#line 694 "../src/nibbles-game.vala"
				_tmp194_ = _score_delta_list;
#line 694 "../src/nibbles-game.vala"
				_tmp195_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp194_);
#line 694 "../src/nibbles-game.vala"
				_tmp196_ = _tmp195_;
#line 694 "../src/nibbles-game.vala"
				_score_delta_size = _tmp196_;
#line 694 "../src/nibbles-game.vala"
				_score_delta_index = -1;
#line 694 "../src/nibbles-game.vala"
				while (TRUE) {
#line 3720 "nibbles-game.c"
					gint _tmp197_;
					gint _tmp198_;
					NibblesGameScoreDelta* score_delta = NULL;
					GeeLinkedList* _tmp199_;
					gpointer _tmp200_;
					gint delta = 0;
					NibblesGameScoreDelta* _tmp201_;
					gint _tmp202_;
					gint _tmp203_;
					NibblesGameScoreDelta* _tmp204_;
					Worm* _tmp205_;
					Worm* _tmp206_;
					NibblesGameScoreDelta* _tmp207_;
					Worm* _tmp208_;
					Worm* _tmp209_;
					gint _tmp210_;
					gint _tmp211_;
					GeeMapEntry* _tmp212_;
					gconstpointer _tmp213_;
					gconstpointer _tmp214_;
					NibblesGameScoreDelta* _tmp215_;
					Worm* _tmp216_;
					Worm* _tmp217_;
#line 694 "../src/nibbles-game.vala"
					_score_delta_index = _score_delta_index + 1;
#line 694 "../src/nibbles-game.vala"
					_tmp197_ = _score_delta_index;
#line 694 "../src/nibbles-game.vala"
					_tmp198_ = _score_delta_size;
#line 694 "../src/nibbles-game.vala"
					if (!(_tmp197_ < _tmp198_)) {
#line 694 "../src/nibbles-game.vala"
						break;
#line 3754 "nibbles-game.c"
					}
#line 694 "../src/nibbles-game.vala"
					_tmp199_ = _score_delta_list;
#line 694 "../src/nibbles-game.vala"
					_tmp200_ = gee_abstract_list_get ((GeeAbstractList*) _tmp199_, _score_delta_index);
#line 694 "../src/nibbles-game.vala"
					score_delta = (NibblesGameScoreDelta*) _tmp200_;
#line 696 "../src/nibbles-game.vala"
					_tmp201_ = score_delta;
#line 696 "../src/nibbles-game.vala"
					_tmp202_ = nibbles_game_score_delta_get_score_delta (_tmp201_);
#line 696 "../src/nibbles-game.vala"
					_tmp203_ = _tmp202_;
#line 696 "../src/nibbles-game.vala"
					delta = _tmp203_ / how_many_worms_ate_the_bonus;
#line 697 "../src/nibbles-game.vala"
					_tmp204_ = score_delta;
#line 697 "../src/nibbles-game.vala"
					_tmp205_ = nibbles_game_score_delta_get_worm (_tmp204_);
#line 697 "../src/nibbles-game.vala"
					_tmp206_ = _tmp205_;
#line 697 "../src/nibbles-game.vala"
					_tmp207_ = score_delta;
#line 697 "../src/nibbles-game.vala"
					_tmp208_ = nibbles_game_score_delta_get_worm (_tmp207_);
#line 697 "../src/nibbles-game.vala"
					_tmp209_ = _tmp208_;
#line 697 "../src/nibbles-game.vala"
					_tmp210_ = worm_get_score (_tmp209_);
#line 697 "../src/nibbles-game.vala"
					_tmp211_ = _tmp210_;
#line 697 "../src/nibbles-game.vala"
					worm_set_score (_tmp209_, _tmp211_ + delta);
#line 698 "../src/nibbles-game.vala"
					_tmp212_ = bonus;
#line 698 "../src/nibbles-game.vala"
					_tmp213_ = gee_map_entry_get_key (_tmp212_);
#line 698 "../src/nibbles-game.vala"
					_tmp214_ = _tmp213_;
#line 698 "../src/nibbles-game.vala"
					_tmp215_ = score_delta;
#line 698 "../src/nibbles-game.vala"
					_tmp216_ = nibbles_game_score_delta_get_worm (_tmp215_);
#line 698 "../src/nibbles-game.vala"
					_tmp217_ = _tmp216_;
#line 698 "../src/nibbles-game.vala"
					g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL], 0, (Bonus*) _tmp214_, _tmp217_, delta);
#line 694 "../src/nibbles-game.vala"
					_g_object_unref0 (score_delta);
#line 3804 "nibbles-game.c"
				}
			}
#line 700 "../src/nibbles-game.vala"
			_tmp219_ = bonus;
#line 700 "../src/nibbles-game.vala"
			_tmp220_ = gee_map_entry_get_key (_tmp219_);
#line 700 "../src/nibbles-game.vala"
			_tmp221_ = _tmp220_;
#line 700 "../src/nibbles-game.vala"
			_tmp222_ = bonus_get_etype ((Bonus*) _tmp221_);
#line 700 "../src/nibbles-game.vala"
			_tmp223_ = _tmp222_;
#line 700 "../src/nibbles-game.vala"
			if (_tmp223_ == BONUS_ETYPE_REGULAR) {
#line 3819 "nibbles-game.c"
				GeeMapEntry* _tmp224_;
				gconstpointer _tmp225_;
				gconstpointer _tmp226_;
				gboolean _tmp227_;
				gboolean _tmp228_;
#line 700 "../src/nibbles-game.vala"
				_tmp224_ = bonus;
#line 700 "../src/nibbles-game.vala"
				_tmp225_ = gee_map_entry_get_key (_tmp224_);
#line 700 "../src/nibbles-game.vala"
				_tmp226_ = _tmp225_;
#line 700 "../src/nibbles-game.vala"
				_tmp227_ = bonus_get_fake ((Bonus*) _tmp226_);
#line 700 "../src/nibbles-game.vala"
				_tmp228_ = _tmp227_;
#line 700 "../src/nibbles-game.vala"
				_tmp218_ = !_tmp228_;
#line 3837 "nibbles-game.c"
			} else {
#line 700 "../src/nibbles-game.vala"
				_tmp218_ = FALSE;
#line 3841 "nibbles-game.c"
			}
#line 700 "../src/nibbles-game.vala"
			real_bonus = _tmp218_;
#line 701 "../src/nibbles-game.vala"
			_tmp229_ = self->priv->bonuses;
#line 701 "../src/nibbles-game.vala"
			_tmp230_ = bonus;
#line 701 "../src/nibbles-game.vala"
			_tmp231_ = gee_map_entry_get_key (_tmp230_);
#line 701 "../src/nibbles-game.vala"
			_tmp232_ = _tmp231_;
#line 701 "../src/nibbles-game.vala"
			nibbles_game_bonuses_remove_bonus (_tmp229_, (Bonus*) _tmp232_);
#line 702 "../src/nibbles-game.vala"
			if (real_bonus) {
#line 3857 "nibbles-game.c"
				NibblesGameBonuses* _tmp234_;
#line 702 "../src/nibbles-game.vala"
				_tmp234_ = self->priv->bonuses;
#line 702 "../src/nibbles-game.vala"
				_tmp233_ = !nibbles_game_bonuses_last_regular_bonus (_tmp234_);
#line 3863 "nibbles-game.c"
			} else {
#line 702 "../src/nibbles-game.vala"
				_tmp233_ = FALSE;
#line 3867 "nibbles-game.c"
			}
#line 702 "../src/nibbles-game.vala"
			if (_tmp233_) {
#line 703 "../src/nibbles-game.vala"
				nibbles_game_add_bonus (self, TRUE);
#line 3873 "nibbles-game.c"
			}
#line 691 "../src/nibbles-game.vala"
			_g_object_unref0 (bonus);
#line 3877 "nibbles-game.c"
		}
#line 691 "../src/nibbles-game.vala"
		_g_object_unref0 (_bonus_it);
#line 3881 "nibbles-game.c"
	}
#line 705 "../src/nibbles-game.vala"
	_tmp235_ = self->priv->_score_deltas;
#line 705 "../src/nibbles-game.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp235_);
#line 3887 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp236_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp237_;
		gint _tmp238_;
		gint _tmp239_;
		gint _worm_index = 0;
#line 708 "../src/nibbles-game.vala"
		_tmp236_ = dead_worms;
#line 708 "../src/nibbles-game.vala"
		_worm_list = _tmp236_;
#line 708 "../src/nibbles-game.vala"
		_tmp237_ = _worm_list;
#line 708 "../src/nibbles-game.vala"
		_tmp238_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp237_);
#line 708 "../src/nibbles-game.vala"
		_tmp239_ = _tmp238_;
#line 708 "../src/nibbles-game.vala"
		_worm_size = _tmp239_;
#line 708 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 708 "../src/nibbles-game.vala"
		while (TRUE) {
#line 3912 "nibbles-game.c"
			gint _tmp240_;
			gint _tmp241_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp242_;
			gpointer _tmp243_;
			gint _tmp244_;
			Worm* _tmp249_;
			guint8 _tmp250_;
			guint8 _tmp251_;
#line 708 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 708 "../src/nibbles-game.vala"
			_tmp240_ = _worm_index;
#line 708 "../src/nibbles-game.vala"
			_tmp241_ = _worm_size;
#line 708 "../src/nibbles-game.vala"
			if (!(_tmp240_ < _tmp241_)) {
#line 708 "../src/nibbles-game.vala"
				break;
#line 3932 "nibbles-game.c"
			}
#line 708 "../src/nibbles-game.vala"
			_tmp242_ = _worm_list;
#line 708 "../src/nibbles-game.vala"
			_tmp243_ = gee_abstract_list_get ((GeeAbstractList*) _tmp242_, _worm_index);
#line 708 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp243_;
#line 710 "../src/nibbles-game.vala"
			_tmp244_ = self->priv->_numworms;
#line 710 "../src/nibbles-game.vala"
			if (_tmp244_ > 1) {
#line 3944 "nibbles-game.c"
				Worm* _tmp245_;
				Worm* _tmp246_;
				gint _tmp247_;
				gint _tmp248_;
#line 711 "../src/nibbles-game.vala"
				_tmp245_ = worm;
#line 711 "../src/nibbles-game.vala"
				_tmp246_ = worm;
#line 711 "../src/nibbles-game.vala"
				_tmp247_ = worm_get_score (_tmp246_);
#line 711 "../src/nibbles-game.vala"
				_tmp248_ = _tmp247_;
#line 711 "../src/nibbles-game.vala"
				worm_set_score (_tmp245_, (_tmp248_ * 7) / 10);
#line 3959 "nibbles-game.c"
			}
#line 713 "../src/nibbles-game.vala"
			_tmp249_ = worm;
#line 713 "../src/nibbles-game.vala"
			_tmp250_ = worm_get_lives (_tmp249_);
#line 713 "../src/nibbles-game.vala"
			_tmp251_ = _tmp250_;
#line 713 "../src/nibbles-game.vala"
			if (((gint) _tmp251_) > 0) {
#line 3969 "nibbles-game.c"
				Worm* _tmp252_;
				gint* _tmp253_;
				gint _tmp253__length1;
				gint _tmp253__length2;
#line 714 "../src/nibbles-game.vala"
				_tmp252_ = worm;
#line 714 "../src/nibbles-game.vala"
				_tmp253_ = self->board;
#line 714 "../src/nibbles-game.vala"
				_tmp253__length1 = self->board_length1;
#line 714 "../src/nibbles-game.vala"
				_tmp253__length2 = self->board_length2;
#line 714 "../src/nibbles-game.vala"
				worm_reset (_tmp252_, _tmp253_, (gint) _tmp253__length1, (gint) _tmp253__length2);
#line 3984 "nibbles-game.c"
			}
#line 708 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 3988 "nibbles-game.c"
		}
	}
#line 718 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_REDRAW_SIGNAL], 0, TRUE);
#line 589 "../src/nibbles-game.vala"
	_g_object_unref0 (dead_worms);
#line 3995 "nibbles-game.c"
}

static void
nibbles_game_reverse_worms (NibblesGame* self,
                            Worm* worm)
{
#line 721 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 721 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 4006 "nibbles-game.c"
	{
		GeeLinkedList* _other_worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _other_worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _other_worm_index = 0;
#line 723 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 723 "../src/nibbles-game.vala"
		_other_worm_list = _tmp0_;
#line 723 "../src/nibbles-game.vala"
		_tmp1_ = _other_worm_list;
#line 723 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 723 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 723 "../src/nibbles-game.vala"
		_other_worm_size = _tmp3_;
#line 723 "../src/nibbles-game.vala"
		_other_worm_index = -1;
#line 723 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4031 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* other_worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
#line 723 "../src/nibbles-game.vala"
			_other_worm_index = _other_worm_index + 1;
#line 723 "../src/nibbles-game.vala"
			_tmp4_ = _other_worm_index;
#line 723 "../src/nibbles-game.vala"
			_tmp5_ = _other_worm_size;
#line 723 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 723 "../src/nibbles-game.vala"
				break;
#line 4048 "nibbles-game.c"
			}
#line 723 "../src/nibbles-game.vala"
			_tmp6_ = _other_worm_list;
#line 723 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _other_worm_index);
#line 723 "../src/nibbles-game.vala"
			other_worm = (Worm*) _tmp7_;
#line 724 "../src/nibbles-game.vala"
			_tmp8_ = other_worm;
#line 724 "../src/nibbles-game.vala"
			if (worm != _tmp8_) {
#line 4060 "nibbles-game.c"
				Worm* _tmp9_;
#line 725 "../src/nibbles-game.vala"
				_tmp9_ = other_worm;
#line 725 "../src/nibbles-game.vala"
				worm_reverse (_tmp9_);
#line 4066 "nibbles-game.c"
			}
#line 723 "../src/nibbles-game.vala"
			_g_object_unref0 (other_worm);
#line 4070 "nibbles-game.c"
		}
	}
}

static gboolean
nibbles_game_is_space_empty (NibblesGame* self,
                             guint8 x,
                             guint8 y,
                             gboolean* worms_at,
                             gint worms_at_length1,
                             gint worms_at_length2)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gint _tmp12_;
	gboolean result;
#line 731 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 733 "../src/nibbles-game.vala"
	_tmp11_ = self->board;
#line 733 "../src/nibbles-game.vala"
	_tmp11__length1 = self->board_length1;
#line 733 "../src/nibbles-game.vala"
	_tmp11__length2 = self->board_length2;
#line 733 "../src/nibbles-game.vala"
	_tmp12_ = _tmp11_[(x * _tmp11__length2) + y];
#line 733 "../src/nibbles-game.vala"
	if (((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp12_) {
#line 4111 "nibbles-game.c"
		gint* _tmp13_;
		gint _tmp13__length1;
		gint _tmp13__length2;
		gint _tmp14_;
#line 733 "../src/nibbles-game.vala"
		_tmp13_ = self->board;
#line 733 "../src/nibbles-game.vala"
		_tmp13__length1 = self->board_length1;
#line 733 "../src/nibbles-game.vala"
		_tmp13__length2 = self->board_length2;
#line 733 "../src/nibbles-game.vala"
		_tmp14_ = _tmp13_[((x + 1) * _tmp13__length2) + (y + 1)];
#line 733 "../src/nibbles-game.vala"
		_tmp10_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp14_;
#line 4126 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp10_ = FALSE;
#line 4130 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp10_) {
#line 4134 "nibbles-game.c"
		gint* _tmp15_;
		gint _tmp15__length1;
		gint _tmp15__length2;
		gint _tmp16_;
#line 734 "../src/nibbles-game.vala"
		_tmp15_ = self->board;
#line 734 "../src/nibbles-game.vala"
		_tmp15__length1 = self->board_length1;
#line 734 "../src/nibbles-game.vala"
		_tmp15__length2 = self->board_length2;
#line 734 "../src/nibbles-game.vala"
		_tmp16_ = _tmp15_[((x + 1) * _tmp15__length2) + y];
#line 734 "../src/nibbles-game.vala"
		_tmp9_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp16_;
#line 4149 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp9_ = FALSE;
#line 4153 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp9_) {
#line 4157 "nibbles-game.c"
		gint* _tmp17_;
		gint _tmp17__length1;
		gint _tmp17__length2;
		gint _tmp18_;
#line 734 "../src/nibbles-game.vala"
		_tmp17_ = self->board;
#line 734 "../src/nibbles-game.vala"
		_tmp17__length1 = self->board_length1;
#line 734 "../src/nibbles-game.vala"
		_tmp17__length2 = self->board_length2;
#line 734 "../src/nibbles-game.vala"
		_tmp18_ = _tmp17_[(x * _tmp17__length2) + (y + 1)];
#line 734 "../src/nibbles-game.vala"
		_tmp8_ = ((gint) NIBBLES_GAME_EMPTYCHAR) == _tmp18_;
#line 4172 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp8_ = FALSE;
#line 4176 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp8_) {
#line 4180 "nibbles-game.c"
		NibblesGameBonuses* _tmp19_;
		Bonus* _tmp20_;
		Bonus* _tmp21_;
#line 735 "../src/nibbles-game.vala"
		_tmp19_ = self->priv->bonuses;
#line 735 "../src/nibbles-game.vala"
		_tmp20_ = nibbles_game_bonuses_get_bonus (_tmp19_, x, y);
#line 735 "../src/nibbles-game.vala"
		_tmp21_ = _tmp20_;
#line 735 "../src/nibbles-game.vala"
		_tmp7_ = _tmp21_ == NULL;
#line 735 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp21_);
#line 4194 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp7_ = FALSE;
#line 4198 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp7_) {
#line 4202 "nibbles-game.c"
		NibblesGameBonuses* _tmp22_;
		Bonus* _tmp23_;
		Bonus* _tmp24_;
#line 735 "../src/nibbles-game.vala"
		_tmp22_ = self->priv->bonuses;
#line 735 "../src/nibbles-game.vala"
		_tmp23_ = nibbles_game_bonuses_get_bonus (_tmp22_, (guint8) (x + 1), (guint8) (y + 1));
#line 735 "../src/nibbles-game.vala"
		_tmp24_ = _tmp23_;
#line 735 "../src/nibbles-game.vala"
		_tmp6_ = _tmp24_ == NULL;
#line 735 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp24_);
#line 4216 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp6_ = FALSE;
#line 4220 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp6_) {
#line 4224 "nibbles-game.c"
		NibblesGameBonuses* _tmp25_;
		Bonus* _tmp26_;
		Bonus* _tmp27_;
#line 736 "../src/nibbles-game.vala"
		_tmp25_ = self->priv->bonuses;
#line 736 "../src/nibbles-game.vala"
		_tmp26_ = nibbles_game_bonuses_get_bonus (_tmp25_, (guint8) (x + 1), y);
#line 736 "../src/nibbles-game.vala"
		_tmp27_ = _tmp26_;
#line 736 "../src/nibbles-game.vala"
		_tmp5_ = _tmp27_ == NULL;
#line 736 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp27_);
#line 4238 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp5_ = FALSE;
#line 4242 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp5_) {
#line 4246 "nibbles-game.c"
		NibblesGameBonuses* _tmp28_;
		Bonus* _tmp29_;
		Bonus* _tmp30_;
#line 736 "../src/nibbles-game.vala"
		_tmp28_ = self->priv->bonuses;
#line 736 "../src/nibbles-game.vala"
		_tmp29_ = nibbles_game_bonuses_get_bonus (_tmp28_, x, (guint8) (y + 1));
#line 736 "../src/nibbles-game.vala"
		_tmp30_ = _tmp29_;
#line 736 "../src/nibbles-game.vala"
		_tmp4_ = _tmp30_ == NULL;
#line 736 "../src/nibbles-game.vala"
		_g_object_unref0 (_tmp30_);
#line 4260 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp4_ = FALSE;
#line 4264 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp4_) {
#line 4268 "nibbles-game.c"
		gboolean _tmp31_;
#line 737 "../src/nibbles-game.vala"
		_tmp31_ = worms_at[(x * worms_at_length2) + y];
#line 737 "../src/nibbles-game.vala"
		_tmp3_ = !_tmp31_;
#line 4274 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp3_ = FALSE;
#line 4278 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp3_) {
#line 4282 "nibbles-game.c"
		gboolean _tmp32_;
#line 737 "../src/nibbles-game.vala"
		_tmp32_ = worms_at[((x + 1) * worms_at_length2) + (y + 1)];
#line 737 "../src/nibbles-game.vala"
		_tmp2_ = !_tmp32_;
#line 4288 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp2_ = FALSE;
#line 4292 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp2_) {
#line 4296 "nibbles-game.c"
		gboolean _tmp33_;
#line 738 "../src/nibbles-game.vala"
		_tmp33_ = worms_at[((x + 1) * worms_at_length2) + y];
#line 738 "../src/nibbles-game.vala"
		_tmp1_ = !_tmp33_;
#line 4302 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp1_ = FALSE;
#line 4306 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 4310 "nibbles-game.c"
		gboolean _tmp34_;
#line 738 "../src/nibbles-game.vala"
		_tmp34_ = worms_at[(x * worms_at_length2) + (y + 1)];
#line 738 "../src/nibbles-game.vala"
		_tmp0_ = !_tmp34_;
#line 4316 "nibbles-game.c"
	} else {
#line 733 "../src/nibbles-game.vala"
		_tmp0_ = FALSE;
#line 4320 "nibbles-game.c"
	}
#line 733 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 733 "../src/nibbles-game.vala"
	return result;
#line 4326 "nibbles-game.c"
}

static void
nibbles_game_add_bonus (NibblesGame* self,
                        gboolean regular)
{
	gboolean good = FALSE;
	guint8 x = 0U;
	guint8 y = 0U;
	gboolean* worms_at = NULL;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gboolean* _tmp2_;
	gint worms_at_length1;
	gint worms_at_length2;
#line 741 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 743 "../src/nibbles-game.vala"
	good = FALSE;
#line 744 "../src/nibbles-game.vala"
	x = (guint8) 0;
#line 745 "../src/nibbles-game.vala"
	y = (guint8) 0;
#line 746 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 746 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 746 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gboolean, _tmp0_ * _tmp1_);
#line 746 "../src/nibbles-game.vala"
	worms_at = _tmp2_;
#line 746 "../src/nibbles-game.vala"
	worms_at_length1 = _tmp0_;
#line 746 "../src/nibbles-game.vala"
	worms_at_length2 = _tmp1_;
#line 748 "../src/nibbles-game.vala"
	if (!regular) {
#line 750 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 50) != ((gint32) 0)) {
#line 751 "../src/nibbles-game.vala"
			worms_at = (g_free (worms_at), NULL);
#line 751 "../src/nibbles-game.vala"
			return;
#line 4370 "nibbles-game.c"
		}
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp3_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint _worm_index = 0;
#line 754 "../src/nibbles-game.vala"
		_tmp3_ = self->priv->_worms;
#line 754 "../src/nibbles-game.vala"
		_worm_list = _tmp3_;
#line 754 "../src/nibbles-game.vala"
		_tmp4_ = _worm_list;
#line 754 "../src/nibbles-game.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 754 "../src/nibbles-game.vala"
		_tmp6_ = _tmp5_;
#line 754 "../src/nibbles-game.vala"
		_worm_size = _tmp6_;
#line 754 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 754 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4397 "nibbles-game.c"
			gint _tmp7_;
			gint _tmp8_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp9_;
			gpointer _tmp10_;
			Worm* _tmp11_;
#line 754 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 754 "../src/nibbles-game.vala"
			_tmp7_ = _worm_index;
#line 754 "../src/nibbles-game.vala"
			_tmp8_ = _worm_size;
#line 754 "../src/nibbles-game.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 754 "../src/nibbles-game.vala"
				break;
#line 4414 "nibbles-game.c"
			}
#line 754 "../src/nibbles-game.vala"
			_tmp9_ = _worm_list;
#line 754 "../src/nibbles-game.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _worm_index);
#line 754 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp10_;
#line 755 "../src/nibbles-game.vala"
			_tmp11_ = worm;
#line 755 "../src/nibbles-game.vala"
			if (!_tmp11_->is_stopped) {
#line 4426 "nibbles-game.c"
				{
					WormPositions* _p_list = NULL;
					Worm* _tmp12_;
					WormPositions* _tmp13_;
					gint _p_size = 0;
					WormPositions* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					gint _p_index = 0;
#line 756 "../src/nibbles-game.vala"
					_tmp12_ = worm;
#line 756 "../src/nibbles-game.vala"
					_tmp13_ = _tmp12_->list;
#line 756 "../src/nibbles-game.vala"
					_p_list = _tmp13_;
#line 756 "../src/nibbles-game.vala"
					_tmp14_ = _p_list;
#line 756 "../src/nibbles-game.vala"
					_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
#line 756 "../src/nibbles-game.vala"
					_tmp16_ = _tmp15_;
#line 756 "../src/nibbles-game.vala"
					_p_size = _tmp16_;
#line 756 "../src/nibbles-game.vala"
					_p_index = -1;
#line 756 "../src/nibbles-game.vala"
					while (TRUE) {
#line 4454 "nibbles-game.c"
						gint _tmp17_;
						gint _tmp18_;
						guint16 p = 0U;
						WormPositions* _tmp19_;
						gpointer _tmp20_;
						gboolean* _tmp21_;
						gint _tmp21__length1;
						gint _tmp21__length2;
#line 756 "../src/nibbles-game.vala"
						_p_index = _p_index + 1;
#line 756 "../src/nibbles-game.vala"
						_tmp17_ = _p_index;
#line 756 "../src/nibbles-game.vala"
						_tmp18_ = _p_size;
#line 756 "../src/nibbles-game.vala"
						if (!(_tmp17_ < _tmp18_)) {
#line 756 "../src/nibbles-game.vala"
							break;
#line 4473 "nibbles-game.c"
						}
#line 756 "../src/nibbles-game.vala"
						_tmp19_ = _p_list;
#line 756 "../src/nibbles-game.vala"
						_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _p_index);
#line 756 "../src/nibbles-game.vala"
						p = (guint16) ((guintptr) _tmp20_);
#line 757 "../src/nibbles-game.vala"
						_tmp21_ = worms_at;
#line 757 "../src/nibbles-game.vala"
						_tmp21__length1 = worms_at_length1;
#line 757 "../src/nibbles-game.vala"
						_tmp21__length2 = worms_at_length2;
#line 757 "../src/nibbles-game.vala"
						_tmp21_[((p >> 8) * _tmp21__length2) + ((guint8) p)] = TRUE;
#line 4489 "nibbles-game.c"
					}
				}
			}
#line 754 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 4495 "nibbles-game.c"
		}
	}
	{
		gboolean _tmp22_ = FALSE;
#line 759 "../src/nibbles-game.vala"
		_tmp22_ = TRUE;
#line 759 "../src/nibbles-game.vala"
		while (TRUE) {
#line 4504 "nibbles-game.c"
			guint8 _tmp24_;
			guint8 _tmp25_;
#line 759 "../src/nibbles-game.vala"
			if (!_tmp22_) {
#line 4509 "nibbles-game.c"
				gboolean* _tmp23_;
				gint _tmp23__length1;
				gint _tmp23__length2;
#line 763 "../src/nibbles-game.vala"
				_tmp23_ = worms_at;
#line 763 "../src/nibbles-game.vala"
				_tmp23__length1 = worms_at_length1;
#line 763 "../src/nibbles-game.vala"
				_tmp23__length2 = worms_at_length2;
#line 763 "../src/nibbles-game.vala"
				if (!(!nibbles_game_is_space_empty (self, x, y, _tmp23_, (gint) _tmp23__length1, (gint) _tmp23__length2))) {
#line 763 "../src/nibbles-game.vala"
					break;
#line 4523 "nibbles-game.c"
				}
			}
#line 759 "../src/nibbles-game.vala"
			_tmp22_ = FALSE;
#line 761 "../src/nibbles-game.vala"
			_tmp24_ = self->priv->_width;
#line 761 "../src/nibbles-game.vala"
			x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp24_ - 1));
#line 762 "../src/nibbles-game.vala"
			_tmp25_ = self->priv->_height;
#line 762 "../src/nibbles-game.vala"
			y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp25_ - 1));
#line 4536 "nibbles-game.c"
		}
	}
#line 765 "../src/nibbles-game.vala"
	if (regular) {
#line 4541 "nibbles-game.c"
		gboolean _tmp26_ = FALSE;
#line 767 "../src/nibbles-game.vala"
		if (g_random_int_range ((gint32) 0, (gint32) 7) == ((gint32) 0)) {
#line 4545 "nibbles-game.c"
			gboolean _tmp27_;
#line 767 "../src/nibbles-game.vala"
			_tmp27_ = self->priv->_fakes;
#line 767 "../src/nibbles-game.vala"
			_tmp26_ = _tmp27_;
#line 4551 "nibbles-game.c"
		} else {
#line 767 "../src/nibbles-game.vala"
			_tmp26_ = FALSE;
#line 4555 "nibbles-game.c"
		}
#line 767 "../src/nibbles-game.vala"
		if (_tmp26_) {
#line 768 "../src/nibbles-game.vala"
			_nibbles_game_add_bonus (self, x, y, BONUS_ETYPE_REGULAR, TRUE, (guint16) 300);
#line 4561 "nibbles-game.c"
		}
		{
			gboolean _tmp28_ = FALSE;
#line 770 "../src/nibbles-game.vala"
			_tmp28_ = TRUE;
#line 770 "../src/nibbles-game.vala"
			while (TRUE) {
#line 4569 "nibbles-game.c"
				guint8 _tmp30_;
				guint8 _tmp31_;
#line 770 "../src/nibbles-game.vala"
				if (!_tmp28_) {
#line 4574 "nibbles-game.c"
					gboolean* _tmp29_;
					gint _tmp29__length1;
					gint _tmp29__length2;
#line 774 "../src/nibbles-game.vala"
					_tmp29_ = worms_at;
#line 774 "../src/nibbles-game.vala"
					_tmp29__length1 = worms_at_length1;
#line 774 "../src/nibbles-game.vala"
					_tmp29__length2 = worms_at_length2;
#line 774 "../src/nibbles-game.vala"
					if (!(!nibbles_game_is_space_empty (self, x, y, _tmp29_, (gint) _tmp29__length1, (gint) _tmp29__length2))) {
#line 774 "../src/nibbles-game.vala"
						break;
#line 4588 "nibbles-game.c"
					}
				}
#line 770 "../src/nibbles-game.vala"
				_tmp28_ = FALSE;
#line 772 "../src/nibbles-game.vala"
				_tmp30_ = self->priv->_width;
#line 772 "../src/nibbles-game.vala"
				x = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp30_ - 1));
#line 773 "../src/nibbles-game.vala"
				_tmp31_ = self->priv->_height;
#line 773 "../src/nibbles-game.vala"
				y = (guint8) g_random_int_range ((gint32) 0, (gint32) (_tmp31_ - 1));
#line 4601 "nibbles-game.c"
			}
		}
#line 775 "../src/nibbles-game.vala"
		_nibbles_game_add_bonus (self, x, y, BONUS_ETYPE_REGULAR, FALSE, (guint16) 300);
#line 4606 "nibbles-game.c"
	} else {
		NibblesGameBonuses* _tmp32_;
#line 777 "../src/nibbles-game.vala"
		_tmp32_ = self->priv->bonuses;
#line 777 "../src/nibbles-game.vala"
		if (!nibbles_game_bonuses_too_many_missed (_tmp32_)) {
#line 4613 "nibbles-game.c"
			gboolean _tmp33_ = FALSE;
#line 779 "../src/nibbles-game.vala"
			if (g_random_int_range ((gint32) 0, (gint32) 7) != ((gint32) 0)) {
#line 780 "../src/nibbles-game.vala"
				good = FALSE;
#line 4619 "nibbles-game.c"
			} else {
#line 782 "../src/nibbles-game.vala"
				good = TRUE;
#line 4623 "nibbles-game.c"
			}
#line 784 "../src/nibbles-game.vala"
			if (good) {
#line 4627 "nibbles-game.c"
				gboolean _tmp34_;
#line 784 "../src/nibbles-game.vala"
				_tmp34_ = self->priv->_fakes;
#line 784 "../src/nibbles-game.vala"
				_tmp33_ = !_tmp34_;
#line 4633 "nibbles-game.c"
			} else {
#line 784 "../src/nibbles-game.vala"
				_tmp33_ = FALSE;
#line 4637 "nibbles-game.c"
			}
#line 784 "../src/nibbles-game.vala"
			if (_tmp33_) {
#line 785 "../src/nibbles-game.vala"
				worms_at = (g_free (worms_at), NULL);
#line 785 "../src/nibbles-game.vala"
				return;
#line 4645 "nibbles-game.c"
			}
#line 787 "../src/nibbles-game.vala"
			switch (g_random_int_range ((gint32) 0, (gint32) 21)) {
#line 787 "../src/nibbles-game.vala"
				case 0:
#line 787 "../src/nibbles-game.vala"
				case 1:
#line 787 "../src/nibbles-game.vala"
				case 2:
#line 787 "../src/nibbles-game.vala"
				case 3:
#line 787 "../src/nibbles-game.vala"
				case 4:
#line 787 "../src/nibbles-game.vala"
				case 5:
#line 787 "../src/nibbles-game.vala"
				case 6:
#line 787 "../src/nibbles-game.vala"
				case 7:
#line 787 "../src/nibbles-game.vala"
				case 8:
#line 787 "../src/nibbles-game.vala"
				case 9:
#line 4669 "nibbles-game.c"
				{
#line 799 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_ETYPE_HALF, good, (guint16) 200);
#line 800 "../src/nibbles-game.vala"
					break;
#line 4675 "nibbles-game.c"
				}
#line 787 "../src/nibbles-game.vala"
				case 10:
#line 787 "../src/nibbles-game.vala"
				case 11:
#line 787 "../src/nibbles-game.vala"
				case 12:
#line 787 "../src/nibbles-game.vala"
				case 13:
#line 787 "../src/nibbles-game.vala"
				case 14:
#line 4687 "nibbles-game.c"
				{
#line 806 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_ETYPE_DOUBLE, good, (guint16) 150);
#line 807 "../src/nibbles-game.vala"
					break;
#line 4693 "nibbles-game.c"
				}
#line 787 "../src/nibbles-game.vala"
				case 15:
#line 4697 "nibbles-game.c"
				{
#line 809 "../src/nibbles-game.vala"
					_nibbles_game_add_bonus (self, x, y, BONUS_ETYPE_LIFE, good, (guint16) 100);
#line 810 "../src/nibbles-game.vala"
					break;
#line 4703 "nibbles-game.c"
				}
#line 787 "../src/nibbles-game.vala"
				case 16:
#line 787 "../src/nibbles-game.vala"
				case 17:
#line 787 "../src/nibbles-game.vala"
				case 18:
#line 787 "../src/nibbles-game.vala"
				case 19:
#line 787 "../src/nibbles-game.vala"
				case 20:
#line 4715 "nibbles-game.c"
				{
					gint _tmp35_;
#line 816 "../src/nibbles-game.vala"
					_tmp35_ = self->priv->_numworms;
#line 816 "../src/nibbles-game.vala"
					if (_tmp35_ > 1) {
#line 817 "../src/nibbles-game.vala"
						_nibbles_game_add_bonus (self, x, y, BONUS_ETYPE_REVERSE, good, (guint16) 150);
#line 4724 "nibbles-game.c"
					}
#line 818 "../src/nibbles-game.vala"
					break;
#line 4728 "nibbles-game.c"
				}
				default:
#line 787 "../src/nibbles-game.vala"
				break;
#line 4733 "nibbles-game.c"
			}
		}
	}
#line 741 "../src/nibbles-game.vala"
	worms_at = (g_free (worms_at), NULL);
#line 4739 "nibbles-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 825 "../src/nibbles-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 4747 "nibbles-game.c"
}

static inline void
_nibbles_game_add_bonus (NibblesGame* self,
                         guint8 x,
                         guint8 y,
                         BonuseType bonus_type,
                         gboolean fake,
                         guint16 countdown)
{
	Bonus* bonus = NULL;
	Bonus* _tmp0_;
	NibblesGameBonuses* _tmp1_;
	Bonus* _tmp2_;
	Bonus* _tmp3_;
#line 822 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 824 "../src/nibbles-game.vala"
	_tmp0_ = bonus_new (x, y, (GType) bonus_type, fake, countdown);
#line 824 "../src/nibbles-game.vala"
	bonus = _tmp0_;
#line 825 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->bonuses;
#line 825 "../src/nibbles-game.vala"
	_tmp2_ = bonus;
#line 825 "../src/nibbles-game.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 825 "../src/nibbles-game.vala"
	if (nibbles_game_bonuses_add_bonus (_tmp1_, _tmp3_)) {
#line 4777 "nibbles-game.c"
		Bonus* _tmp4_;
		BonuseType _tmp5_;
		BonuseType _tmp6_;
#line 826 "../src/nibbles-game.vala"
		_tmp4_ = bonus;
#line 826 "../src/nibbles-game.vala"
		_tmp5_ = bonus_get_etype (_tmp4_);
#line 826 "../src/nibbles-game.vala"
		_tmp6_ = _tmp5_;
#line 826 "../src/nibbles-game.vala"
		if (_tmp6_ != BONUS_ETYPE_REGULAR) {
#line 827 "../src/nibbles-game.vala"
			g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "appear");
#line 4791 "nibbles-game.c"
		}
	}
#line 822 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 4796 "nibbles-game.c"
}

static gint
nibbles_game_calculate_bonus (NibblesGame* self,
                              Bonus* bonus,
                              Worm* worm)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	gint result;
#line 830 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 830 "../src/nibbles-game.vala"
	g_return_val_if_fail (bonus != NULL, 0);
#line 830 "../src/nibbles-game.vala"
	g_return_val_if_fail (worm != NULL, 0);
#line 832 "../src/nibbles-game.vala"
	_tmp0_ = bonus_get_fake (bonus);
#line 832 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 832 "../src/nibbles-game.vala"
	if (_tmp1_) {
#line 834 "../src/nibbles-game.vala"
		worm_reverse (worm);
#line 835 "../src/nibbles-game.vala"
		result = 0;
#line 835 "../src/nibbles-game.vala"
		return result;
#line 4825 "nibbles-game.c"
	} else {
		gint score_delta = 0;
		BonuseType _tmp2_;
		BonuseType _tmp3_;
#line 839 "../src/nibbles-game.vala"
		score_delta = 0;
#line 840 "../src/nibbles-game.vala"
		_tmp2_ = bonus_get_etype (bonus);
#line 840 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 840 "../src/nibbles-game.vala"
		switch (_tmp3_) {
#line 840 "../src/nibbles-game.vala"
			case BONUS_ETYPE_REGULAR:
#line 4840 "nibbles-game.c"
			{
				guint8 nth_bonus = 0U;
				NibblesGameBonuses* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				gint _tmp7_;
				GeeSet* _tmp8_;
#line 843 "../src/nibbles-game.vala"
				_tmp4_ = self->priv->bonuses;
#line 843 "../src/nibbles-game.vala"
				nth_bonus = nibbles_game_bonuses_new_regular_bonus_eaten (_tmp4_);
#line 844 "../src/nibbles-game.vala"
				_tmp5_ = worm_get_change (worm);
#line 844 "../src/nibbles-game.vala"
				_tmp6_ = _tmp5_;
#line 844 "../src/nibbles-game.vala"
				worm_set_change (worm, _tmp6_ + (((gint) nth_bonus) * WORM_GROW_FACTOR));
#line 845 "../src/nibbles-game.vala"
				_tmp7_ = self->priv->_current_level;
#line 845 "../src/nibbles-game.vala"
				score_delta = ((gint) nth_bonus) * _tmp7_;
#line 846 "../src/nibbles-game.vala"
				_tmp8_ = self->priv->bouns_eaten;
#line 846 "../src/nibbles-game.vala"
				gee_collection_add ((GeeCollection*) _tmp8_, bonus);
#line 847 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "gobble");
#line 848 "../src/nibbles-game.vala"
				break;
#line 4870 "nibbles-game.c"
			}
#line 840 "../src/nibbles-game.vala"
			case BONUS_ETYPE_DOUBLE:
#line 4874 "nibbles-game.c"
			{
				gint _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
#line 850 "../src/nibbles-game.vala"
				_tmp9_ = worm_get_length (worm);
#line 850 "../src/nibbles-game.vala"
				_tmp10_ = _tmp9_;
#line 850 "../src/nibbles-game.vala"
				_tmp11_ = worm_get_change (worm);
#line 850 "../src/nibbles-game.vala"
				_tmp12_ = _tmp11_;
#line 850 "../src/nibbles-game.vala"
				_tmp13_ = self->priv->_current_level;
#line 850 "../src/nibbles-game.vala"
				score_delta = (_tmp10_ + _tmp12_) * _tmp13_;
#line 851 "../src/nibbles-game.vala"
				_tmp14_ = worm_get_change (worm);
#line 851 "../src/nibbles-game.vala"
				_tmp15_ = _tmp14_;
#line 851 "../src/nibbles-game.vala"
				_tmp16_ = worm_get_length (worm);
#line 851 "../src/nibbles-game.vala"
				_tmp17_ = _tmp16_;
#line 851 "../src/nibbles-game.vala"
				_tmp18_ = worm_get_change (worm);
#line 851 "../src/nibbles-game.vala"
				_tmp19_ = _tmp18_;
#line 851 "../src/nibbles-game.vala"
				worm_set_change (worm, _tmp15_ + (_tmp17_ + _tmp19_));
#line 852 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 853 "../src/nibbles-game.vala"
				break;
#line 4917 "nibbles-game.c"
			}
#line 840 "../src/nibbles-game.vala"
			case BONUS_ETYPE_HALF:
#line 4921 "nibbles-game.c"
			{
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				gint _tmp23_;
#line 855 "../src/nibbles-game.vala"
				_tmp20_ = worm_get_length (worm);
#line 855 "../src/nibbles-game.vala"
				_tmp21_ = _tmp20_;
#line 855 "../src/nibbles-game.vala"
				_tmp22_ = worm_get_change (worm);
#line 855 "../src/nibbles-game.vala"
				_tmp23_ = _tmp22_;
#line 855 "../src/nibbles-game.vala"
				if ((_tmp21_ + _tmp23_) > 2) {
#line 4937 "nibbles-game.c"
					gint _tmp24_;
					gint _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					gint _tmp32_;
					gint _tmp33_;
					gint _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
#line 857 "../src/nibbles-game.vala"
					_tmp24_ = worm_get_length (worm);
#line 857 "../src/nibbles-game.vala"
					_tmp25_ = _tmp24_;
#line 857 "../src/nibbles-game.vala"
					_tmp26_ = worm_get_change (worm);
#line 857 "../src/nibbles-game.vala"
					_tmp27_ = _tmp26_;
#line 857 "../src/nibbles-game.vala"
					_tmp28_ = self->priv->_current_level;
#line 857 "../src/nibbles-game.vala"
					score_delta = (_tmp25_ + (_tmp27_ / 2)) * _tmp28_;
#line 858 "../src/nibbles-game.vala"
					_tmp29_ = worm_get_length (worm);
#line 858 "../src/nibbles-game.vala"
					_tmp30_ = _tmp29_;
#line 858 "../src/nibbles-game.vala"
					worm_reduce_tail (worm, _tmp30_ / 2);
#line 859 "../src/nibbles-game.vala"
					_tmp31_ = worm_get_change (worm);
#line 859 "../src/nibbles-game.vala"
					_tmp32_ = _tmp31_;
#line 859 "../src/nibbles-game.vala"
					_tmp33_ = worm_get_length (worm);
#line 859 "../src/nibbles-game.vala"
					_tmp34_ = _tmp33_;
#line 859 "../src/nibbles-game.vala"
					_tmp35_ = worm_get_change (worm);
#line 859 "../src/nibbles-game.vala"
					_tmp36_ = _tmp35_;
#line 859 "../src/nibbles-game.vala"
					worm_set_change (worm, _tmp32_ - ((_tmp34_ + _tmp36_) / 2));
#line 4983 "nibbles-game.c"
				}
#line 861 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "bonus");
#line 862 "../src/nibbles-game.vala"
				break;
#line 4989 "nibbles-game.c"
			}
#line 840 "../src/nibbles-game.vala"
			case BONUS_ETYPE_LIFE:
#line 4993 "nibbles-game.c"
			{
#line 864 "../src/nibbles-game.vala"
				worm_add_life (worm);
#line 865 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "life");
#line 866 "../src/nibbles-game.vala"
				break;
#line 5001 "nibbles-game.c"
			}
#line 840 "../src/nibbles-game.vala"
			case BONUS_ETYPE_REVERSE:
#line 5005 "nibbles-game.c"
			{
#line 868 "../src/nibbles-game.vala"
				nibbles_game_reverse_worms (self, worm);
#line 869 "../src/nibbles-game.vala"
				g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL], 0, "reverse");
#line 870 "../src/nibbles-game.vala"
				break;
#line 5013 "nibbles-game.c"
			}
#line 840 "../src/nibbles-game.vala"
			case BONUS_ETYPE_WARP:
#line 5017 "nibbles-game.c"
			{
#line 872 "../src/nibbles-game.vala"
				break;
#line 5021 "nibbles-game.c"
			}
			default:
#line 840 "../src/nibbles-game.vala"
			break;
#line 5026 "nibbles-game.c"
		}
#line 874 "../src/nibbles-game.vala"
		result = score_delta;
#line 874 "../src/nibbles-game.vala"
		return result;
#line 5032 "nibbles-game.c"
	}
}

static void
nibbles_game_bonus_found_cb (NibblesGame* self,
                             Worm* worm)
{
	Bonus* bonus = NULL;
	NibblesGameBonuses* _tmp0_;
	Position _tmp1_ = {0};
	Position _tmp2_;
	Position _tmp3_ = {0};
	Position _tmp4_;
	Bonus* _tmp5_;
	Bonus* _tmp6_;
#line 878 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 878 "../src/nibbles-game.vala"
	g_return_if_fail (worm != NULL);
#line 880 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->bonuses;
#line 880 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp1_);
#line 880 "../src/nibbles-game.vala"
	_tmp2_ = _tmp1_;
#line 880 "../src/nibbles-game.vala"
	worm_get_head (worm, &_tmp3_);
#line 880 "../src/nibbles-game.vala"
	_tmp4_ = _tmp3_;
#line 880 "../src/nibbles-game.vala"
	_tmp5_ = nibbles_game_bonuses_get_bonus (_tmp0_, _tmp2_.x, _tmp4_.y);
#line 880 "../src/nibbles-game.vala"
	bonus = _tmp5_;
#line 881 "../src/nibbles-game.vala"
	_tmp6_ = bonus;
#line 881 "../src/nibbles-game.vala"
	if (_tmp6_ != NULL) {
#line 5070 "nibbles-game.c"
		Position _tmp7_ = {0};
		Position _tmp8_;
		Position _tmp9_ = {0};
		Position _tmp10_;
		NibblesGameScoreDelta* score_delta = NULL;
		Bonus* _tmp11_;
		NibblesGameScoreDelta* _tmp12_;
		GeeLinkedList* delta = NULL;
		GeeHashMap* _tmp13_;
		Bonus* _tmp14_;
		gpointer _tmp15_;
		GeeLinkedList* _tmp16_;
		GeeLinkedList* _tmp21_;
		NibblesGameScoreDelta* _tmp22_;
#line 883 "../src/nibbles-game.vala"
		worm_get_head (worm, &_tmp7_);
#line 883 "../src/nibbles-game.vala"
		_tmp8_ = _tmp7_;
#line 883 "../src/nibbles-game.vala"
		worm_get_head (worm, &_tmp9_);
#line 883 "../src/nibbles-game.vala"
		_tmp10_ = _tmp9_;
#line 883 "../src/nibbles-game.vala"
		worm_add_bonus_eaten_position (worm, _tmp8_.x, _tmp10_.y);
#line 884 "../src/nibbles-game.vala"
		_tmp11_ = bonus;
#line 884 "../src/nibbles-game.vala"
		_tmp12_ = nibbles_game_score_delta_new (worm, nibbles_game_calculate_bonus (self, _tmp11_, worm));
#line 884 "../src/nibbles-game.vala"
		score_delta = _tmp12_;
#line 885 "../src/nibbles-game.vala"
		_tmp13_ = self->priv->_score_deltas;
#line 885 "../src/nibbles-game.vala"
		_tmp14_ = bonus;
#line 885 "../src/nibbles-game.vala"
		_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp13_, _tmp14_);
#line 885 "../src/nibbles-game.vala"
		delta = (GeeLinkedList*) _tmp15_;
#line 886 "../src/nibbles-game.vala"
		_tmp16_ = delta;
#line 886 "../src/nibbles-game.vala"
		if (_tmp16_ == NULL) {
#line 5113 "nibbles-game.c"
			GeeLinkedList* _tmp17_;
			GeeHashMap* _tmp18_;
			Bonus* _tmp19_;
			GeeLinkedList* _tmp20_;
#line 888 "../src/nibbles-game.vala"
			_tmp17_ = gee_linked_list_new (NIBBLES_GAME_TYPE_SCORE_DELTA, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 888 "../src/nibbles-game.vala"
			_g_object_unref0 (delta);
#line 888 "../src/nibbles-game.vala"
			delta = _tmp17_;
#line 889 "../src/nibbles-game.vala"
			_tmp18_ = self->priv->_score_deltas;
#line 889 "../src/nibbles-game.vala"
			_tmp19_ = bonus;
#line 889 "../src/nibbles-game.vala"
			_tmp20_ = delta;
#line 889 "../src/nibbles-game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, _tmp19_, _tmp20_);
#line 5132 "nibbles-game.c"
		}
#line 891 "../src/nibbles-game.vala"
		_tmp21_ = delta;
#line 891 "../src/nibbles-game.vala"
		_tmp22_ = score_delta;
#line 891 "../src/nibbles-game.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp21_, _tmp22_);
#line 881 "../src/nibbles-game.vala"
		_g_object_unref0 (delta);
#line 881 "../src/nibbles-game.vala"
		_g_object_unref0 (score_delta);
#line 5144 "nibbles-game.c"
	}
#line 878 "../src/nibbles-game.vala"
	_g_object_unref0 (bonus);
#line 5148 "nibbles-game.c"
}

static NibblesGameeStatus*
_nibbles_game_estatus_dup (NibblesGameeStatus* self)
{
	NibblesGameeStatus* dup;
#line 906 "../src/nibbles-game.vala"
	dup = g_new0 (NibblesGameeStatus, 1);
#line 906 "../src/nibbles-game.vala"
	memcpy (dup, self, sizeof (NibblesGameeStatus));
#line 906 "../src/nibbles-game.vala"
	return dup;
#line 5161 "nibbles-game.c"
}

static gpointer
__nibbles_game_estatus_dup0 (gpointer self)
{
#line 906 "../src/nibbles-game.vala"
	return self ? _nibbles_game_estatus_dup (self) : NULL;
#line 5169 "nibbles-game.c"
}

NibblesGameeStatus*
nibbles_game_get_game_status (NibblesGame* self)
{
	gint worms_left = 0;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	NibblesGameeStatus* result;
#line 898 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 900 "../src/nibbles-game.vala"
	worms_left = 0;
#line 5183 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 901 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 901 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 901 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 901 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 901 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 901 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 901 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 901 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5208 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			Worm* _tmp8_;
			guint8 _tmp9_;
			guint8 _tmp10_;
#line 901 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 901 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 901 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 901 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 901 "../src/nibbles-game.vala"
				break;
#line 5227 "nibbles-game.c"
			}
#line 901 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 901 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 901 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 903 "../src/nibbles-game.vala"
			_tmp8_ = worm;
#line 903 "../src/nibbles-game.vala"
			_tmp9_ = worm_get_lives (_tmp8_);
#line 903 "../src/nibbles-game.vala"
			_tmp10_ = _tmp9_;
#line 903 "../src/nibbles-game.vala"
			if (((gint) _tmp10_) > 0) {
#line 904 "../src/nibbles-game.vala"
				worms_left += 1;
#line 5245 "nibbles-game.c"
			} else {
				gboolean _tmp11_ = FALSE;
				gint _tmp12_;
#line 905 "../src/nibbles-game.vala"
				_tmp12_ = self->priv->_numhumans;
#line 905 "../src/nibbles-game.vala"
				if (_tmp12_ == 0) {
#line 5253 "nibbles-game.c"
					Worm* _tmp13_;
					guint8 _tmp14_;
					guint8 _tmp15_;
#line 905 "../src/nibbles-game.vala"
					_tmp13_ = worm;
#line 905 "../src/nibbles-game.vala"
					_tmp14_ = worm_get_lives (_tmp13_);
#line 905 "../src/nibbles-game.vala"
					_tmp15_ = _tmp14_;
#line 905 "../src/nibbles-game.vala"
					_tmp11_ = ((gint) _tmp15_) == 0;
#line 5265 "nibbles-game.c"
				} else {
#line 905 "../src/nibbles-game.vala"
					_tmp11_ = FALSE;
#line 5269 "nibbles-game.c"
				}
#line 905 "../src/nibbles-game.vala"
				if (_tmp11_) {
#line 5273 "nibbles-game.c"
					NibblesGameeStatus _tmp16_;
					NibblesGameeStatus* _tmp17_;
#line 906 "../src/nibbles-game.vala"
					_tmp16_ = NIBBLES_GAME_ESTATUS_GAMEOVER;
#line 906 "../src/nibbles-game.vala"
					_tmp17_ = __nibbles_game_estatus_dup0 (&_tmp16_);
#line 906 "../src/nibbles-game.vala"
					result = _tmp17_;
#line 906 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 906 "../src/nibbles-game.vala"
					return result;
#line 5286 "nibbles-game.c"
				}
			}
#line 901 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5291 "nibbles-game.c"
		}
	}
#line 909 "../src/nibbles-game.vala"
	if (worms_left == 1) {
#line 5296 "nibbles-game.c"
		gint _tmp20_;
#line 909 "../src/nibbles-game.vala"
		_tmp20_ = self->priv->_numworms;
#line 909 "../src/nibbles-game.vala"
		_tmp19_ = _tmp20_ > 1;
#line 5302 "nibbles-game.c"
	} else {
#line 909 "../src/nibbles-game.vala"
		_tmp19_ = FALSE;
#line 5306 "nibbles-game.c"
	}
#line 909 "../src/nibbles-game.vala"
	if (_tmp19_) {
#line 909 "../src/nibbles-game.vala"
		_tmp18_ = TRUE;
#line 5312 "nibbles-game.c"
	} else {
		gboolean _tmp21_ = FALSE;
#line 909 "../src/nibbles-game.vala"
		if (nibbles_game_humans_left (self) == ((guint) 1)) {
#line 5317 "nibbles-game.c"
			gint _tmp22_;
#line 909 "../src/nibbles-game.vala"
			_tmp22_ = self->priv->_numhumans;
#line 909 "../src/nibbles-game.vala"
			_tmp21_ = _tmp22_ > 1;
#line 5323 "nibbles-game.c"
		} else {
#line 909 "../src/nibbles-game.vala"
			_tmp21_ = FALSE;
#line 5327 "nibbles-game.c"
		}
#line 909 "../src/nibbles-game.vala"
		_tmp18_ = _tmp21_;
#line 5331 "nibbles-game.c"
	}
#line 909 "../src/nibbles-game.vala"
	if (_tmp18_) {
#line 5335 "nibbles-game.c"
		NibblesGameeStatus _tmp23_;
		NibblesGameeStatus* _tmp24_;
#line 912 "../src/nibbles-game.vala"
		_tmp23_ = NIBBLES_GAME_ESTATUS_VICTORY;
#line 912 "../src/nibbles-game.vala"
		_tmp24_ = __nibbles_game_estatus_dup0 (&_tmp23_);
#line 912 "../src/nibbles-game.vala"
		result = _tmp24_;
#line 912 "../src/nibbles-game.vala"
		return result;
#line 5346 "nibbles-game.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 914 "../src/nibbles-game.vala"
		if (worms_left == 0) {
#line 914 "../src/nibbles-game.vala"
			_tmp25_ = TRUE;
#line 5353 "nibbles-game.c"
		} else {
			gboolean _tmp26_ = FALSE;
#line 914 "../src/nibbles-game.vala"
			if (nibbles_game_humans_left (self) == ((guint) 0)) {
#line 5358 "nibbles-game.c"
				gint _tmp27_;
#line 914 "../src/nibbles-game.vala"
				_tmp27_ = self->priv->_numhumans;
#line 914 "../src/nibbles-game.vala"
				_tmp26_ = _tmp27_ >= 1;
#line 5364 "nibbles-game.c"
			} else {
#line 914 "../src/nibbles-game.vala"
				_tmp26_ = FALSE;
#line 5368 "nibbles-game.c"
			}
#line 914 "../src/nibbles-game.vala"
			_tmp25_ = _tmp26_;
#line 5372 "nibbles-game.c"
		}
#line 914 "../src/nibbles-game.vala"
		if (_tmp25_) {
#line 5376 "nibbles-game.c"
			NibblesGameeStatus _tmp28_;
			NibblesGameeStatus* _tmp29_;
#line 917 "../src/nibbles-game.vala"
			_tmp28_ = NIBBLES_GAME_ESTATUS_GAMEOVER;
#line 917 "../src/nibbles-game.vala"
			_tmp29_ = __nibbles_game_estatus_dup0 (&_tmp28_);
#line 917 "../src/nibbles-game.vala"
			result = _tmp29_;
#line 917 "../src/nibbles-game.vala"
			return result;
#line 5387 "nibbles-game.c"
		} else {
			NibblesGameBonuses* _tmp30_;
#line 919 "../src/nibbles-game.vala"
			_tmp30_ = self->priv->bonuses;
#line 919 "../src/nibbles-game.vala"
			if (nibbles_game_bonuses_last_regular_bonus (_tmp30_)) {
#line 5394 "nibbles-game.c"
				NibblesGameeStatus _tmp31_;
				NibblesGameeStatus* _tmp32_;
#line 920 "../src/nibbles-game.vala"
				_tmp31_ = NIBBLES_GAME_ESTATUS_NEWROUND;
#line 920 "../src/nibbles-game.vala"
				_tmp32_ = __nibbles_game_estatus_dup0 (&_tmp31_);
#line 920 "../src/nibbles-game.vala"
				result = _tmp32_;
#line 920 "../src/nibbles-game.vala"
				return result;
#line 5405 "nibbles-game.c"
			} else {
#line 922 "../src/nibbles-game.vala"
				result = NULL;
#line 922 "../src/nibbles-game.vala"
				return result;
#line 5411 "nibbles-game.c"
			}
		}
	}
}

guint
nibbles_game_humans_left (NibblesGame* self)
{
	guint count = 0U;
	guint result;
#line 925 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 927 "../src/nibbles-game.vala"
	count = (guint) 0;
#line 5426 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 928 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 928 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 928 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 928 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 928 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 928 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 928 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 928 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5451 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			Worm* _tmp9_;
#line 928 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 928 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 928 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 928 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 928 "../src/nibbles-game.vala"
				break;
#line 5469 "nibbles-game.c"
			}
#line 928 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 928 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 928 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 929 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 929 "../src/nibbles-game.vala"
			if (_tmp9_->is_human) {
#line 5481 "nibbles-game.c"
				Worm* _tmp10_;
				guint8 _tmp11_;
				guint8 _tmp12_;
#line 929 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 929 "../src/nibbles-game.vala"
				_tmp11_ = worm_get_lives (_tmp10_);
#line 929 "../src/nibbles-game.vala"
				_tmp12_ = _tmp11_;
#line 929 "../src/nibbles-game.vala"
				_tmp8_ = ((gint) _tmp12_) > 0;
#line 5493 "nibbles-game.c"
			} else {
#line 929 "../src/nibbles-game.vala"
				_tmp8_ = FALSE;
#line 5497 "nibbles-game.c"
			}
#line 929 "../src/nibbles-game.vala"
			if (_tmp8_) {
#line 5501 "nibbles-game.c"
				guint _tmp13_;
#line 930 "../src/nibbles-game.vala"
				count = count + 1;
#line 930 "../src/nibbles-game.vala"
				_tmp13_ = count;
#line 5507 "nibbles-game.c"
			}
#line 928 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5511 "nibbles-game.c"
		}
	}
#line 931 "../src/nibbles-game.vala"
	result = count;
#line 931 "../src/nibbles-game.vala"
	return result;
#line 5518 "nibbles-game.c"
}

Worm*
nibbles_game_get_winner (NibblesGame* self)
{
	gboolean one_human_left = FALSE;
	Worm* result;
#line 934 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 936 "../src/nibbles-game.vala"
	one_human_left = nibbles_game_humans_left (self) == ((guint) 1);
#line 5530 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _worm_index = 0;
#line 937 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->_worms;
#line 937 "../src/nibbles-game.vala"
		_worm_list = _tmp0_;
#line 937 "../src/nibbles-game.vala"
		_tmp1_ = _worm_list;
#line 937 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 937 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 937 "../src/nibbles-game.vala"
		_worm_size = _tmp3_;
#line 937 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 937 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5555 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
#line 937 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 937 "../src/nibbles-game.vala"
			_tmp4_ = _worm_index;
#line 937 "../src/nibbles-game.vala"
			_tmp5_ = _worm_size;
#line 937 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 937 "../src/nibbles-game.vala"
				break;
#line 5574 "nibbles-game.c"
			}
#line 937 "../src/nibbles-game.vala"
			_tmp6_ = _worm_list;
#line 937 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _worm_index);
#line 937 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp7_;
#line 938 "../src/nibbles-game.vala"
			if (one_human_left) {
#line 5584 "nibbles-game.c"
				Worm* _tmp11_;
#line 938 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 938 "../src/nibbles-game.vala"
				_tmp10_ = _tmp11_->is_human;
#line 5590 "nibbles-game.c"
			} else {
#line 938 "../src/nibbles-game.vala"
				_tmp10_ = FALSE;
#line 5594 "nibbles-game.c"
			}
#line 938 "../src/nibbles-game.vala"
			if (_tmp10_) {
#line 938 "../src/nibbles-game.vala"
				_tmp9_ = TRUE;
#line 5600 "nibbles-game.c"
			} else {
				gboolean _tmp12_ = FALSE;
#line 939 "../src/nibbles-game.vala"
				if (!one_human_left) {
#line 5605 "nibbles-game.c"
					Worm* _tmp13_;
#line 939 "../src/nibbles-game.vala"
					_tmp13_ = worm;
#line 939 "../src/nibbles-game.vala"
					_tmp12_ = !_tmp13_->is_human;
#line 5611 "nibbles-game.c"
				} else {
#line 939 "../src/nibbles-game.vala"
					_tmp12_ = FALSE;
#line 5615 "nibbles-game.c"
				}
#line 939 "../src/nibbles-game.vala"
				_tmp9_ = _tmp12_;
#line 5619 "nibbles-game.c"
			}
#line 938 "../src/nibbles-game.vala"
			if (_tmp9_) {
#line 5623 "nibbles-game.c"
				Worm* _tmp14_;
				guint8 _tmp15_;
				guint8 _tmp16_;
#line 939 "../src/nibbles-game.vala"
				_tmp14_ = worm;
#line 939 "../src/nibbles-game.vala"
				_tmp15_ = worm_get_lives (_tmp14_);
#line 939 "../src/nibbles-game.vala"
				_tmp16_ = _tmp15_;
#line 939 "../src/nibbles-game.vala"
				_tmp8_ = ((gint) _tmp16_) > 0;
#line 5635 "nibbles-game.c"
			} else {
#line 938 "../src/nibbles-game.vala"
				_tmp8_ = FALSE;
#line 5639 "nibbles-game.c"
			}
#line 938 "../src/nibbles-game.vala"
			if (_tmp8_) {
#line 940 "../src/nibbles-game.vala"
				result = worm;
#line 940 "../src/nibbles-game.vala"
				return result;
#line 5647 "nibbles-game.c"
			}
#line 937 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 5651 "nibbles-game.c"
		}
	}
#line 941 "../src/nibbles-game.vala"
	result = NULL;
#line 941 "../src/nibbles-game.vala"
	return result;
#line 5658 "nibbles-game.c"
}

static gboolean
__lambda7_ (NibblesGame* self,
            GValue* value,
            GVariant* variant,
            void* data)
{
	const gchar* _tmp0_;
	gboolean result;
#line 953 "../src/nibbles-game.vala"
	g_return_val_if_fail (value != NULL, FALSE);
#line 953 "../src/nibbles-game.vala"
	g_return_val_if_fail (variant != NULL, FALSE);
#line 955 "../src/nibbles-game.vala"
	_tmp0_ = g_variant_get_string (variant, NULL);
#line 955 "../src/nibbles-game.vala"
	g_value_set_int (value, nibbles_game_get_color_num (_tmp0_));
#line 956 "../src/nibbles-game.vala"
	result = TRUE;
#line 956 "../src/nibbles-game.vala"
	return result;
#line 5681 "nibbles-game.c"
}

static gboolean
___lambda7___localfunc0_ (GValue* value,
                          GVariant* variant,
                          void* data,
                          gpointer self)
{
	gboolean result;
	result = __lambda7_ ((NibblesGame*) self, value, variant, data);
#line 953 "../src/nibbles-game.vala"
	return result;
#line 5694 "nibbles-game.c"
}

static GVariant*
__lambda8_ (NibblesGame* self,
            GValue* value,
            const GVariantType* type,
            void* data)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* result;
#line 961 "../src/nibbles-game.vala"
	g_return_val_if_fail (value != NULL, NULL);
#line 961 "../src/nibbles-game.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 963 "../src/nibbles-game.vala"
	_tmp0_ = nibbles_game_get_color_string (g_value_get_int (value));
#line 963 "../src/nibbles-game.vala"
	_tmp1_ = _tmp0_;
#line 963 "../src/nibbles-game.vala"
	_tmp2_ = g_variant_new_string (_tmp1_);
#line 963 "../src/nibbles-game.vala"
	g_variant_ref_sink (_tmp2_);
#line 963 "../src/nibbles-game.vala"
	_tmp3_ = _tmp2_;
#line 963 "../src/nibbles-game.vala"
	_g_free0 (_tmp1_);
#line 963 "../src/nibbles-game.vala"
	result = _tmp3_;
#line 963 "../src/nibbles-game.vala"
	return result;
#line 5728 "nibbles-game.c"
}

static GVariant*
___lambda8___localfunc1_ (GValue* value,
                          const GVariantType* type,
                          void* data,
                          gpointer self)
{
	GVariant* result;
	result = __lambda8_ ((NibblesGame*) self, value, type, data);
#line 961 "../src/nibbles-game.vala"
	return result;
#line 5741 "nibbles-game.c"
}

void
nibbles_game_load_worm_properties (NibblesGame* self,
                                   GeeArrayList* worm_settings)
{
	_LocalFunc0_ GetMappingFunction = NULL;
	gpointer GetMappingFunction_target;
	_LocalFunc1_ SetMappingFunction = NULL;
	gpointer SetMappingFunction_target;
	GeeHashMap* _tmp0_;
#line 948 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 948 "../src/nibbles-game.vala"
	g_return_if_fail (worm_settings != NULL);
#line 953 "../src/nibbles-game.vala"
	GetMappingFunction = ___lambda7___localfunc0_;
#line 953 "../src/nibbles-game.vala"
	GetMappingFunction_target = self;
#line 961 "../src/nibbles-game.vala"
	SetMappingFunction = ___lambda8___localfunc1_;
#line 961 "../src/nibbles-game.vala"
	SetMappingFunction_target = self;
#line 965 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 965 "../src/nibbles-game.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 5769 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 966 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 966 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 966 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 966 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 966 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 966 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 966 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 966 "../src/nibbles-game.vala"
		while (TRUE) {
#line 5794 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			WormProperties* properties = NULL;
			WormProperties* _tmp9_;
			Worm* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gpointer _tmp13_;
			GSettings* _tmp14_;
			WormProperties* _tmp15_;
			_LocalFunc0_ _tmp16_;
			gpointer _tmp16__target;
			_LocalFunc1_ _tmp17_;
			gpointer _tmp17__target;
			Worm* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
			gpointer _tmp21_;
			GSettings* _tmp22_;
			WormProperties* _tmp23_;
			Worm* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gpointer _tmp27_;
			GSettings* _tmp28_;
			WormProperties* _tmp29_;
			Worm* _tmp30_;
			gint _tmp31_;
			gint _tmp32_;
			gpointer _tmp33_;
			GSettings* _tmp34_;
			WormProperties* _tmp35_;
			Worm* _tmp36_;
			gint _tmp37_;
			gint _tmp38_;
			gpointer _tmp39_;
			GSettings* _tmp40_;
			WormProperties* _tmp41_;
			Worm* _tmp42_;
			gint _tmp43_;
			gint _tmp44_;
			gpointer _tmp45_;
			GSettings* _tmp46_;
			WormProperties* _tmp47_;
			Worm* _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			gpointer _tmp51_;
			GSettings* _tmp52_;
			WormProperties* _tmp53_;
			Worm* _tmp54_;
			gint _tmp55_;
			gint _tmp56_;
			gpointer _tmp57_;
			GSettings* _tmp58_;
			WormProperties* _tmp59_;
			Worm* _tmp60_;
			gint _tmp61_;
			gint _tmp62_;
			gpointer _tmp63_;
			GSettings* _tmp64_;
			WormProperties* _tmp65_;
			GeeHashMap* _tmp66_;
			Worm* _tmp67_;
			WormProperties* _tmp68_;
#line 966 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 966 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 966 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 966 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 966 "../src/nibbles-game.vala"
				break;
#line 5873 "nibbles-game.c"
			}
#line 966 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 966 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 966 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 968 "../src/nibbles-game.vala"
			_tmp9_ = worm_properties_new ();
#line 968 "../src/nibbles-game.vala"
			properties = _tmp9_;
#line 969 "../src/nibbles-game.vala"
			_tmp10_ = worm;
#line 969 "../src/nibbles-game.vala"
			_tmp11_ = worm_get_id (_tmp10_);
#line 969 "../src/nibbles-game.vala"
			_tmp12_ = _tmp11_;
#line 969 "../src/nibbles-game.vala"
			_tmp13_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp12_);
#line 969 "../src/nibbles-game.vala"
			_tmp14_ = (GSettings*) _tmp13_;
#line 969 "../src/nibbles-game.vala"
			_tmp15_ = properties;
#line 969 "../src/nibbles-game.vala"
			_tmp16_ = GetMappingFunction;
#line 969 "../src/nibbles-game.vala"
			_tmp16__target = GetMappingFunction_target;
#line 969 "../src/nibbles-game.vala"
			_tmp17_ = SetMappingFunction;
#line 969 "../src/nibbles-game.vala"
			_tmp17__target = SetMappingFunction_target;
#line 969 "../src/nibbles-game.vala"
			g_settings_bind_with_mapping (_tmp14_, "color", (GObject*) _tmp15_, "color", G_SETTINGS_BIND_DEFAULT, (GSettingsBindGetMapping) _tmp16_, (GSettingsBindSetMapping) _tmp17_, NULL, NULL);
#line 969 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp14_);
#line 976 "../src/nibbles-game.vala"
			_tmp18_ = worm;
#line 976 "../src/nibbles-game.vala"
			_tmp19_ = worm_get_id (_tmp18_);
#line 976 "../src/nibbles-game.vala"
			_tmp20_ = _tmp19_;
#line 976 "../src/nibbles-game.vala"
			_tmp21_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp20_);
#line 976 "../src/nibbles-game.vala"
			_tmp22_ = (GSettings*) _tmp21_;
#line 976 "../src/nibbles-game.vala"
			_tmp23_ = properties;
#line 976 "../src/nibbles-game.vala"
			g_settings_bind (_tmp22_, "key-up", (GObject*) _tmp23_, "up", G_SETTINGS_BIND_DEFAULT);
#line 976 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp22_);
#line 977 "../src/nibbles-game.vala"
			_tmp24_ = worm;
#line 977 "../src/nibbles-game.vala"
			_tmp25_ = worm_get_id (_tmp24_);
#line 977 "../src/nibbles-game.vala"
			_tmp26_ = _tmp25_;
#line 977 "../src/nibbles-game.vala"
			_tmp27_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp26_);
#line 977 "../src/nibbles-game.vala"
			_tmp28_ = (GSettings*) _tmp27_;
#line 977 "../src/nibbles-game.vala"
			_tmp29_ = properties;
#line 977 "../src/nibbles-game.vala"
			g_settings_bind (_tmp28_, "key-down", (GObject*) _tmp29_, "down", G_SETTINGS_BIND_DEFAULT);
#line 977 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp28_);
#line 978 "../src/nibbles-game.vala"
			_tmp30_ = worm;
#line 978 "../src/nibbles-game.vala"
			_tmp31_ = worm_get_id (_tmp30_);
#line 978 "../src/nibbles-game.vala"
			_tmp32_ = _tmp31_;
#line 978 "../src/nibbles-game.vala"
			_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp32_);
#line 978 "../src/nibbles-game.vala"
			_tmp34_ = (GSettings*) _tmp33_;
#line 978 "../src/nibbles-game.vala"
			_tmp35_ = properties;
#line 978 "../src/nibbles-game.vala"
			g_settings_bind (_tmp34_, "key-left", (GObject*) _tmp35_, "left", G_SETTINGS_BIND_DEFAULT);
#line 978 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp34_);
#line 979 "../src/nibbles-game.vala"
			_tmp36_ = worm;
#line 979 "../src/nibbles-game.vala"
			_tmp37_ = worm_get_id (_tmp36_);
#line 979 "../src/nibbles-game.vala"
			_tmp38_ = _tmp37_;
#line 979 "../src/nibbles-game.vala"
			_tmp39_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp38_);
#line 979 "../src/nibbles-game.vala"
			_tmp40_ = (GSettings*) _tmp39_;
#line 979 "../src/nibbles-game.vala"
			_tmp41_ = properties;
#line 979 "../src/nibbles-game.vala"
			g_settings_bind (_tmp40_, "key-right", (GObject*) _tmp41_, "right", G_SETTINGS_BIND_DEFAULT);
#line 979 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp40_);
#line 980 "../src/nibbles-game.vala"
			_tmp42_ = worm;
#line 980 "../src/nibbles-game.vala"
			_tmp43_ = worm_get_id (_tmp42_);
#line 980 "../src/nibbles-game.vala"
			_tmp44_ = _tmp43_;
#line 980 "../src/nibbles-game.vala"
			_tmp45_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp44_);
#line 980 "../src/nibbles-game.vala"
			_tmp46_ = (GSettings*) _tmp45_;
#line 980 "../src/nibbles-game.vala"
			_tmp47_ = properties;
#line 980 "../src/nibbles-game.vala"
			g_settings_bind (_tmp46_, "key-up-raw", (GObject*) _tmp47_, "raw-up", G_SETTINGS_BIND_DEFAULT);
#line 980 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp46_);
#line 981 "../src/nibbles-game.vala"
			_tmp48_ = worm;
#line 981 "../src/nibbles-game.vala"
			_tmp49_ = worm_get_id (_tmp48_);
#line 981 "../src/nibbles-game.vala"
			_tmp50_ = _tmp49_;
#line 981 "../src/nibbles-game.vala"
			_tmp51_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp50_);
#line 981 "../src/nibbles-game.vala"
			_tmp52_ = (GSettings*) _tmp51_;
#line 981 "../src/nibbles-game.vala"
			_tmp53_ = properties;
#line 981 "../src/nibbles-game.vala"
			g_settings_bind (_tmp52_, "key-down-raw", (GObject*) _tmp53_, "raw-down", G_SETTINGS_BIND_DEFAULT);
#line 981 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp52_);
#line 982 "../src/nibbles-game.vala"
			_tmp54_ = worm;
#line 982 "../src/nibbles-game.vala"
			_tmp55_ = worm_get_id (_tmp54_);
#line 982 "../src/nibbles-game.vala"
			_tmp56_ = _tmp55_;
#line 982 "../src/nibbles-game.vala"
			_tmp57_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp56_);
#line 982 "../src/nibbles-game.vala"
			_tmp58_ = (GSettings*) _tmp57_;
#line 982 "../src/nibbles-game.vala"
			_tmp59_ = properties;
#line 982 "../src/nibbles-game.vala"
			g_settings_bind (_tmp58_, "key-left-raw", (GObject*) _tmp59_, "raw-left", G_SETTINGS_BIND_DEFAULT);
#line 982 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp58_);
#line 983 "../src/nibbles-game.vala"
			_tmp60_ = worm;
#line 983 "../src/nibbles-game.vala"
			_tmp61_ = worm_get_id (_tmp60_);
#line 983 "../src/nibbles-game.vala"
			_tmp62_ = _tmp61_;
#line 983 "../src/nibbles-game.vala"
			_tmp63_ = gee_abstract_list_get ((GeeAbstractList*) worm_settings, _tmp62_);
#line 983 "../src/nibbles-game.vala"
			_tmp64_ = (GSettings*) _tmp63_;
#line 983 "../src/nibbles-game.vala"
			_tmp65_ = properties;
#line 983 "../src/nibbles-game.vala"
			g_settings_bind (_tmp64_, "key-right-raw", (GObject*) _tmp65_, "raw-right", G_SETTINGS_BIND_DEFAULT);
#line 983 "../src/nibbles-game.vala"
			_g_object_unref0 (_tmp64_);
#line 984 "../src/nibbles-game.vala"
			_tmp66_ = self->priv->_worm_props;
#line 984 "../src/nibbles-game.vala"
			_tmp67_ = worm;
#line 984 "../src/nibbles-game.vala"
			_tmp68_ = properties;
#line 984 "../src/nibbles-game.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp66_, _tmp67_, _tmp68_);
#line 966 "../src/nibbles-game.vala"
			_g_object_unref0 (properties);
#line 966 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 6049 "nibbles-game.c"
		}
	}
}

static inline gchar*
nibbles_game_get_color_string (gint color)
{
	gchar* result;
#line 989 "../src/nibbles-game.vala"
	switch (color) {
#line 989 "../src/nibbles-game.vala"
		case 0:
#line 6062 "nibbles-game.c"
		{
			gchar* _tmp0_;
#line 991 "../src/nibbles-game.vala"
			_tmp0_ = g_strdup ("red");
#line 991 "../src/nibbles-game.vala"
			result = _tmp0_;
#line 991 "../src/nibbles-game.vala"
			return result;
#line 6071 "nibbles-game.c"
		}
#line 989 "../src/nibbles-game.vala"
		case 1:
#line 6075 "nibbles-game.c"
		{
			gchar* _tmp1_;
#line 992 "../src/nibbles-game.vala"
			_tmp1_ = g_strdup ("green");
#line 992 "../src/nibbles-game.vala"
			result = _tmp1_;
#line 992 "../src/nibbles-game.vala"
			return result;
#line 6084 "nibbles-game.c"
		}
#line 989 "../src/nibbles-game.vala"
		case 2:
#line 6088 "nibbles-game.c"
		{
			gchar* _tmp2_;
#line 993 "../src/nibbles-game.vala"
			_tmp2_ = g_strdup ("blue");
#line 993 "../src/nibbles-game.vala"
			result = _tmp2_;
#line 993 "../src/nibbles-game.vala"
			return result;
#line 6097 "nibbles-game.c"
		}
#line 989 "../src/nibbles-game.vala"
		case 3:
#line 6101 "nibbles-game.c"
		{
			gchar* _tmp3_;
#line 994 "../src/nibbles-game.vala"
			_tmp3_ = g_strdup ("yellow");
#line 994 "../src/nibbles-game.vala"
			result = _tmp3_;
#line 994 "../src/nibbles-game.vala"
			return result;
#line 6110 "nibbles-game.c"
		}
#line 989 "../src/nibbles-game.vala"
		case 4:
#line 6114 "nibbles-game.c"
		{
			gchar* _tmp4_;
#line 995 "../src/nibbles-game.vala"
			_tmp4_ = g_strdup ("cyan");
#line 995 "../src/nibbles-game.vala"
			result = _tmp4_;
#line 995 "../src/nibbles-game.vala"
			return result;
#line 6123 "nibbles-game.c"
		}
#line 989 "../src/nibbles-game.vala"
		case 5:
#line 6127 "nibbles-game.c"
		{
			gchar* _tmp5_;
#line 996 "../src/nibbles-game.vala"
			_tmp5_ = g_strdup ("purple");
#line 996 "../src/nibbles-game.vala"
			result = _tmp5_;
#line 996 "../src/nibbles-game.vala"
			return result;
#line 6136 "nibbles-game.c"
		}
		default:
		{
#line 997 "../src/nibbles-game.vala"
			g_assert_not_reached ();
#line 6142 "nibbles-game.c"
		}
	}
}

static inline gint
nibbles_game_get_color_num (const gchar* color)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 1002 "../src/nibbles-game.vala"
	static GQuark _tmp1_label0 = 0;
#line 1002 "../src/nibbles-game.vala"
	static GQuark _tmp1_label1 = 0;
#line 1002 "../src/nibbles-game.vala"
	static GQuark _tmp1_label2 = 0;
#line 1002 "../src/nibbles-game.vala"
	static GQuark _tmp1_label3 = 0;
#line 1002 "../src/nibbles-game.vala"
	static GQuark _tmp1_label4 = 0;
#line 1002 "../src/nibbles-game.vala"
	static GQuark _tmp1_label5 = 0;
#line 6164 "nibbles-game.c"
	gint result;
#line 1000 "../src/nibbles-game.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 1002 "../src/nibbles-game.vala"
	_tmp0_ = color;
#line 1002 "../src/nibbles-game.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 1002 "../src/nibbles-game.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("red")))) {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6176 "nibbles-game.c"
			default:
			{
#line 1004 "../src/nibbles-game.vala"
				result = 0;
#line 1004 "../src/nibbles-game.vala"
				return result;
#line 6183 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("green")))) {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6189 "nibbles-game.c"
			default:
			{
#line 1005 "../src/nibbles-game.vala"
				result = 1;
#line 1005 "../src/nibbles-game.vala"
				return result;
#line 6196 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("blue")))) {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6202 "nibbles-game.c"
			default:
			{
#line 1006 "../src/nibbles-game.vala"
				result = 2;
#line 1006 "../src/nibbles-game.vala"
				return result;
#line 6209 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("yellow")))) {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6215 "nibbles-game.c"
			default:
			{
#line 1007 "../src/nibbles-game.vala"
				result = 3;
#line 1007 "../src/nibbles-game.vala"
				return result;
#line 6222 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("cyan")))) {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6228 "nibbles-game.c"
			default:
			{
#line 1008 "../src/nibbles-game.vala"
				result = 4;
#line 1008 "../src/nibbles-game.vala"
				return result;
#line 6235 "nibbles-game.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("purple")))) {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6241 "nibbles-game.c"
			default:
			{
#line 1009 "../src/nibbles-game.vala"
				result = 5;
#line 1009 "../src/nibbles-game.vala"
				return result;
#line 6248 "nibbles-game.c"
			}
		}
	} else {
#line 1002 "../src/nibbles-game.vala"
		switch (0) {
#line 6254 "nibbles-game.c"
			default:
			{
#line 1010 "../src/nibbles-game.vala"
				g_assert_not_reached ();
#line 6259 "nibbles-game.c"
			}
		}
	}
}

gboolean
nibbles_game_keypress (NibblesGame* self,
                       guint keyval,
                       guint keycode,
                       gboolean* remove_handler)
{
	gboolean _vala_remove_handler = FALSE;
	gboolean result;
#line 1014 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1016 "../src/nibbles-game.vala"
	_vala_remove_handler = FALSE;
#line 1017 "../src/nibbles-game.vala"
	result = nibbles_game_handle_keypress (self, keyval, keycode);
#line 1017 "../src/nibbles-game.vala"
	if (remove_handler) {
#line 1017 "../src/nibbles-game.vala"
		*remove_handler = _vala_remove_handler;
#line 6283 "nibbles-game.c"
	}
#line 1017 "../src/nibbles-game.vala"
	return result;
#line 6287 "nibbles-game.c"
}

gboolean
nibbles_game_handle_keypress (NibblesGame* self,
                              guint keyval,
                              guint keycode)
{
	gboolean _tmp0_;
	gboolean result;
#line 1020 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1022 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_running;
#line 1022 "../src/nibbles-game.vala"
	if (!_tmp0_) {
#line 1023 "../src/nibbles-game.vala"
		result = FALSE;
#line 1023 "../src/nibbles-game.vala"
		return result;
#line 6307 "nibbles-game.c"
	}
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 1025 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 1025 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 1025 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 1025 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1025 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 1025 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 1025 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 1025 "../src/nibbles-game.vala"
		while (TRUE) {
#line 6333 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 1025 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 1025 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 1025 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 1025 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1025 "../src/nibbles-game.vala"
				break;
#line 6350 "nibbles-game.c"
			}
#line 1025 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 1025 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 1025 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 1027 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 1027 "../src/nibbles-game.vala"
			if (_tmp9_->is_human) {
#line 6362 "nibbles-game.c"
				Worm* _tmp10_;
				GeeHashMap* _tmp11_;
#line 1028 "../src/nibbles-game.vala"
				_tmp10_ = worm;
#line 1028 "../src/nibbles-game.vala"
				_tmp11_ = self->priv->_worm_props;
#line 1028 "../src/nibbles-game.vala"
				if (worm_handle_keypress (_tmp10_, keycode, _tmp11_)) {
#line 1029 "../src/nibbles-game.vala"
					result = TRUE;
#line 1029 "../src/nibbles-game.vala"
					_g_object_unref0 (worm);
#line 1029 "../src/nibbles-game.vala"
					return result;
#line 6377 "nibbles-game.c"
				}
			}
#line 1025 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 6382 "nibbles-game.c"
		}
	}
#line 1032 "../src/nibbles-game.vala"
	result = FALSE;
#line 1032 "../src/nibbles-game.vala"
	return result;
#line 6389 "nibbles-game.c"
}

static GeeList*
nibbles_game_get_other_worms (NibblesGame* self,
                              Worm* _self_)
{
	GeeArrayList* _result_ = NULL;
	GeeArrayList* _tmp0_;
	GeeList* result;
#line 1039 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1039 "../src/nibbles-game.vala"
	g_return_val_if_fail (_self_ != NULL, NULL);
#line 1041 "../src/nibbles-game.vala"
	_tmp0_ = gee_array_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1041 "../src/nibbles-game.vala"
	_result_ = _tmp0_;
#line 6407 "nibbles-game.c"
	{
		GeeLinkedList* _worm_list = NULL;
		GeeLinkedList* _tmp1_;
		gint _worm_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _worm_index = 0;
#line 1042 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->_worms;
#line 1042 "../src/nibbles-game.vala"
		_worm_list = _tmp1_;
#line 1042 "../src/nibbles-game.vala"
		_tmp2_ = _worm_list;
#line 1042 "../src/nibbles-game.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 1042 "../src/nibbles-game.vala"
		_tmp4_ = _tmp3_;
#line 1042 "../src/nibbles-game.vala"
		_worm_size = _tmp4_;
#line 1042 "../src/nibbles-game.vala"
		_worm_index = -1;
#line 1042 "../src/nibbles-game.vala"
		while (TRUE) {
#line 6432 "nibbles-game.c"
			gint _tmp5_;
			gint _tmp6_;
			Worm* worm = NULL;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			Worm* _tmp9_;
#line 1042 "../src/nibbles-game.vala"
			_worm_index = _worm_index + 1;
#line 1042 "../src/nibbles-game.vala"
			_tmp5_ = _worm_index;
#line 1042 "../src/nibbles-game.vala"
			_tmp6_ = _worm_size;
#line 1042 "../src/nibbles-game.vala"
			if (!(_tmp5_ < _tmp6_)) {
#line 1042 "../src/nibbles-game.vala"
				break;
#line 6449 "nibbles-game.c"
			}
#line 1042 "../src/nibbles-game.vala"
			_tmp7_ = _worm_list;
#line 1042 "../src/nibbles-game.vala"
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _worm_index);
#line 1042 "../src/nibbles-game.vala"
			worm = (Worm*) _tmp8_;
#line 1044 "../src/nibbles-game.vala"
			_tmp9_ = worm;
#line 1044 "../src/nibbles-game.vala"
			if (_tmp9_ != _self_) {
#line 6461 "nibbles-game.c"
				GeeArrayList* _tmp10_;
				Worm* _tmp11_;
#line 1045 "../src/nibbles-game.vala"
				_tmp10_ = _result_;
#line 1045 "../src/nibbles-game.vala"
				_tmp11_ = worm;
#line 1045 "../src/nibbles-game.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 6470 "nibbles-game.c"
			}
#line 1042 "../src/nibbles-game.vala"
			_g_object_unref0 (worm);
#line 6474 "nibbles-game.c"
		}
	}
#line 1047 "../src/nibbles-game.vala"
	result = (GeeList*) _result_;
#line 1047 "../src/nibbles-game.vala"
	return result;
#line 6481 "nibbles-game.c"
}

GeeList*
nibbles_game_get_bonuses (NibblesGame* self)
{
	NibblesGameBonuses* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 1050 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1052 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->bonuses;
#line 1052 "../src/nibbles-game.vala"
	_tmp1_ = nibbles_game_bonuses_get_bonuses (_tmp0_);
#line 1052 "../src/nibbles-game.vala"
	result = _tmp1_;
#line 1052 "../src/nibbles-game.vala"
	return result;
#line 6500 "nibbles-game.c"
}

gboolean
nibbles_game_get_skip_score (NibblesGame* self)
{
	gboolean result;
#line 169 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 169 "../src/nibbles-game.vala"
	result = self->priv->_skip_score;
#line 169 "../src/nibbles-game.vala"
	return result;
#line 6513 "nibbles-game.c"
}

void
nibbles_game_set_skip_score (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 169 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_skip_score (self);
#line 169 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 169 "../src/nibbles-game.vala"
		self->priv->_skip_score = value;
#line 169 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY]);
#line 6531 "nibbles-game.c"
	}
}

gint
nibbles_game_get_current_level (NibblesGame* self)
{
	gint result;
#line 170 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 170 "../src/nibbles-game.vala"
	result = self->priv->_current_level;
#line 170 "../src/nibbles-game.vala"
	return result;
#line 6545 "nibbles-game.c"
}

void
nibbles_game_set_current_level (NibblesGame* self,
                                gint value)
{
	gint old_value;
#line 170 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_current_level (self);
#line 170 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 170 "../src/nibbles-game.vala"
		self->priv->_current_level = value;
#line 170 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY]);
#line 6563 "nibbles-game.c"
	}
}

gboolean
nibbles_game_get_three_dimensional_view (NibblesGame* self)
{
	gboolean result;
#line 171 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 171 "../src/nibbles-game.vala"
	result = self->priv->_three_dimensional_view;
#line 171 "../src/nibbles-game.vala"
	return result;
#line 6577 "nibbles-game.c"
}

void
nibbles_game_set_three_dimensional_view (NibblesGame* self,
                                         gboolean value)
{
	gboolean old_value;
#line 171 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 171 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_three_dimensional_view (self);
#line 171 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 171 "../src/nibbles-game.vala"
		self->priv->_three_dimensional_view = value;
#line 171 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY]);
#line 6595 "nibbles-game.c"
	}
}

gint
nibbles_game_get_speed (NibblesGame* self)
{
	gint result;
#line 172 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 172 "../src/nibbles-game.vala"
	result = self->priv->_speed;
#line 172 "../src/nibbles-game.vala"
	return result;
#line 6609 "nibbles-game.c"
}

void
nibbles_game_set_speed (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 172 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 172 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_speed (self);
#line 172 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 172 "../src/nibbles-game.vala"
		self->priv->_speed = value;
#line 172 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY]);
#line 6627 "nibbles-game.c"
	}
}

gint
nibbles_game_get_gamedelay (NibblesGame* self)
{
	gint result;
#line 173 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 173 "../src/nibbles-game.vala"
	result = self->priv->_gamedelay;
#line 173 "../src/nibbles-game.vala"
	return result;
#line 6641 "nibbles-game.c"
}

static void
nibbles_game_set_gamedelay (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 173 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 173 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_gamedelay (self);
#line 173 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 173 "../src/nibbles-game.vala"
		self->priv->_gamedelay = value;
#line 173 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY]);
#line 6659 "nibbles-game.c"
	}
}

gint
nibbles_game_get_progress (NibblesGame* self)
{
	gint result;
#line 175 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 175 "../src/nibbles-game.vala"
	result = self->_progress;
#line 175 "../src/nibbles-game.vala"
	return result;
#line 6673 "nibbles-game.c"
}

void
nibbles_game_set_progress (NibblesGame* self,
                           gint value)
{
	NibblesGameBonuses* _tmp0_;
#line 175 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/nibbles-game.vala"
	self->_progress = value;
#line 175 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->bonuses;
#line 175 "../src/nibbles-game.vala"
	if (_tmp0_ != NULL) {
#line 6689 "nibbles-game.c"
		NibblesGameBonuses* _tmp1_;
#line 175 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->bonuses;
#line 175 "../src/nibbles-game.vala"
		_tmp1_->progress = self->_progress;
#line 6695 "nibbles-game.c"
	}
#line 175 "../src/nibbles-game.vala"
	g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_PROGRESS_PROPERTY]);
#line 6699 "nibbles-game.c"
}

gint
nibbles_game_get_start_level (NibblesGame* self)
{
	gint result;
#line 176 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 176 "../src/nibbles-game.vala"
	result = self->priv->_start_level;
#line 176 "../src/nibbles-game.vala"
	return result;
#line 6712 "nibbles-game.c"
}

void
nibbles_game_set_start_level (NibblesGame* self,
                              gint value)
{
	gint old_value;
#line 176 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 176 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_start_level (self);
#line 176 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 176 "../src/nibbles-game.vala"
		self->priv->_start_level = value;
#line 176 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_START_LEVEL_PROPERTY]);
#line 6730 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_width (NibblesGame* self)
{
	guint8 result;
#line 181 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 181 "../src/nibbles-game.vala"
	result = self->priv->_width;
#line 181 "../src/nibbles-game.vala"
	return result;
#line 6744 "nibbles-game.c"
}

static void
nibbles_game_set_width (NibblesGame* self,
                        guint8 value)
{
	guint8 old_value;
#line 181 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_width (self);
#line 181 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 181 "../src/nibbles-game.vala"
		self->priv->_width = value;
#line 181 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY]);
#line 6762 "nibbles-game.c"
	}
}

guint8
nibbles_game_get_height (NibblesGame* self)
{
	guint8 result;
#line 182 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 182 "../src/nibbles-game.vala"
	result = self->priv->_height;
#line 182 "../src/nibbles-game.vala"
	return result;
#line 6776 "nibbles-game.c"
}

static void
nibbles_game_set_height (NibblesGame* self,
                         guint8 value)
{
	guint8 old_value;
#line 182 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 182 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_height (self);
#line 182 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 182 "../src/nibbles-game.vala"
		self->priv->_height = value;
#line 182 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY]);
#line 6794 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numhumans (NibblesGame* self)
{
	gint result;
#line 185 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 185 "../src/nibbles-game.vala"
	result = self->priv->_numhumans;
#line 185 "../src/nibbles-game.vala"
	return result;
#line 6808 "nibbles-game.c"
}

void
nibbles_game_set_numhumans (NibblesGame* self,
                            gint value)
{
	gint old_value;
#line 185 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numhumans (self);
#line 185 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 185 "../src/nibbles-game.vala"
		self->priv->_numhumans = value;
#line 185 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY]);
#line 6826 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numai (NibblesGame* self)
{
	gint result;
#line 186 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 186 "../src/nibbles-game.vala"
	result = self->priv->_numai;
#line 186 "../src/nibbles-game.vala"
	return result;
#line 6840 "nibbles-game.c"
}

void
nibbles_game_set_numai (NibblesGame* self,
                        gint value)
{
	gint old_value;
#line 186 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 186 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numai (self);
#line 186 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 186 "../src/nibbles-game.vala"
		self->priv->_numai = value;
#line 186 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY]);
#line 6858 "nibbles-game.c"
	}
}

gint
nibbles_game_get_numworms (NibblesGame* self)
{
	gint result;
#line 187 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 187 "../src/nibbles-game.vala"
	result = self->priv->_numworms;
#line 187 "../src/nibbles-game.vala"
	return result;
#line 6872 "nibbles-game.c"
}

static void
nibbles_game_set_numworms (NibblesGame* self,
                           gint value)
{
	gint old_value;
#line 187 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_numworms (self);
#line 187 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 187 "../src/nibbles-game.vala"
		self->priv->_numworms = value;
#line 187 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY]);
#line 6890 "nibbles-game.c"
	}
}

GeeLinkedList*
nibbles_game_get_worms (NibblesGame* self)
{
	GeeLinkedList* result;
	GeeLinkedList* _tmp0_;
#line 190 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 190 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worms;
#line 190 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 190 "../src/nibbles-game.vala"
	return result;
#line 6907 "nibbles-game.c"
}

GeeHashMap*
nibbles_game_get_worm_props (NibblesGame* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 191 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm_props;
#line 191 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 191 "../src/nibbles-game.vala"
	return result;
#line 6923 "nibbles-game.c"
}

static GeeHashMap*
nibbles_game_get_score_deltas (NibblesGame* self)
{
	GeeHashMap* result;
	GeeHashMap* _tmp0_;
#line 203 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_score_deltas;
#line 203 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 203 "../src/nibbles-game.vala"
	return result;
#line 6939 "nibbles-game.c"
}

gboolean
nibbles_game_get_is_running (NibblesGame* self)
{
	gboolean result;
#line 207 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 207 "../src/nibbles-game.vala"
	result = self->priv->_is_running;
#line 207 "../src/nibbles-game.vala"
	return result;
#line 6952 "nibbles-game.c"
}

static void
nibbles_game_set_is_running (NibblesGame* self,
                             gboolean value)
{
	gboolean old_value;
#line 207 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_is_running (self);
#line 207 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 207 "../src/nibbles-game.vala"
		self->priv->_is_running = value;
#line 207 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY]);
#line 6970 "nibbles-game.c"
	}
}

static gboolean
nibbles_game_get_is_paused (NibblesGame* self)
{
	gboolean result;
#line 208 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 208 "../src/nibbles-game.vala"
	result = self->priv->_is_paused;
#line 208 "../src/nibbles-game.vala"
	return result;
#line 6984 "nibbles-game.c"
}

static void
nibbles_game_set_is_paused (NibblesGame* self,
                            gboolean value)
{
#line 208 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 208 "../src/nibbles-game.vala"
	self->priv->_is_paused = value;
#line 6995 "nibbles-game.c"
}

gboolean
nibbles_game_get_paused (NibblesGame* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 211 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 211 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_is_paused;
#line 211 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 211 "../src/nibbles-game.vala"
	return result;
#line 7011 "nibbles-game.c"
}

void
nibbles_game_set_paused (NibblesGame* self,
                         gboolean value)
{
#line 212 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 214 "../src/nibbles-game.vala"
	nibbles_game_set_is_paused (self, value);
#line 215 "../src/nibbles-game.vala"
	if (value) {
#line 216 "../src/nibbles-game.vala"
		nibbles_game_stop (self);
#line 7026 "nibbles-game.c"
	} else {
#line 218 "../src/nibbles-game.vala"
		nibbles_game_start (self, FALSE);
#line 7030 "nibbles-game.c"
	}
#line 212 "../src/nibbles-game.vala"
	g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_PAUSED_PROPERTY]);
#line 7034 "nibbles-game.c"
}

gboolean
nibbles_game_get_fakes (NibblesGame* self)
{
	gboolean result;
#line 224 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 224 "../src/nibbles-game.vala"
	result = self->priv->_fakes;
#line 224 "../src/nibbles-game.vala"
	return result;
#line 7047 "nibbles-game.c"
}

void
nibbles_game_set_fakes (NibblesGame* self,
                        gboolean value)
{
	gboolean old_value;
#line 224 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 224 "../src/nibbles-game.vala"
	old_value = nibbles_game_get_fakes (self);
#line 224 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 224 "../src/nibbles-game.vala"
		self->priv->_fakes = value;
#line 224 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY]);
#line 7065 "nibbles-game.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_INT (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_INT) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 4);
#line 36 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 36 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7091 "nibbles-game.c"
	} else {
#line 36 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7097 "nibbles-game.c"
	}
#line 36 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 36 "../src/nibbles-game.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 7103 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 36 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 36 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7128 "nibbles-game.c"
	} else {
#line 36 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7134 "nibbles-game.c"
	}
#line 36 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 36 "../src/nibbles-game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 7140 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_VOID__UCHAR_UCHAR (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__UCHAR_UCHAR) (gpointer data1, guint8 arg_1, guint8 arg_2, gpointer data2);
	register GMarshalFunc_VOID__UCHAR_UCHAR callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 36 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 36 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7165 "nibbles-game.c"
	} else {
#line 36 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7171 "nibbles-game.c"
	}
#line 36 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_VOID__UCHAR_UCHAR) (marshal_data ? marshal_data : cc->callback);
#line 36 "../src/nibbles-game.vala"
	callback (data1, g_value_get_uchar (param_values + 1), g_value_get_uchar (param_values + 2), data2);
#line 7177 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_STRING__VOID (GClosure * closure,
                                      GValue * return_value,
                                      guint n_param_values,
                                      const GValue * param_values,
                                      gpointer invocation_hint,
                                      gpointer marshal_data)
{
	typedef const char* (*GMarshalFunc_STRING__VOID) (gpointer data1, gpointer data2);
	register GMarshalFunc_STRING__VOID callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	const char* v_return;
	cc = (GCClosure *) closure;
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (return_value != NULL);
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 1);
#line 36 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 36 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7205 "nibbles-game.c"
	} else {
#line 36 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7211 "nibbles-game.c"
	}
#line 36 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_STRING__VOID) (marshal_data ? marshal_data : cc->callback);
#line 36 "../src/nibbles-game.vala"
	v_return = callback (data1, data2);
#line 36 "../src/nibbles-game.vala"
	g_value_take_string (return_value, v_return);
#line 7219 "nibbles-game.c"
}

static void
g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__POINTER_POINTER) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_BOOLEAN__POINTER_POINTER callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (return_value != NULL);
#line 36 "../src/nibbles-game.vala"
	g_return_if_fail (n_param_values == 3);
#line 36 "../src/nibbles-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 36 "../src/nibbles-game.vala"
		data1 = closure->data;
#line 36 "../src/nibbles-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 7247 "nibbles-game.c"
	} else {
#line 36 "../src/nibbles-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 36 "../src/nibbles-game.vala"
		data2 = closure->data;
#line 7253 "nibbles-game.c"
	}
#line 36 "../src/nibbles-game.vala"
	callback = (GMarshalFunc_BOOLEAN__POINTER_POINTER) (marshal_data ? marshal_data : cc->callback);
#line 36 "../src/nibbles-game.vala"
	v_return = callback (data1, g_value_get_pointer (param_values + 1), g_value_get_pointer (param_values + 2), data2);
#line 36 "../src/nibbles-game.vala"
	g_value_set_boolean (return_value, v_return);
#line 7261 "nibbles-game.c"
}

static inline gpointer
nibbles_game_bonuses_get_instance_private (NibblesGameBonuses* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGameBonuses_private_offset);
}

static gboolean
nibbles_game_bonuses_add_bonus (NibblesGameBonuses* self,
                                Bonus* bonus)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 52 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "../src/nibbles-game.vala"
	g_return_val_if_fail (bonus != NULL, FALSE);
#line 54 "../src/nibbles-game.vala"
	if (self->progress != 2) {
#line 54 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->total_bonus_number >= NIBBLES_GAME_BONUSES_MAX_BONUSES;
#line 7284 "nibbles-game.c"
	} else {
#line 54 "../src/nibbles-game.vala"
		_tmp0_ = FALSE;
#line 7288 "nibbles-game.c"
	}
#line 54 "../src/nibbles-game.vala"
	if (_tmp0_) {
#line 55 "../src/nibbles-game.vala"
		result = FALSE;
#line 55 "../src/nibbles-game.vala"
		_g_object_unref0 (bonus);
#line 55 "../src/nibbles-game.vala"
		return result;
#line 7298 "nibbles-game.c"
	} else {
		GeeLinkedList* _tmp1_;
		guint8 _tmp2_;
#line 58 "../src/nibbles-game.vala"
		_tmp1_ = self->priv->bonuses;
#line 58 "../src/nibbles-game.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, bonus);
#line 59 "../src/nibbles-game.vala"
		_tmp2_ = self->priv->total_bonus_number;
#line 59 "../src/nibbles-game.vala"
		self->priv->total_bonus_number = _tmp2_ + 1;
#line 60 "../src/nibbles-game.vala"
		result = TRUE;
#line 60 "../src/nibbles-game.vala"
		_g_object_unref0 (bonus);
#line 60 "../src/nibbles-game.vala"
		return result;
#line 7316 "nibbles-game.c"
	}
}

static void
nibbles_game_bonuses_remove_bonus (NibblesGameBonuses* self,
                                   Bonus* bonus)
{
	GeeLinkedList* _tmp0_;
#line 64 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 66 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_bonuses_signals[NIBBLES_GAME_BONUSES_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 67 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->bonuses;
#line 67 "../src/nibbles-game.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp0_, bonus);
#line 7335 "nibbles-game.c"
}

static void
nibbles_game_bonuses_reset (NibblesGameBonuses* self,
                            guint8 regular_bonus)
{
	GeeLinkedList* _tmp0_;
	guint8 _tmp1_ = 0U;
#line 70 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->bonuses;
#line 72 "../src/nibbles-game.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp0_);
#line 73 "../src/nibbles-game.vala"
	nibbles_game_bonuses_reset_missed (self);
#line 74 "../src/nibbles-game.vala"
	if (regular_bonus < NIBBLES_GAME_BONUSES_MAX_BONUSES) {
#line 74 "../src/nibbles-game.vala"
		_tmp1_ = regular_bonus;
#line 7356 "nibbles-game.c"
	} else {
#line 74 "../src/nibbles-game.vala"
		_tmp1_ = NIBBLES_GAME_BONUSES_MAX_BONUSES;
#line 7360 "nibbles-game.c"
	}
#line 74 "../src/nibbles-game.vala"
	self->priv->regular_bonus_maxi = _tmp1_;
#line 75 "../src/nibbles-game.vala"
	self->priv->regular_bonus_left = self->priv->regular_bonus_maxi;
#line 76 "../src/nibbles-game.vala"
	self->priv->total_bonus_number = (guint8) 0;
#line 7368 "nibbles-game.c"
}

static Bonus*
nibbles_game_bonuses_get_bonus (NibblesGameBonuses* self,
                                guint8 x,
                                guint8 y)
{
	Bonus* result;
#line 79 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 7379 "nibbles-game.c"
	{
		GeeLinkedList* _bonus_list = NULL;
		GeeLinkedList* _tmp0_;
		gint _bonus_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _bonus_index = 0;
#line 81 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->bonuses;
#line 81 "../src/nibbles-game.vala"
		_bonus_list = _tmp0_;
#line 81 "../src/nibbles-game.vala"
		_tmp1_ = _bonus_list;
#line 81 "../src/nibbles-game.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 81 "../src/nibbles-game.vala"
		_tmp3_ = _tmp2_;
#line 81 "../src/nibbles-game.vala"
		_bonus_size = _tmp3_;
#line 81 "../src/nibbles-game.vala"
		_bonus_index = -1;
#line 81 "../src/nibbles-game.vala"
		while (TRUE) {
#line 7404 "nibbles-game.c"
			gint _tmp4_;
			gint _tmp5_;
			Bonus* bonus = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			gboolean _tmp8_ = FALSE;
			gboolean _tmp9_ = FALSE;
			gboolean _tmp10_ = FALSE;
			gboolean _tmp11_ = FALSE;
			Bonus* _tmp12_;
			guint8 _tmp13_;
			guint8 _tmp14_;
#line 81 "../src/nibbles-game.vala"
			_bonus_index = _bonus_index + 1;
#line 81 "../src/nibbles-game.vala"
			_tmp4_ = _bonus_index;
#line 81 "../src/nibbles-game.vala"
			_tmp5_ = _bonus_size;
#line 81 "../src/nibbles-game.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 81 "../src/nibbles-game.vala"
				break;
#line 7427 "nibbles-game.c"
			}
#line 81 "../src/nibbles-game.vala"
			_tmp6_ = _bonus_list;
#line 81 "../src/nibbles-game.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _bonus_index);
#line 81 "../src/nibbles-game.vala"
			bonus = (Bonus*) _tmp7_;
#line 83 "../src/nibbles-game.vala"
			_tmp12_ = bonus;
#line 83 "../src/nibbles-game.vala"
			_tmp13_ = bonus_get_x (_tmp12_);
#line 83 "../src/nibbles-game.vala"
			_tmp14_ = _tmp13_;
#line 83 "../src/nibbles-game.vala"
			if (((gint) x) == (_tmp14_ + 0)) {
#line 7443 "nibbles-game.c"
				Bonus* _tmp15_;
				guint8 _tmp16_;
				guint8 _tmp17_;
#line 83 "../src/nibbles-game.vala"
				_tmp15_ = bonus;
#line 83 "../src/nibbles-game.vala"
				_tmp16_ = bonus_get_y (_tmp15_);
#line 83 "../src/nibbles-game.vala"
				_tmp17_ = _tmp16_;
#line 83 "../src/nibbles-game.vala"
				_tmp11_ = ((gint) y) == (_tmp17_ + 0);
#line 7455 "nibbles-game.c"
			} else {
#line 83 "../src/nibbles-game.vala"
				_tmp11_ = FALSE;
#line 7459 "nibbles-game.c"
			}
#line 83 "../src/nibbles-game.vala"
			if (_tmp11_) {
#line 83 "../src/nibbles-game.vala"
				_tmp10_ = TRUE;
#line 7465 "nibbles-game.c"
			} else {
				gboolean _tmp18_ = FALSE;
				Bonus* _tmp19_;
				guint8 _tmp20_;
				guint8 _tmp21_;
#line 84 "../src/nibbles-game.vala"
				_tmp19_ = bonus;
#line 84 "../src/nibbles-game.vala"
				_tmp20_ = bonus_get_x (_tmp19_);
#line 84 "../src/nibbles-game.vala"
				_tmp21_ = _tmp20_;
#line 84 "../src/nibbles-game.vala"
				if (((gint) x) == (_tmp21_ + 1)) {
#line 7479 "nibbles-game.c"
					Bonus* _tmp22_;
					guint8 _tmp23_;
					guint8 _tmp24_;
#line 84 "../src/nibbles-game.vala"
					_tmp22_ = bonus;
#line 84 "../src/nibbles-game.vala"
					_tmp23_ = bonus_get_y (_tmp22_);
#line 84 "../src/nibbles-game.vala"
					_tmp24_ = _tmp23_;
#line 84 "../src/nibbles-game.vala"
					_tmp18_ = ((gint) y) == (_tmp24_ + 0);
#line 7491 "nibbles-game.c"
				} else {
#line 84 "../src/nibbles-game.vala"
					_tmp18_ = FALSE;
#line 7495 "nibbles-game.c"
				}
#line 84 "../src/nibbles-game.vala"
				_tmp10_ = _tmp18_;
#line 7499 "nibbles-game.c"
			}
#line 83 "../src/nibbles-game.vala"
			if (_tmp10_) {
#line 83 "../src/nibbles-game.vala"
				_tmp9_ = TRUE;
#line 7505 "nibbles-game.c"
			} else {
				gboolean _tmp25_ = FALSE;
				Bonus* _tmp26_;
				guint8 _tmp27_;
				guint8 _tmp28_;
#line 85 "../src/nibbles-game.vala"
				_tmp26_ = bonus;
#line 85 "../src/nibbles-game.vala"
				_tmp27_ = bonus_get_x (_tmp26_);
#line 85 "../src/nibbles-game.vala"
				_tmp28_ = _tmp27_;
#line 85 "../src/nibbles-game.vala"
				if (((gint) x) == (_tmp28_ + 0)) {
#line 7519 "nibbles-game.c"
					Bonus* _tmp29_;
					guint8 _tmp30_;
					guint8 _tmp31_;
#line 85 "../src/nibbles-game.vala"
					_tmp29_ = bonus;
#line 85 "../src/nibbles-game.vala"
					_tmp30_ = bonus_get_y (_tmp29_);
#line 85 "../src/nibbles-game.vala"
					_tmp31_ = _tmp30_;
#line 85 "../src/nibbles-game.vala"
					_tmp25_ = ((gint) y) == (_tmp31_ + 1);
#line 7531 "nibbles-game.c"
				} else {
#line 85 "../src/nibbles-game.vala"
					_tmp25_ = FALSE;
#line 7535 "nibbles-game.c"
				}
#line 85 "../src/nibbles-game.vala"
				_tmp9_ = _tmp25_;
#line 7539 "nibbles-game.c"
			}
#line 83 "../src/nibbles-game.vala"
			if (_tmp9_) {
#line 83 "../src/nibbles-game.vala"
				_tmp8_ = TRUE;
#line 7545 "nibbles-game.c"
			} else {
				gboolean _tmp32_ = FALSE;
				Bonus* _tmp33_;
				guint8 _tmp34_;
				guint8 _tmp35_;
#line 86 "../src/nibbles-game.vala"
				_tmp33_ = bonus;
#line 86 "../src/nibbles-game.vala"
				_tmp34_ = bonus_get_x (_tmp33_);
#line 86 "../src/nibbles-game.vala"
				_tmp35_ = _tmp34_;
#line 86 "../src/nibbles-game.vala"
				if (((gint) x) == (_tmp35_ + 1)) {
#line 7559 "nibbles-game.c"
					Bonus* _tmp36_;
					guint8 _tmp37_;
					guint8 _tmp38_;
#line 86 "../src/nibbles-game.vala"
					_tmp36_ = bonus;
#line 86 "../src/nibbles-game.vala"
					_tmp37_ = bonus_get_y (_tmp36_);
#line 86 "../src/nibbles-game.vala"
					_tmp38_ = _tmp37_;
#line 86 "../src/nibbles-game.vala"
					_tmp32_ = ((gint) y) == (_tmp38_ + 1);
#line 7571 "nibbles-game.c"
				} else {
#line 86 "../src/nibbles-game.vala"
					_tmp32_ = FALSE;
#line 7575 "nibbles-game.c"
				}
#line 86 "../src/nibbles-game.vala"
				_tmp8_ = _tmp32_;
#line 7579 "nibbles-game.c"
			}
#line 83 "../src/nibbles-game.vala"
			if (_tmp8_) {
#line 87 "../src/nibbles-game.vala"
				result = bonus;
#line 87 "../src/nibbles-game.vala"
				return result;
#line 7587 "nibbles-game.c"
			}
#line 81 "../src/nibbles-game.vala"
			_g_object_unref0 (bonus);
#line 7591 "nibbles-game.c"
		}
	}
#line 89 "../src/nibbles-game.vala"
	result = NULL;
#line 89 "../src/nibbles-game.vala"
	return result;
#line 7598 "nibbles-game.c"
}

static GeeList*
nibbles_game_bonuses_get_bonuses (NibblesGameBonuses* self)
{
	GeeLinkedList* _tmp0_;
	GeeList* _tmp1_;
	GeeList* result;
#line 92 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->bonuses;
#line 94 "../src/nibbles-game.vala"
	_tmp1_ = _g_object_ref0 ((GeeList*) _tmp0_);
#line 94 "../src/nibbles-game.vala"
	result = _tmp1_;
#line 94 "../src/nibbles-game.vala"
	return result;
#line 7617 "nibbles-game.c"
}

static void
nibbles_game_bonuses_on_worms_move (NibblesGameBonuses* self,
                                    guint8* missed_bonuses_to_replace)
{
	guint8 _vala_missed_bonuses_to_replace = 0U;
#line 97 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/nibbles-game.vala"
	_vala_missed_bonuses_to_replace = (guint8) 0;
#line 7629 "nibbles-game.c"
	{
		gint i = 0;
		GeeLinkedList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 100 "../src/nibbles-game.vala"
		_tmp0_ = self->priv->bonuses;
#line 100 "../src/nibbles-game.vala"
		_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 100 "../src/nibbles-game.vala"
		_tmp2_ = _tmp1_;
#line 100 "../src/nibbles-game.vala"
		i = _tmp2_;
#line 7643 "nibbles-game.c"
		{
			gboolean _tmp3_ = FALSE;
#line 100 "../src/nibbles-game.vala"
			_tmp3_ = TRUE;
#line 100 "../src/nibbles-game.vala"
			while (TRUE) {
#line 7650 "nibbles-game.c"
				Bonus* bonus = NULL;
				GeeLinkedList* _tmp5_;
				gpointer _tmp6_;
				Bonus* _tmp7_;
				guint16 _tmp8_;
				guint16 _tmp9_;
#line 100 "../src/nibbles-game.vala"
				if (!_tmp3_) {
#line 7659 "nibbles-game.c"
					gint _tmp4_;
#line 100 "../src/nibbles-game.vala"
					_tmp4_ = i;
#line 100 "../src/nibbles-game.vala"
					i = _tmp4_ - 1;
#line 7665 "nibbles-game.c"
				}
#line 100 "../src/nibbles-game.vala"
				_tmp3_ = FALSE;
#line 100 "../src/nibbles-game.vala"
				if (!(i > 0)) {
#line 100 "../src/nibbles-game.vala"
					break;
#line 7673 "nibbles-game.c"
				}
#line 102 "../src/nibbles-game.vala"
				_tmp5_ = self->priv->bonuses;
#line 102 "../src/nibbles-game.vala"
				_tmp6_ = gee_abstract_list_get ((GeeAbstractList*) _tmp5_, i - 1);
#line 102 "../src/nibbles-game.vala"
				bonus = (Bonus*) _tmp6_;
#line 103 "../src/nibbles-game.vala"
				_tmp7_ = bonus;
#line 103 "../src/nibbles-game.vala"
				_tmp8_ = bonus_get_countdown (_tmp7_);
#line 103 "../src/nibbles-game.vala"
				_tmp9_ = _tmp8_;
#line 103 "../src/nibbles-game.vala"
				if (((gint) _tmp9_) > 0) {
#line 7689 "nibbles-game.c"
					Bonus* _tmp10_;
					guint16 _tmp11_;
					guint16 _tmp12_;
#line 104 "../src/nibbles-game.vala"
					_tmp10_ = bonus;
#line 104 "../src/nibbles-game.vala"
					_tmp11_ = bonus_get_countdown (_tmp10_);
#line 104 "../src/nibbles-game.vala"
					_tmp12_ = _tmp11_;
#line 104 "../src/nibbles-game.vala"
					bonus_set_countdown (_tmp10_, _tmp12_ - 1);
#line 7701 "nibbles-game.c"
				} else {
					Bonus* _tmp13_;
					gboolean _tmp14_ = FALSE;
					Bonus* _tmp15_;
					BonuseType _tmp16_;
					BonuseType _tmp17_;
#line 107 "../src/nibbles-game.vala"
					_tmp13_ = bonus;
#line 107 "../src/nibbles-game.vala"
					nibbles_game_bonuses_remove_bonus (self, _tmp13_);
#line 108 "../src/nibbles-game.vala"
					_tmp15_ = bonus;
#line 108 "../src/nibbles-game.vala"
					_tmp16_ = bonus_get_etype (_tmp15_);
#line 108 "../src/nibbles-game.vala"
					_tmp17_ = _tmp16_;
#line 108 "../src/nibbles-game.vala"
					if (_tmp17_ == BONUS_ETYPE_REGULAR) {
#line 7720 "nibbles-game.c"
						Bonus* _tmp18_;
						gboolean _tmp19_;
						gboolean _tmp20_;
#line 108 "../src/nibbles-game.vala"
						_tmp18_ = bonus;
#line 108 "../src/nibbles-game.vala"
						_tmp19_ = bonus_get_fake (_tmp18_);
#line 108 "../src/nibbles-game.vala"
						_tmp20_ = _tmp19_;
#line 108 "../src/nibbles-game.vala"
						_tmp14_ = !_tmp20_;
#line 7732 "nibbles-game.c"
					} else {
#line 108 "../src/nibbles-game.vala"
						_tmp14_ = FALSE;
#line 7736 "nibbles-game.c"
					}
#line 108 "../src/nibbles-game.vala"
					if (_tmp14_) {
#line 7740 "nibbles-game.c"
						guint8 _tmp21_;
#line 110 "../src/nibbles-game.vala"
						nibbles_game_bonuses_increase_missed (self);
#line 111 "../src/nibbles-game.vala"
						_tmp21_ = _vala_missed_bonuses_to_replace;
#line 111 "../src/nibbles-game.vala"
						_vala_missed_bonuses_to_replace = _tmp21_ + 1;
#line 7748 "nibbles-game.c"
					}
				}
#line 100 "../src/nibbles-game.vala"
				_g_object_unref0 (bonus);
#line 7753 "nibbles-game.c"
			}
		}
	}
#line 97 "../src/nibbles-game.vala"
	if (missed_bonuses_to_replace) {
#line 97 "../src/nibbles-game.vala"
		*missed_bonuses_to_replace = _vala_missed_bonuses_to_replace;
#line 7761 "nibbles-game.c"
	}
}

static guint8
nibbles_game_bonuses_new_regular_bonus_eaten (NibblesGameBonuses* self)
{
	guint8 result;
#line 117 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 119 "../src/nibbles-game.vala"
	nibbles_game_bonuses_reset_missed (self);
#line 120 "../src/nibbles-game.vala"
	if (((gint) self->priv->regular_bonus_left) > 0) {
#line 121 "../src/nibbles-game.vala"
		result = (guint8) (self->priv->regular_bonus_maxi - (self->priv->regular_bonus_left - 1));
#line 121 "../src/nibbles-game.vala"
		return result;
#line 7779 "nibbles-game.c"
	} else {
#line 123 "../src/nibbles-game.vala"
		result = self->priv->regular_bonus_maxi - self->priv->regular_bonus_left;
#line 123 "../src/nibbles-game.vala"
		return result;
#line 7785 "nibbles-game.c"
	}
}

static void
nibbles_game_bonuses_decrement_regular_bonus (NibblesGameBonuses* self,
                                              gint d)
{
#line 126 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/nibbles-game.vala"
	if (((gint) self->priv->regular_bonus_left) > d) {
#line 129 "../src/nibbles-game.vala"
		self->priv->regular_bonus_left = self->priv->regular_bonus_left - ((guint8) d);
#line 7799 "nibbles-game.c"
	} else {
#line 131 "../src/nibbles-game.vala"
		self->priv->regular_bonus_left = (guint8) 0;
#line 7803 "nibbles-game.c"
	}
}

static inline gboolean
nibbles_game_bonuses_last_regular_bonus (NibblesGameBonuses* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 134 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../src/nibbles-game.vala"
	if (self->progress != 2) {
#line 136 "../src/nibbles-game.vala"
		_tmp0_ = ((gint) self->priv->regular_bonus_left) == 0;
#line 7818 "nibbles-game.c"
	} else {
#line 136 "../src/nibbles-game.vala"
		_tmp0_ = FALSE;
#line 7822 "nibbles-game.c"
	}
#line 136 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 136 "../src/nibbles-game.vala"
	return result;
#line 7828 "nibbles-game.c"
}

static inline gboolean
nibbles_game_bonuses_too_many_missed (NibblesGameBonuses* self)
{
	gboolean result;
#line 145 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 147 "../src/nibbles-game.vala"
	result = self->priv->missed > NIBBLES_GAME_BONUSES_MAX_MISSED;
#line 147 "../src/nibbles-game.vala"
	return result;
#line 7841 "nibbles-game.c"
}

static inline void
nibbles_game_bonuses_increase_missed (NibblesGameBonuses* self)
{
	guint8 _tmp0_;
#line 150 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->missed;
#line 152 "../src/nibbles-game.vala"
	self->priv->missed = _tmp0_ + 1;
#line 7854 "nibbles-game.c"
}

static inline void
nibbles_game_bonuses_reset_missed (NibblesGameBonuses* self)
{
#line 155 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/nibbles-game.vala"
	self->priv->missed = (guint8) 0;
#line 7864 "nibbles-game.c"
}

static NibblesGameBonuses*
nibbles_game_bonuses_construct (GType object_type)
{
	NibblesGameBonuses * self = NULL;
#line 39 "../src/nibbles-game.vala"
	self = (NibblesGameBonuses*) g_object_new (object_type, NULL);
#line 39 "../src/nibbles-game.vala"
	return self;
#line 7875 "nibbles-game.c"
}

static NibblesGameBonuses*
nibbles_game_bonuses_new (void)
{
#line 39 "../src/nibbles-game.vala"
	return nibbles_game_bonuses_construct (NIBBLES_GAME_TYPE_BONUSES);
#line 7883 "nibbles-game.c"
}

static void
nibbles_game_bonuses_class_init (NibblesGameBonusesClass * klass,
                                 gpointer klass_data)
{
#line 39 "../src/nibbles-game.vala"
	nibbles_game_bonuses_parent_class = g_type_class_peek_parent (klass);
#line 39 "../src/nibbles-game.vala"
	g_type_class_adjust_private_offset (klass, &NibblesGameBonuses_private_offset);
#line 39 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_bonuses_finalize;
#line 39 "../src/nibbles-game.vala"
	nibbles_game_bonuses_signals[NIBBLES_GAME_BONUSES_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", NIBBLES_GAME_TYPE_BONUSES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 7898 "nibbles-game.c"
}

static void
nibbles_game_bonuses_instance_init (NibblesGameBonuses * self,
                                    gpointer klass)
{
	GeeLinkedList* _tmp0_;
#line 39 "../src/nibbles-game.vala"
	self->priv = nibbles_game_bonuses_get_instance_private (self);
#line 41 "../src/nibbles-game.vala"
	_tmp0_ = gee_linked_list_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 41 "../src/nibbles-game.vala"
	self->priv->bonuses = _tmp0_;
#line 43 "../src/nibbles-game.vala"
	self->priv->regular_bonus_left = (guint8) 0;
#line 44 "../src/nibbles-game.vala"
	self->priv->regular_bonus_maxi = (guint8) 0;
#line 45 "../src/nibbles-game.vala"
	self->priv->total_bonus_number = (guint8) 0;
#line 142 "../src/nibbles-game.vala"
	self->priv->missed = (guint8) 0;
#line 7920 "nibbles-game.c"
}

static void
nibbles_game_bonuses_finalize (GObject * obj)
{
	NibblesGameBonuses * self;
#line 39 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NIBBLES_GAME_TYPE_BONUSES, NibblesGameBonuses);
#line 41 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->bonuses);
#line 39 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (nibbles_game_bonuses_parent_class)->finalize (obj);
#line 7933 "nibbles-game.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_game_bonuses_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameBonusesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_bonuses_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGameBonuses), 0, (GInstanceInitFunc) nibbles_game_bonuses_instance_init, NULL };
	GType nibbles_game_bonuses_type_id;
	nibbles_game_bonuses_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGameBonuses", &g_define_type_info, 0);
	NibblesGameBonuses_private_offset = g_type_add_instance_private (nibbles_game_bonuses_type_id, sizeof (NibblesGameBonusesPrivate));
	return nibbles_game_bonuses_type_id;
}

static GType
nibbles_game_bonuses_get_type (void)
{
	static gsize nibbles_game_bonuses_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_bonuses_type_id__once)) {
		GType nibbles_game_bonuses_type_id;
		nibbles_game_bonuses_type_id = nibbles_game_bonuses_get_type_once ();
		g_once_init_leave (&nibbles_game_bonuses_type_id__once, nibbles_game_bonuses_type_id);
	}
	return nibbles_game_bonuses_type_id__once;
}

static inline gpointer
nibbles_game_score_delta_get_instance_private (NibblesGameScoreDelta* self)
{
	return G_STRUCT_MEMBER_P (self, NibblesGameScoreDelta_private_offset);
}

static NibblesGameScoreDelta*
nibbles_game_score_delta_construct (GType object_type,
                                    Worm* worm,
                                    gint score_delta)
{
	NibblesGameScoreDelta * self = NULL;
#line 198 "../src/nibbles-game.vala"
	g_return_val_if_fail (worm != NULL, NULL);
#line 200 "../src/nibbles-game.vala"
	self = (NibblesGameScoreDelta*) g_object_new (object_type, "worm", worm, "score-delta", score_delta, NULL);
#line 198 "../src/nibbles-game.vala"
	return self;
#line 7976 "nibbles-game.c"
}

static NibblesGameScoreDelta*
nibbles_game_score_delta_new (Worm* worm,
                              gint score_delta)
{
#line 198 "../src/nibbles-game.vala"
	return nibbles_game_score_delta_construct (NIBBLES_GAME_TYPE_SCORE_DELTA, worm, score_delta);
#line 7985 "nibbles-game.c"
}

static Worm*
nibbles_game_score_delta_get_worm (NibblesGameScoreDelta* self)
{
	Worm* result;
	Worm* _tmp0_;
#line 196 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 196 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_worm;
#line 196 "../src/nibbles-game.vala"
	result = _tmp0_;
#line 196 "../src/nibbles-game.vala"
	return result;
#line 8001 "nibbles-game.c"
}

static void
nibbles_game_score_delta_set_worm (NibblesGameScoreDelta* self,
                                   Worm* value)
{
	Worm* old_value;
#line 196 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/nibbles-game.vala"
	old_value = nibbles_game_score_delta_get_worm (self);
#line 196 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 8015 "nibbles-game.c"
		Worm* _tmp0_;
#line 196 "../src/nibbles-game.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 196 "../src/nibbles-game.vala"
		_g_object_unref0 (self->priv->_worm);
#line 196 "../src/nibbles-game.vala"
		self->priv->_worm = _tmp0_;
#line 196 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_score_delta_properties[NIBBLES_GAME_SCORE_DELTA_WORM_PROPERTY]);
#line 8025 "nibbles-game.c"
	}
}

static gint
nibbles_game_score_delta_get_score_delta (NibblesGameScoreDelta* self)
{
	gint result;
#line 197 "../src/nibbles-game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 197 "../src/nibbles-game.vala"
	result = self->priv->_score_delta;
#line 197 "../src/nibbles-game.vala"
	return result;
#line 8039 "nibbles-game.c"
}

static void
nibbles_game_score_delta_set_score_delta (NibblesGameScoreDelta* self,
                                          gint value)
{
	gint old_value;
#line 197 "../src/nibbles-game.vala"
	g_return_if_fail (self != NULL);
#line 197 "../src/nibbles-game.vala"
	old_value = nibbles_game_score_delta_get_score_delta (self);
#line 197 "../src/nibbles-game.vala"
	if (old_value != value) {
#line 197 "../src/nibbles-game.vala"
		self->priv->_score_delta = value;
#line 197 "../src/nibbles-game.vala"
		g_object_notify_by_pspec ((GObject *) self, nibbles_game_score_delta_properties[NIBBLES_GAME_SCORE_DELTA_SCORE_DELTA_PROPERTY]);
#line 8057 "nibbles-game.c"
	}
}

static void
nibbles_game_score_delta_class_init (NibblesGameScoreDeltaClass * klass,
                                     gpointer klass_data)
{
#line 194 "../src/nibbles-game.vala"
	nibbles_game_score_delta_parent_class = g_type_class_peek_parent (klass);
#line 194 "../src/nibbles-game.vala"
	g_type_class_adjust_private_offset (klass, &NibblesGameScoreDelta_private_offset);
#line 194 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_game_score_delta_get_property;
#line 194 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_game_score_delta_set_property;
#line 194 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_score_delta_finalize;
#line 194 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SCORE_DELTA_WORM_PROPERTY, nibbles_game_score_delta_properties[NIBBLES_GAME_SCORE_DELTA_WORM_PROPERTY] = g_param_spec_object ("worm", "worm", "worm", TYPE_WORM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 194 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SCORE_DELTA_SCORE_DELTA_PROPERTY, nibbles_game_score_delta_properties[NIBBLES_GAME_SCORE_DELTA_SCORE_DELTA_PROPERTY] = g_param_spec_int ("score-delta", "score-delta", "score-delta", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 8079 "nibbles-game.c"
}

static void
nibbles_game_score_delta_instance_init (NibblesGameScoreDelta * self,
                                        gpointer klass)
{
#line 194 "../src/nibbles-game.vala"
	self->priv = nibbles_game_score_delta_get_instance_private (self);
#line 8088 "nibbles-game.c"
}

static void
nibbles_game_score_delta_finalize (GObject * obj)
{
	NibblesGameScoreDelta * self;
#line 194 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NIBBLES_GAME_TYPE_SCORE_DELTA, NibblesGameScoreDelta);
#line 196 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worm);
#line 194 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (nibbles_game_score_delta_parent_class)->finalize (obj);
#line 8101 "nibbles-game.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_game_score_delta_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameScoreDeltaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_score_delta_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGameScoreDelta), 0, (GInstanceInitFunc) nibbles_game_score_delta_instance_init, NULL };
	GType nibbles_game_score_delta_type_id;
	nibbles_game_score_delta_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGameScoreDelta", &g_define_type_info, 0);
	NibblesGameScoreDelta_private_offset = g_type_add_instance_private (nibbles_game_score_delta_type_id, sizeof (NibblesGameScoreDeltaPrivate));
	return nibbles_game_score_delta_type_id;
}

static GType
nibbles_game_score_delta_get_type (void)
{
	static gsize nibbles_game_score_delta_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_score_delta_type_id__once)) {
		GType nibbles_game_score_delta_type_id;
		nibbles_game_score_delta_type_id = nibbles_game_score_delta_get_type_once ();
		g_once_init_leave (&nibbles_game_score_delta_type_id__once, nibbles_game_score_delta_type_id);
	}
	return nibbles_game_score_delta_type_id__once;
}

static void
_vala_nibbles_game_score_delta_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	NibblesGameScoreDelta * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NIBBLES_GAME_TYPE_SCORE_DELTA, NibblesGameScoreDelta);
#line 194 "../src/nibbles-game.vala"
	switch (property_id) {
#line 194 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SCORE_DELTA_WORM_PROPERTY:
#line 194 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_score_delta_get_worm (self));
#line 194 "../src/nibbles-game.vala"
		break;
#line 194 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SCORE_DELTA_SCORE_DELTA_PROPERTY:
#line 194 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_score_delta_get_score_delta (self));
#line 194 "../src/nibbles-game.vala"
		break;
#line 8148 "nibbles-game.c"
		default:
#line 194 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 194 "../src/nibbles-game.vala"
		break;
#line 8154 "nibbles-game.c"
	}
}

static void
_vala_nibbles_game_score_delta_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	NibblesGameScoreDelta * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NIBBLES_GAME_TYPE_SCORE_DELTA, NibblesGameScoreDelta);
#line 194 "../src/nibbles-game.vala"
	switch (property_id) {
#line 194 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SCORE_DELTA_WORM_PROPERTY:
#line 194 "../src/nibbles-game.vala"
		nibbles_game_score_delta_set_worm (self, g_value_get_object (value));
#line 194 "../src/nibbles-game.vala"
		break;
#line 194 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SCORE_DELTA_SCORE_DELTA_PROPERTY:
#line 194 "../src/nibbles-game.vala"
		nibbles_game_score_delta_set_score_delta (self, g_value_get_int (value));
#line 194 "../src/nibbles-game.vala"
		break;
#line 8180 "nibbles-game.c"
		default:
#line 194 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 194 "../src/nibbles-game.vala"
		break;
#line 8186 "nibbles-game.c"
	}
}

static void
_nibbles_game___lambda9_ (NibblesGame* self,
                          Bonus* bonus)
{
#line 250 "../src/nibbles-game.vala"
	g_return_if_fail (bonus != NULL);
#line 250 "../src/nibbles-game.vala"
	g_signal_emit (self, nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL], 0, bonus);
#line 8198 "nibbles-game.c"
}

static void
__nibbles_game___lambda9__nibbles_game_bonuses_bonus_removed (NibblesGameBonuses* _sender,
                                                              Bonus* bonus,
                                                              gpointer self)
{
#line 250 "../src/nibbles-game.vala"
	_nibbles_game___lambda9_ ((NibblesGame*) self, bonus);
#line 8208 "nibbles-game.c"
}

static GObject *
nibbles_game_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NibblesGame * self;
	guint8 _tmp0_;
	guint8 _tmp1_;
	gint* _tmp2_;
	NibblesGameBonuses* _tmp3_;
#line 247 "../src/nibbles-game.vala"
	parent_class = G_OBJECT_CLASS (nibbles_game_parent_class);
#line 247 "../src/nibbles-game.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 247 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 249 "../src/nibbles-game.vala"
	_tmp0_ = self->priv->_width;
#line 249 "../src/nibbles-game.vala"
	_tmp1_ = self->priv->_height;
#line 249 "../src/nibbles-game.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 249 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 249 "../src/nibbles-game.vala"
	self->board = _tmp2_;
#line 249 "../src/nibbles-game.vala"
	self->board_length1 = _tmp0_;
#line 249 "../src/nibbles-game.vala"
	self->board_length2 = _tmp1_;
#line 250 "../src/nibbles-game.vala"
	_tmp3_ = self->priv->bonuses;
#line 250 "../src/nibbles-game.vala"
	g_signal_connect_object (_tmp3_, "bonus-removed", (GCallback) __nibbles_game___lambda9__nibbles_game_bonuses_bonus_removed, self, 0);
#line 247 "../src/nibbles-game.vala"
	return obj;
#line 8249 "nibbles-game.c"
}

static void
nibbles_game_class_init (NibblesGameClass * klass,
                         gpointer klass_data)
{
#line 36 "../src/nibbles-game.vala"
	nibbles_game_parent_class = g_type_class_peek_parent (klass);
#line 36 "../src/nibbles-game.vala"
	g_type_class_adjust_private_offset (klass, &NibblesGame_private_offset);
#line 36 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_nibbles_game_get_property;
#line 36 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_nibbles_game_set_property;
#line 36 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->constructor = nibbles_game_constructor;
#line 36 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (klass)->finalize = nibbles_game_finalize;
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SKIP_SCORE_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SKIP_SCORE_PROPERTY] = g_param_spec_boolean ("skip-score", "skip-score", "skip-score", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_CURRENT_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_CURRENT_LEVEL_PROPERTY] = g_param_spec_int ("current-level", "current-level", "current-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY, nibbles_game_properties[NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY] = g_param_spec_boolean ("three-dimensional-view", "three-dimensional-view", "three-dimensional-view", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_SPEED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_SPEED_PROPERTY] = g_param_spec_int ("speed", "speed", "speed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_GAMEDELAY_PROPERTY, nibbles_game_properties[NIBBLES_GAME_GAMEDELAY_PROPERTY] = g_param_spec_int ("gamedelay", "gamedelay", "gamedelay", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_PROGRESS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_PROGRESS_PROPERTY] = g_param_spec_int ("progress", "progress", "progress", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_START_LEVEL_PROPERTY, nibbles_game_properties[NIBBLES_GAME_START_LEVEL_PROPERTY] = g_param_spec_int ("start-level", "start-level", "start-level", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WIDTH_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WIDTH_PROPERTY] = g_param_spec_uchar ("width", "width", "width", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_HEIGHT_PROPERTY, nibbles_game_properties[NIBBLES_GAME_HEIGHT_PROPERTY] = g_param_spec_uchar ("height", "height", "height", 0, G_MAXUINT8, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMHUMANS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMHUMANS_PROPERTY] = g_param_spec_int ("numhumans", "numhumans", "numhumans", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMAI_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMAI_PROPERTY] = g_param_spec_int ("numai", "numai", "numai", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_NUMWORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_NUMWORMS_PROPERTY] = g_param_spec_int ("numworms", "numworms", "numworms", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORMS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORMS_PROPERTY] = g_param_spec_object ("worms", "worms", "worms", GEE_TYPE_LINKED_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_WORM_PROPS_PROPERTY, nibbles_game_properties[NIBBLES_GAME_WORM_PROPS_PROPERTY] = g_param_spec_object ("worm-props", "worm-props", "worm-props", GEE_TYPE_HASH_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_IS_RUNNING_PROPERTY, nibbles_game_properties[NIBBLES_GAME_IS_RUNNING_PROPERTY] = g_param_spec_boolean ("is-running", "is-running", "is-running", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_PAUSED_PROPERTY, nibbles_game_properties[NIBBLES_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 36 "../src/nibbles-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NIBBLES_GAME_FAKES_PROPERTY, nibbles_game_properties[NIBBLES_GAME_FAKES_PROPERTY] = g_param_spec_boolean ("fakes", "fakes", "fakes", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_APPLIED_SIGNAL] = g_signal_new ("bonus-applied", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_INT, G_TYPE_NONE, 3, TYPE_BONUS, TYPE_WORM, G_TYPE_INT);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LOG_SCORE_SIGNAL] = g_signal_new ("log-score", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ANIMATE_END_GAME_SIGNAL] = g_signal_new ("animate-end-game", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_LEVEL_COMPLETED_SIGNAL] = g_signal_new ("level-completed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_WARP_ADDED_SIGNAL] = g_signal_new ("warp-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__UCHAR_UCHAR, G_TYPE_NONE, 2, G_TYPE_UCHAR, G_TYPE_UCHAR);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_ADDED_SIGNAL] = g_signal_new ("bonus-added", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_BONUS_REMOVED_SIGNAL] = g_signal_new ("bonus-removed", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_BONUS);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_GET_PKGDATADIR_SIGNAL] = g_signal_new ("get-pkgdatadir", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_STRING__VOID, G_TYPE_STRING, 0);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_ADD_KEYPRESS_HANDLER_SIGNAL] = g_signal_new ("add-keypress-handler", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__POINTER_POINTER, G_TYPE_BOOLEAN, 2, G_TYPE_POINTER, G_TYPE_POINTER);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_REDRAW_SIGNAL] = g_signal_new ("redraw", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
#line 36 "../src/nibbles-game.vala"
	nibbles_game_signals[NIBBLES_GAME_PLAY_SOUND_SIGNAL] = g_signal_new ("play-sound", TYPE_NIBBLES_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
#line 8324 "nibbles-game.c"
}

static void
nibbles_game_instance_init (NibblesGame * self,
                            gpointer klass)
{
	gint* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeHashMap* _tmp2_;
	NibblesGameBonuses* _tmp3_;
	WarpManager* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeConcurrentSet* _tmp6_;
#line 36 "../src/nibbles-game.vala"
	self->priv = nibbles_game_get_instance_private (self);
#line 177 "../src/nibbles-game.vala"
	_tmp0_ = g_new0 (gint, 0);
#line 177 "../src/nibbles-game.vala"
	self->levels_uncompleated = _tmp0_;
#line 177 "../src/nibbles-game.vala"
	self->levels_uncompleated_length1 = 0;
#line 177 "../src/nibbles-game.vala"
	self->_levels_uncompleated_size_ = self->levels_uncompleated_length1;
#line 190 "../src/nibbles-game.vala"
	_tmp1_ = gee_linked_list_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 190 "../src/nibbles-game.vala"
	self->priv->_worms = _tmp1_;
#line 191 "../src/nibbles-game.vala"
	_tmp2_ = gee_hash_map_new (TYPE_WORM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, TYPE_WORM_PROPERTIES, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 191 "../src/nibbles-game.vala"
	self->priv->_worm_props = _tmp2_;
#line 192 "../src/nibbles-game.vala"
	_tmp3_ = nibbles_game_bonuses_new ();
#line 192 "../src/nibbles-game.vala"
	self->priv->bonuses = _tmp3_;
#line 193 "../src/nibbles-game.vala"
	_tmp4_ = warp_manager_new ();
#line 193 "../src/nibbles-game.vala"
	self->priv->warp_manager = _tmp4_;
#line 203 "../src/nibbles-game.vala"
	_tmp5_ = gee_hash_map_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_LINKED_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 203 "../src/nibbles-game.vala"
	self->priv->_score_deltas = _tmp5_;
#line 204 "../src/nibbles-game.vala"
	_tmp6_ = gee_concurrent_set_new (TYPE_BONUS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 204 "../src/nibbles-game.vala"
	self->priv->bouns_eaten = (GeeSet*) _tmp6_;
#line 207 "../src/nibbles-game.vala"
	self->priv->_is_running = FALSE;
#line 208 "../src/nibbles-game.vala"
	self->priv->_is_paused = FALSE;
#line 222 "../src/nibbles-game.vala"
	self->priv->main_id = (guint) 0;
#line 238 "../src/nibbles-game.vala"
	self->added_keypress_handler = FALSE;
#line 453 "../src/nibbles-game.vala"
	self->priv->bonus_cycle = (guint8) 0;
#line 8382 "nibbles-game.c"
}

static void
nibbles_game_finalize (GObject * obj)
{
	NibblesGame * self;
#line 36 "../src/nibbles-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NIBBLES_GAME, NibblesGame);
#line 177 "../src/nibbles-game.vala"
	self->levels_uncompleated = (g_free (self->levels_uncompleated), NULL);
#line 180 "../src/nibbles-game.vala"
	self->board = (g_free (self->board), NULL);
#line 190 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worms);
#line 191 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_worm_props);
#line 192 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->bonuses);
#line 193 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->warp_manager);
#line 203 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->_score_deltas);
#line 204 "../src/nibbles-game.vala"
	_g_object_unref0 (self->priv->bouns_eaten);
#line 36 "../src/nibbles-game.vala"
	G_OBJECT_CLASS (nibbles_game_parent_class)->finalize (obj);
#line 8409 "nibbles-game.c"
}

 G_GNUC_NO_INLINE static GType
nibbles_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NibblesGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) nibbles_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NibblesGame), 0, (GInstanceInitFunc) nibbles_game_instance_init, NULL };
	GType nibbles_game_type_id;
	nibbles_game_type_id = g_type_register_static (G_TYPE_OBJECT, "NibblesGame", &g_define_type_info, 0);
	NibblesGame_private_offset = g_type_add_instance_private (nibbles_game_type_id, sizeof (NibblesGamePrivate));
	return nibbles_game_type_id;
}

GType
nibbles_game_get_type (void)
{
	static gsize nibbles_game_type_id__once = 0;
	if (g_once_init_enter (&nibbles_game_type_id__once)) {
		GType nibbles_game_type_id;
		nibbles_game_type_id = nibbles_game_get_type_once ();
		g_once_init_leave (&nibbles_game_type_id__once, nibbles_game_type_id);
	}
	return nibbles_game_type_id__once;
}

static void
_vala_nibbles_game_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 36 "../src/nibbles-game.vala"
	switch (property_id) {
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_skip_score (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_current_level (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_three_dimensional_view (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_speed (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_gamedelay (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PROGRESS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_progress (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_START_LEVEL_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_start_level (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_width (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_uchar (value, nibbles_game_get_height (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numhumans (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numai (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_int (value, nibbles_game_get_numworms (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORMS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worms (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WORM_PROPS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_object (value, nibbles_game_get_worm_props (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_is_running (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PAUSED_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_paused (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		g_value_set_boolean (value, nibbles_game_get_fakes (self));
#line 36 "../src/nibbles-game.vala"
		break;
#line 8546 "nibbles-game.c"
		default:
#line 36 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/nibbles-game.vala"
		break;
#line 8552 "nibbles-game.c"
	}
}

static void
_vala_nibbles_game_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	NibblesGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NIBBLES_GAME, NibblesGame);
#line 36 "../src/nibbles-game.vala"
	switch (property_id) {
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SKIP_SCORE_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_skip_score (self, g_value_get_boolean (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_CURRENT_LEVEL_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_current_level (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_THREE_DIMENSIONAL_VIEW_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_three_dimensional_view (self, g_value_get_boolean (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_SPEED_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_speed (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_GAMEDELAY_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_gamedelay (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PROGRESS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_progress (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_START_LEVEL_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_start_level (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_WIDTH_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_width (self, g_value_get_uchar (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_HEIGHT_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_height (self, g_value_get_uchar (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMHUMANS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_numhumans (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMAI_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_numai (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_NUMWORMS_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_numworms (self, g_value_get_int (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_IS_RUNNING_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_is_running (self, g_value_get_boolean (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_PAUSED_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_paused (self, g_value_get_boolean (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 36 "../src/nibbles-game.vala"
		case NIBBLES_GAME_FAKES_PROPERTY:
#line 36 "../src/nibbles-game.vala"
		nibbles_game_set_fakes (self, g_value_get_boolean (value));
#line 36 "../src/nibbles-game.vala"
		break;
#line 8656 "nibbles-game.c"
		default:
#line 36 "../src/nibbles-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 36 "../src/nibbles-game.vala"
		break;
#line 8662 "nibbles-game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static void
_vala_array_move (gpointer array,
                  gsize element_size,
                  gssize src,
                  gssize dest,
                  gssize length)
{
	memmove (((char*) array) + (dest * element_size), ((char*) array) + (src * element_size), length * element_size);
	if ((src < dest) && ((src + length) > dest)) {
		memset (((char*) array) + (src * element_size), 0, (dest - src) * element_size);
	} else if ((src > dest) && (src < (dest + length))) {
		memset (((char*) array) + ((dest + length) * element_size), 0, (src - dest) * element_size);
	} else if (src != dest) {
		memset (((char*) array) + (src * element_size), 0, length * element_size);
	}
}

